
#include <complex>

using namespace std;

typedef complex<double> complexd;

complexd sine(complexd z)
{
	double x,y;
	x=real(z); y=imag(z); 
	return complexd(sin(x)*cosh(y), cos(x)*sinh(y));
}


extern "C"
{

__declspec(dllexport) int mandelf(
	double zr, double zi, double cr, double ci, int maxiter)
{
	complexd z(zr,zi), c(cr,ci);
	int i;
	for (i=1;  i< maxiter;  i++)
	{	z=z*z+c;
		if (norm(z) > 4)
			break;
	}
	return i;
}

__declspec(dllexport) int mandelc(
	complexd z, complexd c, int maxiter)
{
	int i;
	for (i=1;  i< maxiter;  i++)
	{	z=z*z+c;
		if (norm(z) > 4)
			break;
	}
	return i;
}

__declspec(dllexport) int iterate_sinec(
	complexd z, complexd c, int maxiter)
{
	int i;
	for (i=1;  i< maxiter;  i++)
	{	z=sine(z)+z*z+c;
		if (abs(real(z)) > 10 
		||  abs(imag(z)) > 10)
			return i;
	}
	return i;
}

__declspec(dllexport) void mandelfa(
	double *zr, double *zi, double *cr, double *ci, int length, int maxiter, int *result)
{
	int *n=result;
	int l;
	for (l=length;  l;  l--)
	{
		complexd z(*zr++,*zi++), c(*cr++,*ci++);
		int i;
		for (i=1;  i< maxiter;  i++)
		{	z=z*z+c;
			if (norm(z) > 4)
				break;
		}
		*n++=i;
	}
}

}