//___________________________________________________________________
//
//									Class AVIGen
//___________________________________________________________________

class AVIGen  
{
public:
	wxString filename;	// name of output file
	wxString aviError;	// last error string
	int rate;	// Frame rate 
	int frame;	// frame counter
	BITMAPINFOHEADER bih;	// structure contains information for a single stream

	AVIGen();
	AVIGen(charP filename_, wxWindow *window, int rate_);
	AVIGen(charP filename_, BITMAPINFOHEADER *lpbih, int rate_);

	~AVIGen();

	int InitEngine(bool newFile=true, int frame_=0);

	// The data pointed by bmBits has to be compatible 
	// with the bitmap description of the movie.
	int AddFrame(charP pixels);

	void ReleaseEngine();

	void SetBitmapHeader(wxWindow *window);
	void SetBitmapHeader(BITMAPINFOHEADER *lpbih);

	BITMAPINFOHEADER *GetBitmapHeader()							
	{	return &bih;
	}

	void SetFileName(wxString filename_)
	{	filename=filename_; 
		MakeExtAvi();
	}

	// Sets FrameRate (should equal or greater than one)
	void SetRate(int rate_)										
	{	rate=rate_;
	}

	wxString GetLastErrorMessage() const								
	{	return aviError;
	}

	void MakeExtAvi();

#ifdef WIN32
	PAVIFILE pAVIFile;		// file interface pointer
	PAVISTREAM pStream;	// Address of the stream interface
	PAVISTREAM pStreamCompressed;	// Address of the compressed video stream
#else
	avm::IWriteFile *avifile;
	avm::IVideoWriteStream* vidstr;
#endif
};
