#ifndef Node_included
	#include "Node.h"
#endif

#ifndef BigFloat_included

class BigFloat: public Node 
{
	public: 
		MAPM float_;

		static MAPM deg2rad;
		static const BigFloat aBigFloat;

		operator_new;
		BigFloat():         Node(BIGFLOAT), float_(0) {}
		BigFloat(int i): Node(BIGFLOAT), float_(i) {}
		BigFloat(int16 i): Node(BIGFLOAT), float_(int(i)) {}
		BigFloat(int8 i): Node(BIGFLOAT), float_(int(i)) {}
		BigFloat(uint8 i): Node(BIGFLOAT), float_(int(i)) {}
		BigFloat(double f): Node(BIGFLOAT), float_(f) {}
		BigFloat(MAPM f): Node(BIGFLOAT), float_(f) {}
		BigFloat(StringP s);
		virtual ~BigFloat() {}
		void free();

		DataInputStream &read(DataInputStream &istr);
		wxDataOutputStream &write(wxDataOutputStream &ostr);

		NodeP copy(PtrToInt_ &ptrToInt);

		StringP   string();
		void print(FILEP strm, int &width, int depth, int noBrackets=0, int noSpacers=0);
		void printBin(FILEP strm);
		   int   numberP() {return 1;}
		double getnumber();
		 NodeP    number() {return this;}

		OPERATORS_DECL
		NodeP compare(NodeP nd);
		int _sizeof();
		StringP _typeof();
		double _min(double d);
		double _max(double d);
		NodeP Norm();
		NodeP maxNorm();
		NodeP item(NodeP index, NodeP result);
		NodeP memberP(NodeP subobj, bool notp=false, bool substr=false);
		NodeP reverse();
//		NodeP readbin(FileP file);
		NodeP upper();
		NodeP lower();
		PairP list();

		static void init();
		static MAPM Remainder(MAPM x, MAPM d);
		static MAPM mod(MAPM x, MAPM d);
};

#define BigFloat_included
#endif
