#ifndef Node_included
	#include "Node.h"
#endif

//#ifndef Bitmap_included
class TextInputStream;
class TextOutputStream;

struct BitmapStruct
{
	unsigned int width, height, winx,winy;
	Color *pixels;
};
typedef BitmapStruct *BitmapStructP;

class Bitmap: public Node
{
	public:
		unsigned int width, height, winx,winy;
		Color *pixels;

		union {ObjectType flag; ObjectBits bit; int tint;};

	public:
		static const Bitmap aBitmap;

		operator_new;
		Bitmap(): Node(BITMAP_), 
			width(0),height(0), winx(0),winy(0), pixels(0) {}
		Bitmap(int width_, int height_, 
			int winx_, int winy_, Color *pixels_);
		Bitmap(wxBitmap &wbmp);

		void free();

		TextInputStream &read(TextInputStream &istr);
		DataInputStream &read(DataInputStream &istr);
		TextOutputStream &write(TextOutputStream &ostr);
		wxDataOutputStream &write(wxDataOutputStream &ostr);

		StringP string();
		void print(FILEP strm, int &width, int depth, int noBrackets=0, int noSpacers=0);
		NodeP contentsTree(	wxArrayString &namearr, 
									wxArrayString &valarr, 
									wxArrayPtrVoid &objarr, 
									ObjectType want, 
									ObjectType dont, 
									ObjectType must, 
									int &count, int level);
		bool expanded() {return bit.table_expand;}
		bool expandable() {return true;}
		void setExpanded(bool state) {bit.table_expand=state;}

		OPERATORS_DECL
		StringP _typeof();
		ArrayP array(int origin=1);
		IntArrayP intarray(int origin=1);


		void makeTransparent(Color c);
		void setPixel(int x, int y, Color c);
		Color Pixel(int x, int y);

		void fill(int x, int y, Color fillc, Color rim);
		void fillRecursiv(int x, int y, Color fillc, Color rim);

		void fillSurface(int x, int y, Color fillc, Color rim);
		void fillSurfaceRecursiv(int x, int y, Color fillc, Color rim);

		void bitPaste(BitmapP bm, int x, int y);
		void bitPaste(BitmapP bm, int x, int y, double sx, double sy);
};

#define Bitmap_included
//#endif
