//___________________________________________________________________
//
//                         ChoiceBox Header
//___________________________________________________________________

#ifndef WINDOWNODE
	#include "Window.h"
#endif

extern Function 
	lChoiceBox, lChoiceBoxDestroy,
	lChoiceBoxSelection, lChoiceBoxSetSelection,
	lChoiceBoxSetChoices, 
	lChoiceBoxAppend, 
	lChoiceBoxSetItem, lChoiceBoxRemoveItem, 
	lChoiceBoxCount,
	lChoiceBoxSetBackgroundColor, lChoiceBoxSetColor,
	lChoiceBoxSetFontSize, lChoiceBoxSetFontName,
	lChoiceBoxSetFontStyle, lChoiceBoxSetFontWeight,
	lChoiceBoxOnChar, lChoiceBoxOnKeyDown, lChoiceBoxOnKeyUp,
	lChoiceBoxOnSelect,
	lChoiceBoxEnable;

class wxStaticText;
class MyChoiceBox;

class ChoiceBox: public wxControl
{
	public:
		wxStaticText *label;
		MyChoiceBox *choiceBox;
		wxSize bestSize;
		wxArrayString choices;
		enum Data
		{	WINDOW_DATA,
			onSelect, uonSelect, tonSelect, 
			dataCount
		};
		NodeP data[dataCount];

		static int vmt;

		virtual NodePP d(int i) {return &data[i];}

		ChoiceBox(wxWindow *parent);
		ChoiceBox(ChoiceBoxNodeP choiceBoxNode_, int style);
		ChoiceBox(ChoiceBoxNodeP choiceBoxNode_,
			wxWindow* parent, wxWindowID id, 
			const wxArrayString& choices_, 
			PairP onSelect_=PairP(0),
			const wxPoint& pos=wxDefaultPosition, 
			const wxSize& size=wxDefaultSize, 
			long style = 0, 
			const wxValidator& validator = wxDefaultValidator, 
			const wxString& name = _("ChoiceBox"));

		bool create(wxWindow* parent, wxWindowID id, 
			const wxArrayString& choices_, 
			const wxPoint& pos, 
			const wxSize& size, 
			long style, 
			const wxValidator& validator, 
			const wxString& name);

		~ChoiceBox();

		virtual void DoSetSize(int x, int y, int width, int height,
						   int sizeFlags = wxSIZE_AUTO);

		virtual wxSize DoGetBestSize();

		virtual void Set(wxArrayString &choices);

		void 
			OnClose	(wxCloseEvent &event),
			OnSelect	(wxCommandEvent &event),
			OnChar	(wxKeyEvent &event),
			OnKeyDown(wxKeyEvent &event),
			OnKeyUp	(wxKeyEvent &event);

		wxString wxstring();
		DataInputStream &read(DataInputStream &istr);
		wxDataOutputStream &write(wxDataOutputStream &ostr);

		virtual bool SetBackgroundColour(const wxColour& colour);
		virtual bool SetForegroundColour(const wxColour& colour);
		virtual bool SetFont(const wxFont& font);

		DECLARE_EVENT_TABLE()
};
typedef ChoiceBox *ChoiceBoxP;

class ChoiceBoxNode: public WindowNode
{
	public:
		ChoiceBoxP &choiceBox;
		static const ChoiceBoxNode aChoiceBoxNode;

		operator_new;
		PairP onSelect();
		PairP onChar();
		PairP onKeyDown();
		PairP onKeyUp();
		void setonSelect	(NodeP function);
		void setonChar	(NodeP function);
		void setonKeyDown(NodeP function);
		void setonKeyUp	(NodeP function);

		ChoiceBoxNode();
		ChoiceBoxNode(WindowNodeP parent_);

		void free();

		void inc_gc();
		int youngs();
		int youngsPtr(PtrToInt_ &ptrToInt);
		void check_oldyoungs();
		
		DataInputStream &read(DataInputStream &istr);
		wxDataOutputStream &write(wxDataOutputStream &ostr);
		void setPtrs(IntToPtr_ &intToPtr);
		void recreate();

		StringP string();
		wxString wxstring();
		void print(FILEP strm, int &width, int depth, int noBrackets=0, int noSpacers=0);
		StringP _typeof();
};
