
#include "stdafx.h"
#ifdef WIN32
	#include <crtdbg.h>
#endif

#include "Main.h"
#include "File.h"
#include "UInt8.h"
#include "Color.h"

#ifdef _DEBUG
	#undef THIS_FILE
	static char THIS_FILE[]= __FILE__;
	#define new new(_NORMAL_BLOCK, THIS_FILE, __LINE__)
	#define  calloc(n, m)	 _calloc_dbg((n), (m),   _NORMAL_BLOCK, __FILE__, __LINE__)
#endif

Color::Color(double r_, double g_, double b_) 
{	r=UInt8::clip(255*r_);
	g=UInt8::clip(255*g_);
	b=UInt8::clip(255*b_);
	a=255;
}

Color::Color(double r_, double g_, double b_, double a_) 
{	r=UInt8::clip(255*r_);
	g=UInt8::clip(255*g_);
	b=UInt8::clip(255*b_);
	a=UInt8::clip(255*a_);
}

bool Color::isLike(Color c, float tolerance)
{
	float dev=float(
		abs(int(int(r)-c.r))+
		abs(int(int(g)-c.g))+
		abs(int(int(b)-c.b)))/255/3;//+(a-c.a)/255
	if (dev < tolerance)
		return true;
	return false;
}
//___________________________________________________________________

ColorFiFo::~ColorFiFo() {if (allocated) GC_::free(base); base=0;}

ColorFiFo &ColorFiFo::operator<<(const Color val) 
{
	if (overflow()) return *this;
	*in=val;
	if (in==max) in=base; else in++;
	if (in==out) expand();
	return *this;
}

ColorFiFo &ColorFiFo::operator>>(Color &val) 
{
	val = *out;
	if (out==max) out=base; else out++;
	return *this;
}

ColorFiFo &ColorFiFo::operator=(ColorFiFo &b)
{
	ColorP bout=b.out;
	in=out=base;
	Color p;
	while (b)
	{	b >> p;
		*this << p;
	}
	b.out=bout;
	return *this;
}

void ColorFiFo::expand()	// transfer is untested!!!!
{
	ColorP newbase = (Color*) GC_::calloc(1, sizeof(Color)*(size+expand_size));

	if (newbase==ColorP(0))	// no room to increase FiFo
	{	c_out << _("; Warning: Not enough memory to expand ColorFiFo!") << endL;
		_overflow=true;
	}
	else
	{	ColorP i=newbase;

		if (out)			// transfer old FiFo to new FiFo
		{	*this >> *i++;
			while (in!=out) 
				*this >> *i++;
		}				
		if (allocated) 
			GC_::free(base);

		allocated=true;
		size += expand_size;
		base=newbase;   max= &base[size-1];   in=i;   out= base;
	}
}
