#include "stdafx.h"

#ifdef WIN32
	#include <crtdbg.h>
#endif

#include <wx/thread.h>

#include "Main.h"
#include "Thread.h"
#include "Error.h"
#include "Init.h"
#include "File.h"
#include "IntToPtr_.h"
#include "PtrToInt_.h"
#include "String.h"
#include "Object.h"
#include "LogoObject.h"
#include "Pair.h"
#include "Int.h"
#include "Int16.h"
#include "Int8.h"
#include "Float.h"
#include "Array.h"
#include "IntArray.h"
#include "Int16Array.h"
#include "FloatArray.h"
#include "Bitmap.h"
#include "Color.h"

#include <fftw3.h>

#ifdef _DEBUG
	#undef THIS_FILE
	static char THIS_FILE[]= __FILE__;
	#define new new(_NORMAL_BLOCK, THIS_FILE, __LINE__)
	#define  malloc(m)       _malloc_dbg((m),        _NORMAL_BLOCK, __FILE__, __LINE__)
	#define  calloc(n, m)	 _calloc_dbg((n), (m),   _NORMAL_BLOCK, __FILE__, __LINE__)
	#define realloc(m, len) _realloc_dbg((m), (len), _NORMAL_BLOCK, __FILE__, __LINE__)
#endif

NodeP lfft(PairPP arg)
{
	FloatArrayP in=arg[1]->a_floatarray(1);
	if throwing return Unbound;
	int n=in->length();
	FloatArrayP out=new FloatArray(n);
	if throwing return Unbound;
	unsigned flags=FFTW_ESTIMATE;
	fftw_plan plan=fftw_plan_r2r_1d(n, in->data(), out->data(), FFTW_R2HC, flags);
	fftw_execute(plan);
	fftw_destroy_plan(plan);
	return out;
}

NodeP lPowerSpectrum(PairPP arg)
{
	FloatArrayP in=arg[1]->a_floatarray(1);
	if throwing return Unbound;
	int n=in->length();
	FloatArrayP out=new FloatArray(n);
	if throwing return Unbound;
	doubleP o=out->data();
	unsigned flags=FFTW_ESTIMATE;
	fftw_plan plan=fftw_plan_r2r_1d(n, in->data(), o, FFTW_R2HC, flags);
	fftw_execute(plan);
	fftw_destroy_plan(plan);
	int nh=n/2;
	for (int i=0; i<=nh; i++)
	{	o[i]=sqrt(Float::sqr(o[i])+Float::sqr(o[i+nh]));
	}
	return out;
}
