/*
using namespace std;

class OFStream: public std::ofstream
{
	bool binary;

public:
	OFStream(const char* szName, 
		int nMode = std::ios::out):
	ofstream(szName, nMode)
	{	binary = (nMode & ios::binary) !=0;
	}

	OFStream &operator <<(char n)
	{	if (!binary)
			write(&n, sizeof(char));
		return *this;
	}

	OFStream &operator <<(bool n)
	{	if (binary)
			write((char*)(&n), sizeof(char));
		else
			ofstream::operator<<(n);
		return *this;
	}

	OFStream &operator <<(int16 n)
	{	if (binary)
			write((char*)(&n), sizeof(int16));
		else
			ofstream::operator<<(n);
		return *this;
	}

	OFStream &operator <<(int n)
	{	if (binary)
			write((char*)(&n), sizeof(int));
		else
			ofstream::operator<<(n);
		return *this;
	}

	OFStream &operator <<(unsigned int n)
	{	if (binary)
			write((char*)(&n), sizeof(unsigned int));
		else
			ofstream::operator<<(n);
		return *this;
	}

	OFStream &operator <<(double n)
	{	if (binary)
			write((char*)(&n), sizeof(double));
		else
			ofstream::operator<<(n);
		return *this;
	}

	OFStream &writeString(const char *n)
	{	int l=strlen(n);
		if (binary)
		{	write(n, l);
		}
		else
		{	write(n, l);
		}
		return *this;
	}

	OFStream &writePascalString(const char *n)
	{	int l=strlen(n);
		if (binary)
		{	write((char*)(&l), sizeof(int));
			write(n, l);
		}
		else
		{	ofstream::operator<<(l);
			write(" ", 1);
			write(n, l);
		}
		return *this;
	}

};

class IFStream: public ifstream
{
	bool binary;

public:
	IFStream(const char* szName, 
		int nMode = ios::in):
	ifstream(szName, nMode)
	{	binary = (nMode & ios::binary) !=0;
	}

	IFStream &operator >>(bool &n)
	{	if (binary)
		{	char c;
			read((char*)(&c), sizeof(char));
			n=bool(c!=0);
		}
		else
			ifstream::operator>>(n);
		return *this;
	}

	IFStream &operator >>(int16 &n)
	{	if (binary)
			read((char*)(&n), sizeof(int16));
		else
			ifstream::operator>>(n);
		return *this;
	}

	IFStream &operator >>(int &n)
	{	if (binary)
			read((char*)(&n), sizeof(int));
		else
		{	int i;
			ifstream::operator>>(i);
			n=i;
		}
		return *this;
	}

	IFStream &operator >>(unsigned int &n)
	{	if (binary)
			read((char*)(&n), sizeof(unsigned int));
		else
		{	unsigned int i;
			ifstream::operator>>(i);
			n=i;
		}
		return *this;
	}

	IFStream &operator >>(double &n)
	{	if (binary)
			read((char*)(&n), sizeof(double));
		else
		{	double i;
			ifstream::operator>>(i);
			n=i;
		}
		return *this;
	}

	IFStream &operator >>(char *n)
	{	int l;
		if (binary)
			read((char*)(&l), sizeof(int));
		else
		{	ifstream::operator>>(l);
			ignore(1);
		}
		n=new char[l+1];
		read((char*)(&n), l);
		n[l]='\0';
		return *this;
	}

	IFStream &operator >>(std::string &n)
	{	int l;
		if (binary)
			read((char*)(&l), sizeof(int));
		else
		{	ifstream::operator>>(l);
			ignore(1);
		}
		char *c=new char[l+1];
		read(c, l);
		c[l]='\0';
		n=c;
		delete c;
		return *this;
	}

};
*/
/*
class TOStream: public TextOutputStream
{
public:
	TOStream &operator<<(bool n)
	{	TextOutputStream::operator<<(char(n));
		return *this;
	}
};

class TIStream: public TextInputStream
{
public:
	TIStream &operator>>(bool &n)
	{	char c;
		TextInputStream::operator>>(c);
		n=bool(c);
		return *this;
	}
};

class DOStream: public wxDataOutputStream
{
public:
	DOStream &operator<<(bool n)
	{	wxDataOutputStream::operator<<(char(n));
		return *this;
	}
};

class DIStream: public DataInputStream
{
public:
	DIStream &operator>>(bool &n)
	{	char c;
		c=Read8();
		n=bool(c);
		return *this;
	}
};
*/
/*
typedef TextInputStream TIStream;
typedef TextOutputStream TOStream;
typedef DataInputStream DIStream;
typedef wxDataOutputStream DOStream;
*/
