//___________________________________________________________________
//
//                         Frame Header
//___________________________________________________________________

#ifndef WINDOWNODE
	#include "Window.h"
#endif

extern Function lFrame, lFrameDestroy, 
	lFrameOnChar, lFrameOnKeyDown, lFrameOnKeyUp, lFrameOnClose,
	lFrameSetFocus, lFrameEnable,
	lFrameMaximize, lFrameIconize, lFrameFullScreen,
	lFrameSetClientSize, 
	lFrameSetColor, lFrameSetBackgroundColor,
	lFrameSetFontSize, lFrameSetFontName,
	lFrameSetFontStyle, lFrameSetFontWeight,
	lFrameSetShape, lFrameSetSizer;

class Frame: public wxFrame
{
	public:
		ThreadP thread;
		wxString title;

		enum Data
		{	WINDOW_DATA,
			shape,
			dataCount
		};
		NodeP data[dataCount];

		static int vmt;

		virtual NodePP d(int i) {return &data[i];}

		Frame(wxWindow *parent);
		Frame(FrameNodeP frameNode_);
		Frame(FrameNodeP frameNode_,
			wxWindow* parent, wxWindowID id, 
			const wxString& title, 
			const wxPoint& pos = wxDefaultPosition, 
			const wxSize& size = wxDefaultSize, 
			long style = wxDEFAULT_FRAME_STYLE, 
			const wxString& name = _("Frame"));
		~Frame();

		void 
			OnClose(wxCloseEvent &event),
			OnChar(wxKeyEvent &event),
			OnKeyDown(wxKeyEvent &event),
			OnKeyUp(wxKeyEvent &event);

		bool setShape(PairP shape_);

		wxString wxstring();
		DataInputStream &read(DataInputStream &istr);
		wxDataOutputStream &write(wxDataOutputStream &ostr);

		DECLARE_EVENT_TABLE()
};
typedef Frame *FrameP;

class FrameNode: public WindowNode
{
	public:
		FrameP &frame;
		static const FrameNode aFrameNode;

		operator_new;
		PairP onChar();
		PairP onKeyDown();
		PairP onKeyUp();
		PairP onClose();
	
		ObjectP uonChar();
		ObjectP uonKeyDown();
		ObjectP uonKeyUp();
		ObjectP uonClose();

		LogoObjectP tonChar();
		LogoObjectP tonKeyDown();
		LogoObjectP tonKeyUp();
		LogoObjectP tonClose();

		PairP shape();
		BoxSizerNodeP boxSizer();
		void setonChar	(NodeP function);
		void setonKeyDown(NodeP function);
		void setonKeyUp	(NodeP function);
		void setonClose	(NodeP function);
		void setshape		(PairP shape_);
		void realsetshape(PairP shape_);
		void setSizer(BoxSizerNodeP boxSizer_);

		FrameNode();
		FrameNode(WindowNodeP parent_);

		void free();

		void inc_gc();
		int youngs();
		int youngsPtr(PtrToInt_ &ptrToInt);
		void check_oldyoungs();
		
		DataInputStream &read(DataInputStream &istr);
		wxDataOutputStream &write(wxDataOutputStream &ostr);
		void setPtrs(IntToPtr_ &intToPtr);
		void aftersetPtrs();
		void recreate();
		void aftersetPtrs3();

		StringP string();
		wxString wxstring();
		void print(FILEP strm, int &width, int depth, int noBrackets=0, int noSpacers=0);
		StringP _typeof();
};
