#include "stdafx.h"
#ifdef WIN32
	#include <crtdbg.h>
#endif

#include <wx/frame.h>
#include <wx/listctrl.h>
#include <wx/splitter.h>
#include <wx/html/helpctrl.h>
#include <wx/slider.h>
#include <wx/gauge.h>
#include <wx/button.h>
#include <wx/tglbtn.h>
#include <wx/radiobut.h>
#include <wx/dirdlg.h>
#include <wx/filedlg.h>
#include <wx/stattext.h>
#include <wx/textctrl.h>
#include <wx/listbox.h>
#include <wx/sizer.h>
#include <wx/treectrl.h>
#include <wx/dir.h>
#ifdef WIN32
	#include <wx/wxMidi.h>
#else
	#include <wxMidi.h>
#endif

#ifdef OPENGL
	#include <GL/glu.h>
	#include <gl2ps.h>
#endif

#include <math.h>

#include <m_apm.h>

#include "spinctld.h"
#include "spinctli.h"

#include "Main.h"

#include "String.h"
#include "File.h"
#include "Pair.h"
#include "Primitive.h"
#include "Object.h"
#include "Table.h"
#include "Line.h"
#include "Tree.h"
#include "Int.h"
#include "Float.h"
#include "Complex.h"
#include "BigFloat.h"
#include "UInt8.h"
#include "Array.h"
#include "FloatArray.h"
#include "Procedure.h"
#include "DL.h"
#include "Window.h"
#include "Slider.h"
#include "Gauge.h"
#include "IntControl.h"
#include "FloatControl.h"
#include "Button.h"
#include "ToggleButton.h"
#include "CheckBox.h"
#include "RadioButton.h"
#include "StaticText.h"
#include "TextControl.h"
#include "ListBox.h"
#include "ChoiceBox.h"
#include "ComboBox.h"
#include "ListControl.h"
#include "Frame.h"
#include "BoxSizer.h"
#include "StaticBoxSizer.h"

#include "Coms.h"
#include "Error.h"
#include "Files.h"
#include "Graphics.h"
#include "Init.h"
#include "Lists.h"
#include "Math_.h"
#include "Mem.h"
#include "Paren.h"
#include "Parse.h"
#include "Print.h"
#include "Term.h"
#include "Workspace.h"
#include "Stack.h"
#include "Molecules.h"
#include "ESim.h"
#include "NMR.h"

#include "Point.h"
#include "Color.h"
#include "Pen.h"
#include "Screen.h"
#include "Mouse.h"
#include "Font.h"
#include "Turtle.h"
#include "TurtleNode.h"

#include "EdDefsExt.h"
#include "EdPrefs.h"
#include "Event.h"
#include "io.h"
#include "Dialogs.h"
#include "Console.h"
#include "Graph.h"
#include "Vars.h"
#include "Calls.h"
#include "Splitter.h"
#include "MainFrame.h"
#include "Edit.h"
#include "LogoApp.h"
#include "Midi.h"
#include "Security.h"
#include "Thread.h"
#include "DebugState.h"
#include "Eval.h"
#include "Compile.h"
#include "FFTW.h"

#ifdef _DEBUG
	#undef THIS_FILE
	static char THIS_FILE[]= __FILE__;
	#define new new(_NORMAL_BLOCK, THIS_FILE, __LINE__)
#pragma optimize("",off)
#endif

#define wxCONSTANTS(x)											\
	x(SIMPLE_BORDER) x(DOUBLE_BORDER)						\
	x(SUNKEN_BORDER) x(RAISED_BORDER)						\
	x(STATIC_BORDER) x(NO_BORDER)								\
	x(TRANSPARENT_WINDOW) x(TAB_TRAVERSAL)					\
	x(WANTS_CHARS) x(NO_FULL_REPAINT_ON_RESIZE)			\
	x(VSCROLL) x(HSCROLL) x(ALWAYS_SHOW_SB)				\
	x(CLIP_CHILDREN) x(FULL_REPAINT_ON_RESIZE)			\
																		\
	x(WS_EX_VALIDATE_RECURSIVELY)								\
	x(WS_EX_BLOCK_EVENTS) x(WS_EX_TRANSIENT)				\
	x(WS_EX_PROCESS_IDLE) x(WS_EX_PROCESS_UI_UPDATES)	\
																		\
	x(DEFAULT_FRAME_STYLE)										\
	x(ICONIZE) x(CAPTION) x(MINIMIZE) x(MINIMIZE_BOX)	\
	x(MAXIMIZE) x(MAXIMIZE_BOX) x(CLOSE_BOX)				\
	x(STAY_ON_TOP) x(SYSTEM_MENU) x(RESIZE_BORDER)		\
	x(FRAME_TOOL_WINDOW) x(FRAME_NO_TASKBAR)				\
	x(FRAME_FLOAT_ON_PARENT)									\
	x(FRAME_EX_CONTEXTHELP)										\
	x(FRAME_SHAPED) x(FRAME_EX_METAL)						\
																		\
	x(DEFAULT_DIALOG_STYLE) x(THICK_FRAME)	x(NO_3D)		\
	x(DIALOG_NO_PARENT) x(DIALOG_EX_CONTEXTHELP)			\
	x(DIALOG_EX_METAL)											\
																		\
	x(CHANGE_DIR)													\
	x(DD_DEFAULT_STYLE)											\
	x(DD_NEW_DIR_BUTTON)											\
																		\
	x(OPEN) x(SAVE) x(OVERWRITE_PROMPT)						\
	x(FILE_MUST_EXIST) x(MULTIPLE)							\
																		\
	x(CENTRE) x(CENTRE_ON_SCREEN)								\
	x(YES) x(OK) x(NO) x(YES_NO)								\
	x(CANCEL) x(NO_DEFAULT)										\
	x(ICON_EXCLAMATION) x(ICON_HAND) x(ICON_WARNING)	\
	x(ICON_ERROR) x(ICON_QUESTION)							\
	x(ICON_INFORMATION) x(ICON_STOP)							\
	x(ICON_ASTERISK) x(ICON_MASK)								\
	x(FORWARD) x(BACKWARD) x(RESET) x(HELP) x(MORE)		\
	x(SETUP)															\
																		\
	x(SL_HORIZONTAL) x(SL_VERTICAL)							\
	x(SL_TICKS) x(SL_LABELS) x(SL_LEFT) x(SL_TOP)		\
	x(SL_RIGHT) x(SL_BOTTOM) x(SL_BOTH)						\
	x(SL_SELRANGE) x(SL_INVERSE)								\
																		\
	x(BU_LEFT) x(BU_TOP) x(BU_RIGHT) x(BU_BOTTOM)		\
	x(BU_EXACTFIT)													\
																		\
	x(ID_ADD) x(ID_APPLY) x(ID_BOLD) x(ID_CANCEL)		\
   x(ID_CLEAR) x(ID_CLOSE) x(ID_COPY) x(ID_CUT)			\
	x(ID_DELETE) x(ID_FIND) x(ID_REPLACE)					\
	x(ID_BACKWARD) x(ID_DOWN) x(ID_FORWARD) x(ID_UP)	\
	x(ID_HELP) x(ID_HOME) x(ID_INDENT) x(ID_INDEX)		\
	x(ID_ITALIC) x(ID_JUSTIFY_CENTER)						\
	x(ID_JUSTIFY_FILL) x(ID_JUSTIFY_LEFT)					\
	x(ID_JUSTIFY_RIGHT) x(ID_NEW) x(ID_NO) x(ID_OK)		\
	x(ID_OPEN) x(ID_PASTE) x(ID_PREFERENCES)				\
	x(ID_PRINT) x(ID_PREVIEW) x(ID_PROPERTIES)			\
	x(ID_EXIT) x(ID_REDO) x(ID_REFRESH) x(ID_REMOVE)	\
	x(ID_REVERT_TO_SAVED) x(ID_SAVE) x(ID_SAVEAS)		\
	x(ID_STOP) x(ID_UNDELETE) x(ID_UNDERLINE)				\
	x(ID_UNDO) x(ID_UNINDENT) x(ID_YES) x(ID_ZOOM_100)	\
	x(ID_ZOOM_FIT) x(ID_ZOOM_IN) x(ID_ZOOM_OUT)			\
																		\
	x(CHK_2STATE) x(CHK_3STATE)								\
	x(CHK_ALLOW_3RD_STATE_FOR_USER) x(ALIGN_RIGHT)		\
																		\
	x(RB_GROUP) x(RB_SINGLE) x(RB_USE_CHECKBOX)			\
																		\
	x(GA_HORIZONTAL) x(GA_VERTICAL) x(GA_SMOOTH)			\
																		\
	x(SP_ARROW_KEYS) x(SP_WRAP)								\
																		\
	x(TE_PROCESS_ENTER) x(TE_PROCESS_TAB)					\
	x(TE_MULTILINE) x(TE_PASSWORD) x(TE_READONLY)		\
	x(TE_RICH) x(TE_RICH2) x(TE_AUTO_URL)					\
	x(TE_NOHIDESEL) x(TE_LEFT) x(TE_CENTRE)				\
	x(TE_RIGHT) x(TE_DONTWRAP) x(TE_CHARWRAP)				\
	x(TE_WORDWRAP) x(TE_BESTWRAP) x(TE_CAPITALIZE)		\
																		\
	x(ALIGN_LEFT) x(ALIGN_CENTRE) x(ST_NO_AUTORESIZE)	\
	x(FONTSTYLE_NORMAL) x(FONTSTYLE_SLANT)					\
	x(FONTSTYLE_ITALIC)											\
	x(FONTWEIGHT_NORMAL) x(FONTWEIGHT_LIGHT)				\
	x(FONTWEIGHT_BOLD)											\
																		\
	x(TOP) x(BOTTOM) x(LEFT) x(RIGHT) x(ALL) x(EXPAND)	\
	x(SHAPED) x(FIXED_MINSIZE)									\
	x(ALIGN_CENTER) x(ALIGN_TOP) x(ALIGN_BOTTOM)			\
	x(ALIGN_CENTER_VERTICAL) x(ALIGN_CENTER_HORIZONTAL)\
																		\
	x(HORIZONTAL) x(VERTICAL) x(BOTH)						\
																		\
	x(LB_SINGLE) x(LB_MULTIPLE) x(LB_EXTENDED)			\
	x(LB_HSCROLL) x(LB_ALWAYS_SB) x(LB_NEEDED_SB)		\
	x(LB_SORT)														\
																		\
	x(CB_SIMPLE) x(CB_DROPDOWN) x(CB_READONLY)			\
	x(CB_SORT)	x(NOT_FOUND)									\
																		\
	x(LC_LIST) x(LC_REPORT) x(LC_VIRTUAL) x(LC_ICON)	\
	x(LC_SMALL_ICON) x(LC_ALIGN_TOP) x(LC_ALIGN_LEFT)	\
	x(LC_AUTOARRANGE) x(LC_EDIT_LABELS) x(LC_NO_HEADER)\
	x(LC_SINGLE_SEL)												\
	x(LC_SORT_ASCENDING) x(LC_SORT_DESCENDING)			\
	x(LC_HRULES) x(LC_VRULES)									\
	x(LIST_FORMAT_LEFT) x(LIST_FORMAT_RIGHT)				\
	x(LIST_FORMAT_CENTRE)										\
																		\
	x(DIR_FILES) x(DIR_DIRS) x(DIR_HIDDEN)					\
	x(DIR_DOTDOT) x(DIR_DEFAULT)								\
																		\
	x(FULLSCREEN_NOMENUBAR)	x(FULLSCREEN_NOTOOLBAR)		\
	x(FULLSCREEN_NOSTATUSBAR) x(FULLSCREEN_NOBORDER)	\
	x(FULLSCREEN_NOCAPTION) x(FULLSCREEN_ALL)				\
	x(BG_STYLE_SYSTEM)											\
	x(BG_STYLE_COLOUR) x(BG_STYLE_CUSTOM)					\

#define Keycodes(x) \
	x(BACK		) \
	x(TAB			) \
	x(RETURN		) \
	x(ESCAPE		) \
	x(SPACE		) \
	x(DELETE		) \
	x(START		) \
	x(LBUTTON	) \
	x(RBUTTON	) \
	x(CANCEL		) \
	x(MBUTTON	) \
	x(CLEAR		) \
	x(SHIFT		) \
	x(ALT			) \
	x(CONTROL	) \
	x(MENU		) \
	x(PAUSE		) \
	x(CAPITAL	) \
	x(PRIOR		) \
	x(NEXT		) \
	x(END			) \
	x(HOME		) \
	x(LEFT		) \
	x(UP			) \
	x(RIGHT		) \
	x(DOWN		) \
	x(SELECT		) \
	x(PRINT		) \
	x(EXECUTE	) \
	x(SNAPSHOT	) \
	x(INSERT		) \
	x(HELP		) \
	x(NUMPAD0	) \
	x(NUMPAD1	) \
	x(NUMPAD2	) \
	x(NUMPAD3	) \
	x(NUMPAD4	) \
	x(NUMPAD5	) \
	x(NUMPAD6	) \
	x(NUMPAD7	) \
	x(NUMPAD8	) \
	x(NUMPAD9	) \
	x(MULTIPLY	) \
	x(ADD			) \
	x(SEPARATOR	) \
	x(SUBTRACT	) \
	x(DECIMAL	) \
	x(DIVIDE		) \
	x(F1			) \
	x(F2			) \
	x(F3			) \
	x(F4			) \
	x(F5			) \
	x(F6			) \
	x(F7			) \
	x(F8			) \
	x(F9			) \
	x(F10			) \
	x(F11			) \
	x(F12			) \
	x(F13			) \
	x(F14			) \
	x(F15			) \
	x(F16			) \
	x(F17			) \
	x(F18			) \
	x(F19			) \
	x(F20			) \
	x(F21			) \
	x(F22			) \
	x(F23			) \
	x(F24			) \
	x(NUMLOCK	) \
	x(SCROLL		) \
	x(PAGEUP		) \
	x(PAGEDOWN	) \
					  \
	x(NUMPAD_SPACE		) \
	x(NUMPAD_TAB		) \
	x(NUMPAD_ENTER		) \
	x(NUMPAD_F1			) \
	x(NUMPAD_F2			) \
	x(NUMPAD_F3			) \
	x(NUMPAD_F4			) \
	x(NUMPAD_HOME		) \
	x(NUMPAD_LEFT		) \
	x(NUMPAD_UP			) \
	x(NUMPAD_RIGHT		) \
	x(NUMPAD_DOWN		) \
	x(NUMPAD_PRIOR		) \
	x(NUMPAD_PAGEUP	) \
	x(NUMPAD_NEXT		) \
	x(NUMPAD_PAGEDOWN	) \
	x(NUMPAD_END		) \
	x(NUMPAD_BEGIN		) \
	x(NUMPAD_INSERT	) \
	x(NUMPAD_DELETE	) \
	x(NUMPAD_EQUAL		) \
	x(NUMPAD_MULTIPLY	) \
	x(NUMPAD_ADD		) \
	x(NUMPAD_SEPARATOR) \
	x(NUMPAD_SUBTRACT	) \
	x(NUMPAD_DECIMAL	) \
	x(NUMPAD_DIVIDE	) \
							  \
	x(WINDOWS_LEFT		) \
	x(WINDOWS_RIGHT	) \
	x(WINDOWS_MENU		) \
	x(COMMAND			) \

#define GL_CONSTANTS(x) \
	x(GL_LINEAR) x(GL_EXP) x(GL_EXP2)			\
															\
	x(GL_CLEAR) x(GL_AND) x(GL_AND_REVERSE)	\
	x(GL_COPY) x(GL_AND_INVERTED) x(GL_NOOP)	\
	x(GL_XOR) x(GL_OR) x(GL_NOR) x(GL_EQUIV)	\
	x(GL_INVERT) x(GL_OR_REVERSE)					\
	x(GL_COPY_INVERTED) x(GL_OR_INVERTED)		\
	x(GL_NAND) x(GL_SET)

#define FILL_CONSTANTS(x)	\
	x(FILL_NORMAL) x(FILL_SURFACE)		\
	x(FILL_TOLERANT) x(FILL_SURFACE_TOLERANT) \
	x(FILL_SMALL) x(FILL_SMALL_SURFACE) \
	x(FILL_SMALL_TOLERANT) x(FILL_SMALL_SURFACE_TOLERANT) \

#define GL2PS_CONSTANTS(x)	\
	x(NO_SORT) x(SIMPLE_SORT) x(BSP_SORT)					\
	x(NONE) x(DRAW_BACKGROUND) x(SIMPLE_LINE_OFFSET)	\
	x(SILENT) x(BEST_ROOT) x(NO_TEXT) x(NO_PIXMAP)		\
	x(LANDSCAPE) x(NO_PS3_SHADING) x(NO_BLENDING)		\
	x(OCCLUSION_CULL) x(USE_CURRENT_VIEWPORT)				\
	x(TIGHT_BOUNDING_BOX) x(COMPRESS)						\

#define SECURITY_CONSTANTS(x)			\
	x(DLCALL) x(IODLL) x(SHELL)		\
	x(FILEWRITE) x(FILEREAD) x(DIRS)	\
	x(THREAD) x(KEYBOARD) x(GUI)		\
	x(ERASE) x(CONNECT) x(GLOBAL)		\
	x(BURIED) x(NAMESPACE) x(USER)	\
	x(LANGUAGE)

#define define(x)	_##x=0,
#define defineType(x) type_##x=0,
#define definewx(x)	_wx##x=0,
#define defineWXK_(x)	_WXK_##x=0,
#define defineGL2PS_(x)	_GL2PS_##x=0,
#define defineSECURITY_(x)	_SECURITY_##x=0,
#define defineMsg(x)	ErrorMessage_##x=0,

Export ObjectP 
	Permanent_Objects(define) 
	Permanent_Objects2(define)
	Node_Type_Strings(defineType, UNUSED)
	wxCONSTANTS(definewx) 
	Keycodes(defineWXK_)
#ifdef OPENGL
	GL2PS_CONSTANTS(defineGL2PS_)
	GL_CONSTANTS(define)
#endif
	FILL_CONSTANTS(define)
	SECURITY_CONSTANTS(defineSECURITY_)
	ErrorMessages(defineMsg)
	_=0;

LineP _Not_Enough_node=0;
PairP SecurityMemsizeConst=0;

#define Primitives_prefix__no_arg(x) \
	x( allFullScreen			) \
	x( allOpen 					) \
	x( beginBusyCursor		) \
	x( boldTextMode			) \
	x( break						) \
	x( buried 					) \
	x( bye						) \
	x( Calls						) \
	x( castShadows				) \
	x( CharUnderCursor		) \
	x( clean						) \
	x( clearScreen				) \
	x( clearShadows			) \
	x( clearText	 			) \
/*	x( callCode					)*/ \
	x( ColorLogicOp			) \
	x( ConsoleBitmap			) \
	x( ConsoleSetFocus		) \
	x( Contents					) \
	x( continueLoop			) \
	x( countThreads			) \
	x( Cursor 					) \
	x( deleteTextures			) \
	x(	disableAlphaTest		) \
	x(	disableBlend			) \
	x(	disableCylinderLines	) \
	x( disableDepthTest		) \
	x( disableDither			) \
	x( disableEdgeFlag		) \
	x( disableFog				) \
	x( disableLighting		) \
	x( disableLineSmooth		) \
	x( disablePointSmooth	) \
	x( disablePolySmooth		) \
	x( disableRoundLineEnds	) \
	x( disableShadows			) \
	x(	disableTextMouseEvents) \
	x( disableTexture			) \
	x( disableTextureFont	) \
	x( dispatchMessages		) \
	x( doubleBuffer			) \
	x( Dribbler					) \
	x(	enableAlphaTest		) \
	x(	enableBlend				) \
	x(	enableCylinderLines	) \
	x( enableDepthTest		) \
	x( enableDither			) \
	x( enableEdgeFlag			) \
	x( enableFog				) \
	x( enableLighting			) \
	x( enableLineSmooth		) \
	x( enablePointSmooth		) \
	x( enablePolySmooth		) \
	x( enableRoundLineEnds	) \
	x( enableShadows			) \
	x(	enableTextMouseEvents) \
	x( enableTexture			) \
	x( enableTextureFont		) \
	x( endBusyCursor			) \
	x( eraseAll					) \
	x( eraseNames				) \
	x( eraseProcedures		) \
	x( eraseTables				) \
	x( Error 					) \
	x( ErrorAction				) \
	x( Fence 					) \
	x( FloodColor	 			) \
	x( fullScreen	 			) \
	x( genSym		 			) \
	x( getArchitectureName	) \
	x( getColorDatabase		) \
	x( getEndiannessName		) \
	x( getEnvTable				) \
	x( getOperatingSystemFamilyName) \
	x( getOperatingSystemIdName) \
	x( getPortIdName			) \
	x( getProcessId			) \
	x( getThreadId				) \
	x( getUser					) \
	x( getWorkingDirectory	) \
	x( glReleaseContext		) \
	x( GraphCurrent			) \
	x( GraphEnter				) \
	x( GraphLeave				) \
	x( GraphicEnd				) \
	x( GraphicStart			) \
	x( Heading 					) \
	x( hideTurtle 				) \
	x( hideLogoConsolew		) \
	x( hideLogoMainFrame		) \
	x( Home 						) \
	x( IdentityMatrix			) \
	x( insertMode				) \
	x( italicTextMode			) \
	x( KeyboardValue			) \
	x( KeyboardRawCode		) \
	x( KeyboardRawFlags		) \
	x( LabelAlign				) \
	x( LabelFont				) \
	x( LabelWeight				) \
	x( ListControlColumn		) \
	x( ListControlRow			) \
	x( ListControlText		) \
	x( loadNoisily				) \
	x( LogoComspec				) \
	x( LogoConstants			) \
	x( LogoEditor				) \
	x( LogoFontsDir			) \
	x( LogoHelpDir				) \
	x( LogoInstance			) \
	x( LogoLanguage			) \
	x( LogoLibDir				) \
	x( LogoServiceDir			) \
	x( LogoTempDir				) \
	x( LogoVersion				) \
	x( MidiAllSoundsOff		) \
	x( MidiClose				) \
	x( MidiCountDevices		) \
	x( MidiOutStreamsFinished) \
	x( MidiOutStreamsStart	) \
	x( MidiOutStreamsStop	) \
	x( MaximumPosition		) \
	x( MinimumPosition		) \
	x( MIPS						) \
	x( ModelviewMatrix		) \
	x( MousePos					) \
	x( MouseButtons			) \
	x( MouseX					) \
	x( MouseY					) \
	x( MouseZ					) \
	x( MoveEventX				) \
	x( MoveEventY				) \
	x( Names 					) \
	x( Namespace				) \
	x( newTurtle				) \
	x( Nodes 					) \
	x( noDribble	 			) \
	x( noRefresh	 			) \
	x( notFullScreen			) \
	x( Orientation				) \
	x( orthographic			) \
	x( OSScreenSize			) \
	x( overwriteMode			) \
	x( pause 					) \
	x( PenColor					) \
	x( PenDown 					) \
	x( PenErase					) \
	x( PenMode 					) \
	x( PenPaint					) \
	x( PenPattern	 			) \
	x( PenReverse	 			) \
	x( PenSize 					) \
	x( PenUp 					) \
	x( perspective				) \
	x( pitch						) \
	x( Pixel						) \
	x( plainTextMode			) \
	x( PolyStart				) \
	x( PolyEnd					) \
	x( popMatrix				) \
	x( Pos						) \
	x( PosXYZ					) \
	x( Primitives				) \
	x( PrintDepthLimit		) \
	x( PrintWidthLimit		) \
	x( Procedures				) \
	x( pushMatrix				) \
	x( readChar					) \
	x( readCharExt				) \
	x( readComplexBin			) \
	x( Reader					) \
	x( ReaderPos	 			) \
	x( readIntBin				) \
	x( readInt16Bin			) \
	x( readInt8Bin				) \
	x( readFloatBin			) \
	x( readList					) \
	x( readListFlat			) \
	x( readListFlatLine		) \
	x( readListFlatRaw		) \
	x( readListFlatTags		) \
	x( readUInt8Bin			) \
	x( readRawLine				) \
	x( readWord					) \
	x( recreateGUI				) \
	x( redraw 					) \
	x( refresh 					) \
	x( repeatCount				) \
	x( rnd						) \
	x( roll						) \
	x( SaveSize					) \
	x( ScreenColor				) \
	x( ScreenRange				) \
	x( Scrunch 					) \
	x( setIdentityMatrix		) \
	x( setTurtleMatrix		) \
	x( SizeEventHeight		) \
	x( SizeEventWidth			) \
	x( ShadowColor				) \
	x( showLogoConsolew		) \
	x( showLogoMainFrame		) \
	x( showTurtle 				) \
	x( shrinkStacks			) \
	x( singleBuffer			) \
	x( SoundsStop				) \
	x( SoundsFinished			) \
	x( Startup					) \
	x( stepped 					) \
	x( SurfaceColumn			) \
	x( SurfaceEnd				) \
	x( SurfaceStart			) \
	x( Tables					) \
	x( TessContour				) \
	x( TessEnd					) \
	x( TessStart				) \
	x( TextMousePos			) \
	x( TextMouseX				) \
	x( TextMouseY				) \
	x( TextScreen 				) \
	x( this						) \
	x( Threads					) \
	x( Time						) \
	x( TimeFine 				) \
	x( TimeMilli 				) \
	x( TimerFreq 				) \
	x( Timeu 					) \
	x( TimeuRes 				) \
	x( TonesStop				) \
	x( TonesFinished			) \
	x( traced 					) \
	x( Turtle					) \
	x( TurtleMatrix			) \
	x( TurtleShapes			) \
	x( underlineTextMode		) \
	x( unPerspective			) \
	x( updateGraph				) \
	x( updateVars				) \
	x( updateCalls				) \
	x( VideoEnd					) \
	x( VideoFrame				) \
	x( WindowMode				) \
	x( WindowFindFocus		) \
	x( WindowGetCapture		) \
	x( WordUnderCursor		) \
	x( wrap						) \
	x( Writer					) \
	x( WriterPos				) \
	x( xCor						) \
	x( yCor						) \
	x( yield						) \
	x( zCor						) \

#define Primitives_prefix__no_arg_alias(x) \
	x( cS			, clearScreen				) \
	x( cT			, clearText					) \
	x(	disCL		, disableCylinderLines	) \
	x(	disDT		, disableDepthTest		) \
	x( disLS		, disableLineSmooth		) \
	x( disPS		, disablePolySmooth		) \
	x( disRLE	, disableRoundLineEnds	) \
	x( disTex	, disableTexture			) \
	x(	enCL		, enableCylinderLines	) \
	x(	enDT		, enableDepthTest			) \
	x( enLS		, enableLineSmooth		) \
	x( enPS		, enablePolySmooth		) \
	x( enRLE		, enableRoundLineEnds	) \
	x( enTex		, enableTexture			) \
	x( erAll		, eraseAll					) \
	x( erNs		, eraseNames				) \
	x( erPs		, eraseProcedures			) \
	x( fS			, fullScreen				) \
	x( hT			, hideTurtle				) \
	x( IDM		, IdentityMatrix			) \
	x( PC			, PenColor					) \
	x( PD			, PenDown					) \
	x( PE			, PenErase					) \
	x( PPt		, PenPaint					) \
	x( PU			, PenUp						) \
	x( PX			, PenReverse				) \
	x( rC			, readChar					) \
	x( rCE		, readCharExt				) \
	x( repCount	, repeatCount				) \
	x( rL			, readList					) \
	x( rW			, readWord					) \
	x( SC			, ScreenColor				) \
	x( setIDM	, setIdentityMatrix		) \
	x( setTM		, setTurtleMatrix			) \
	x( sT			, showTurtle				) \
	x( TM			, TurtleMatrix				) \
	x( TS			, TextScreen				) \
	

#define Primitives_prefix_one_arg(x) \
	x( _setPos				) \
	x( _setPosXYZ			) \
	x( abs					) \
	x(	ArcSin				) \
	x(	ArcCos				) \
	x(	Arity					) \
	x(	ArrayOrigin			) \
	x( ASCII					) \
	x( back					) \
	x( BackslashEncode	) \
	x( BigFloatSetPrecision) \
	x( BitMaxX				) \
	x( BitMaxY				) \
	x( BitNot				) \
	x( BitPaste				) \
	x( BitPasteFast		) \
	x( BoxSizer				) \
	x( bury					) \
	x( butFirst				) \
	x( butFirsts			) \
	x( butLast				) \
	x( ButtonDestroy 		) \
	x( ButtonGetLabel		) \
	x( Char					) \
	x( changeDir			) \
	x( CheckBoxDestroy	) \
	x( CheckBoxValue		) \
	x( ChoiceBoxCount		) \
	x( ChoiceBoxDestroy	) \
	x( Circle				) \
	x( close					) \
	x( ComboBoxCount		) \
	x( ComboBoxDestroy	) \
	x( combSort				) \
	x( combSortInPlace	) \
	x( compile				) \
	x( conjugate			) \
	x( Cos					) \
	x( count					) \
	x( deepCopy				) \
	x( Distance				) \
	x( DistanceXYZ			) \
	x( dribble				) \
	x( downPitch			) \
	x( DynamicLibrary		) \
	x( editFile				) \
	x( erase					) \
	x( eraseDirectory		) \
	x( eraseFile			) \
	x( exp					) \
	x( expandBackslashes	) \
	x( factorize			) \
	x( Faculty				) \
	x( Fiber					) \
	x( FileSize				) \
	x( FileTime				) \
	x( fillCircle			) \
	x( first					) \
	x( firsts				) \
	x( forward				) \
	x( FrameDestroy 		) \
	x( FrameSetFocus		) \
	x( fullText				) \
	x( GaugeDestroy 		) \
	x( GaugeValue	 		) \
	x( getEnv				) \
	x( getOwner				) \
	x( glMakeCurrent		) \
	x( GraphDestroy 		) \
	x( GraphSetCurrent	) \
	x( GraphSetFocus		) \
	x( ignore				) \
	x( imag					) \
	x( IntControlDestroy	) \
	x( invertMatrix		) \
	x( killThread			) \
	x( Label					) \
	x( last					) \
	x( left					) \
	x( leftRoll				) \
	x( LineColumn			) \
	x( LineTColumn			) \
	x( LineRow				) \
	x( link					) \
	x( ListBoxCount		) \
	x( ListBoxDestroy		) \
	x( ListControlColumnCount	) \
	x( ListControlDestroy		) \
	x( ListControlGet				) \
	x( ListControlItemCount		) \
	x( LN						) \
	x( load					) \
	x( loadImage			) \
	x( loadNodes			) \
	x( loadLayout			) \
	x( loadPicture			) \
	x( loadPictureText	) \
	x( Log10					) \
	x( lowerCase			) \
	x( makeDirectory		) \
	x( makeTree				) \
	x( makeTreeFromBody	) \
	x( mergePairs			) \
	x( mergeSort			) \
	x( mergeSortInPlace	) \
	x( MidiDeviceInfo		) \
	x( MidiMessage			) \
	x( negate				) \
	x( not					) \
	x( noPepperString		) \
	x( OnChar				) \
	x( OnKeyDown			) \
	x( OnKeyUp				) \
	x(	OnMouseLeftDown		) \
	x(	OnMouseRightDown		) \
	x(	OnMouseMiddleDown		) \
	x(	OnMouseLeftUp			) \
	x(	OnMouseRightUp			) \
	x(	OnMouseMiddleUp		) \
	x(	OnMouseLeftDClick		) \
	x( OnMouseRightDClick	) \
	x( OnMouseMiddleDClick	) \
	x( OnMouseMotion			) \
	x(	OnTextMouseLeftDown		) \
	x(	OnTextMouseRightDown		) \
	x(	OnTextMouseMiddleDown	) \
	x(	OnTextMouseLeftUp			) \
	x(	OnTextMouseRightUp		) \
	x(	OnTextMouseMiddleUp		) \
	x(	OnTextMouseLeftDClick	) \
	x( OnTextMouseRightDClick	) \
	x( OnTextMouseMiddleDClick	) \
	x( OnTextMouseMotion			) \
	x( openAppend			) \
	x( openAppendBin		) \
	x( openRead				) \
	x( openReadBin			) \
	x( openUpdate			) \
	x( openUpdateBin		) \
	x( openWrite			) \
	x( openWriteBin		) \
	x( parse					) \
	x( pick					) \
	x( playWaveFast		) \
	x( pop					) \
	x( PortIn				) \
	x( printOut				) \
	x( printOutTitles		) \
	x( radCos				) \
	x( RadioButtonDestroy) \
	x( RadioButtonValue	) \
	x( radSin				) \
	x( radTan				) \
	x(	radArcSin			) \
	x(	radArcCos			) \
	x( random				) \
	x( rawASCII				) \
	x( readChars			) \
	x( readIntArrayBin	) \
	x( readInt16ArrayBin	) \
	x( readStructBin		) \
	x( readWordBin			) \
	x(	real					) \
	x(	reciprocal			) \
	x( reHSB					) \
	x( reHSBA				) \
	x(	remdup				) \
	x( renderLogoAsHTML	) \
	x( renderLogoFileAsHTML) \
	x( reRGB					) \
	x( reRGBA				) \
	x( resendKeyEvent		) \
	x( reverse				) \
	x( right					) \
	x( rightRoll			) \
	x( round					) \
	x( runParse				) \
	x( save					) \
	x( saveNodes			) \
	x( saveLayout			) \
	x( savePicture			) \
	x( savePictureText	) \
	x( savePostScript		) \
	x( saveScreen			) \
	x(	scrollCalibrate	) \
	x(	setErrorAction		) \
	x( setExpandBackslashes	) \
	x( setCallsSplitter	) \
	x( setCaseIgnored		) \
	x( setColorLogicOp	) \
	x( setCursor			) \
	x( setDepthFunc		) \
	x( setErallOnRun		) \
	x( setFillTolerance	) \
	x( setFloodColor		) \
	x( setFocusOnRun		) \
	x( setFogColor			) \
	x( setFogDensity		) \
	x( setFogMode			) \
	x( setGenSym			) \
	x( setHeading			) \
	x( setLabelFont		) \
	x( setLabelSize		) \
	x( setLabelWeight		) \
	x( setLightAmbient	) \
	x( setLightDiffuse	) \
	x( setLightPos			) \
	x( setLightSpecular	) \
	x(	setLightSpotExponent	) \
	x(	setLineInfoInTrace) \
	x( setLoadNoisily		) \
	x( setLogoComspec		) \
	x( setLogoEditor		) \
	x( setLogoFontsDir		) \
	x( setLogoHelpDir		) \
	x( setLogoLanguage	) \
	x( setLogoLibDir		) \
	x( setLogoServiceDir	) \
	x( setLogoTempDir		) \
	x( setMargins			) \
	x( setMaterialAmbient) \
	x( setMaterialDiffuse) \
	x( setMaterialEmission) \
	x( setMaterialShininess) \
	x( setMaterialSpecular) \
	x( setModelviewMatrix) \
	x( setNamespace		) \
	x( setOrientation		) \
	x( setPenColor			) \
	x( setPenPattern		) \
	x( setPenSize			) \
	x( setPitch				) \
	x( setPlayOnSwap		) \
	x( setPointSize		) \
	x( setPolygonMode		) \
	x( setPos				) \
	x( setPosXYZ			) \
	x( setPrintDepthLimit) \
	x( setPrintWidthLimit) \
	x( setPrintPrecision	) \
	x( setProcessIdleInterleaving	) \
	x( setReader			) \
	x( setReaderPos		) \
	x( setRedefinable		) \
	x( setRoll				) \
	x( setSaveSize			) \
	x( setScreenColor		) \
	x( setShadowColor		) \
	x( setShowGuiOnError	) \
	x( setStackNoisy		) \
	x( setStartup			) \
	x( setTessWindingRule) \
	x( setTexPos			) \
	x( setTexWrapping		) \
	x( setTextFont			) \
	x( setTextSize			) \
	x( setTurtle			) \
	x( setTurtleShapes	) \
	x( setUpdateGraph		) \
	x( setUser				) \
	x( setVarsSplitter	) \
	x( setWriter			) \
	x( setWriterPos		) \
	x( setX					) \
	x( setY					) \
	x( setZ					) \
	x( shuffle				) \
	x( Signum				) \
	x( Sin					) \
	x( SizeOf				) \
	x( SliderDestroy		) \
	x( SliderValue			) \
	x( spinX					) \
	x( spinY					) \
	x( spinZ					) \
	x( Sqr					) \
	x( Sqrt					) \
	x( standout				) \
	x( StaticTextDestroy	) \
	x( StaticTextLabel	) \
	x( StaticTextSetLabel) \
	x( step					) \
	x( StringBuffer		) \
	x( StringBufferToWord) \
	x( Struct				) \
	x( tag					) \
	x( Tan					) \
	x( test					) \
	x( Text					) \
	x( TextControlCursor	) \
	x( TextControlDestroy) \
	x( TextControlInsertMode) \
	x( TextControlOverwriteMode) \
	x( TextControlSetInsertionPointEnd) \
	x( Texture				) \
	x( Thing					) \
	x( Thread				) \
	x( ThreadJoinable		) \
	x( ToggleButtonDestroy	) \
	x( ToggleButtonValue	) \
	x( toList				) \
	x( toListList			) \
	x( towards				) \
	x( towardsXYZ			) \
	x( trace					) \
	x( transposeMatrix	) \
	x( truncate				) \
	x( TypeOf				) \
	x( unBury				) \
	x( unStep				) \
	x( unTrace				) \
	x( updateVarsOnStep	) \
	x( upperCase			) \
	x( upPitch				) \
	x( wait					) \
	x( waitMS				) \
	x( waituS				) \
	x( WindowClearBackground	) \
	x( WindowDestroy				) \
	x( WindowDestroyChildren	) \
	x( WindowDisable				) \
	x( WindowFit					) \
	x( WindowFitInside			) \
	x( WindowFreeze				) \
	x( WindowGetBackgroundColor) \
	x( WindowGetBackgroundStyle) \
	x( WindowGetBestSize			) \
	x( WindowGetCaret				) \
	x( WindowGetCharHeight		) \
	x( WindowGetCharWidth		) \
	x( WindowGetChildren			) \
	x( WindowGetClientSize		) \
	x( WindowGetCursor			) \
	x( WindowGetExtraStyle		) \
	x( WindowGetForegroundColor) \
	x( WindowGetGrandParent		) \
	x( WindowGetHandle			) \
	x( WindowGetHelpText			) \
	x( WindowGetId					) \
	x( WindowGetLabel				) \
	x( WindowGetMaxSize			) \
	x( WindowGetMinSize			) \
	x( WindowGetName				) \
	x( WindowGetParent			) \
	x( WindowGetPosition			) \
	x( WindowGetRect				) \
	x(	WindowGetScreenPosition	) \
	x(	WindowGetScreenRect		) \
	x( WindowGetSize				) \
	x( WindowGetVirtualSize		) \
	x( WindowGetWindowBorderSize) \
	x( WindowGetWindowStyle		) \
	x( WindowHasCapture			) \
	x( WindowHasMultiplePages	) \
	x( WindowHasTransparentBackground) \
	x( WindowHide					) \
	x( WindowInheritAttributes	) \
	x( WindowInitDialog			) \
	x( WindowInvalidateBestSize) \
	x( WindowIsDoubleBuffered	) \
	x( WindowIsEnabled			) \
	x( WindowIsFrozen				) \
	x( WindowIsRetained			) \
	x( WindowIsShown				) \
	x( WindowIsShownOnScreen	) \
	x( WindowIsTopLevel			) \
	x( WindowLayout				) \
	x( WindowLineDown				) \
	x( WindowLineUp				) \
	x( WindowLower					) \
	x( WindowPageDown				) \
	x( WindowPageUp				) \
	x( WindowRaise					) \
	x( WindowReleaseMouse		) \
	x( WindowSetFocus				) \
	x( WindowThaw					) \
	x( WindowUpdate				) \

#define Primitives_prefix_one_arg_alias(x) \
	x( bk			, back				) \
	x( bF			, butFirst			) \
	x( bFs		, butFirsts			) \
	x( bL			, butLast			) \
	x( cd			, changeDir			) \
	x( Comment	, ignore				) \
	x( dequeue	, pop					) \
	x( down		, downPitch			) \
	x( er			, erase				) \
	x( fd			, forward			) \
	x( Float		, _float				) \
	x( BigFloat	, _bigfloat			) \
	x( Int		, _int				) \
	x( Int16		, toint16			) \
	x( Int8		, toint8				) \
	x( UInt8		, touint8			) \
	x( loadPic	, loadPicture		) \
	x( lt			, left				) \
	x( lR			, leftRoll			) \
	x( minus		, negate				) \
	x( pO			, printOut			) \
	x( pOT		, printOutTitles	) \
	x( rt			, right				) \
	x( rr			, rightRoll			) \
	x( rCs		, readChars			) \
	x( savePic	, savePicture		) \
	x( savePS	, savePostScript	) \
	x(	scrollCal, scrollCalibrate	) \
	x( setFC		, setFloodColor	) \
	x( setH		, setHeading		) \
	x( setPC		, setPenColor		) \
	x( setPS		, setPenSize		) \
	x( setSC		, setScreenColor	) \
	x(	trunc		, truncate			) \
	x(	uP			, upPitch			) \
	

#define Primitives_prefix_two_arg(x) \
	x( addColors			) \
	x( addColorsMod		) \
	x( Arc					) \
	x( ArcTan				) \
	x( aShift				) \
	x( BitCopy				) \
	x( BitItem				) \
	x( BitMakeTransparent) \
	x( Bitmap				) \
	x( ButtonEnable		) \
	x( ButtonOnClick		) \
	x( ButtonSetLabel		) \
	x( CheckBoxEnable		) \
	x( CheckBoxOnClick	) \
	x( CheckBoxSet			) \
	x( ChoiceBoxAppend		) \
	x( ChoiceBoxEnable		) \
	x( ChoiceBoxOnChar		) \
	x( ChoiceBoxOnKeyDown	) \
	x( ChoiceBoxOnKeyUp		) \
	x( ChoiceBoxOnSelect		) \
	x( ChoiceBoxRemoveItem	) \
	x( ChoiceBoxSetBackgroundColor) \
	x( ChoiceBoxSetColor		) \
	x( ChoiceBoxSetChoices	) \
	x( ChoiceBoxSetFontName	) \
	x( ChoiceBoxSetFontSize	) \
	x( ChoiceBoxSetFontStyle) \
	x( ChoiceBoxSetFontWeight) \
	x( ChoiceBoxSetSelection) \
	x( clearPortBit			) \
	x( ComboBoxAppend			) \
	x( ComboBoxEnable			) \
	x( ComboBoxOnChange		) \
	x( ComboBoxOnChar			) \
	x( ComboBoxOnEnter		) \
	x( ComboBoxOnSelect		) \
	x( ComboBoxOnKeyDown		) \
	x( ComboBoxOnKeyUp		) \
	x( ComboBoxOnSelect		) \
	x( ComboBoxRemoveItem	) \
	x( ComboBoxSetBackgroundColor) \
	x( ComboBoxSetColor		) \
	x( ComboBoxSetChoices	) \
	x( ComboBoxSetFontName	) \
	x( ComboBoxSetFontSize	) \
	x( ComboBoxSetFontStyle	) \
	x( ComboBoxSetFontWeight) \
	x( ComboBoxSetSelection	) \
	x( ComboBoxSetValue		) \
	x( copyDef				) \
	x( Cross					) \
	x( define				) \
	x( defineBe				) \
	x( destructiveRemove	) \
	x( Ellipse				) \
	x( fillEllipse			) \
	x( fillPie				) \
	x( fillRect				) \
	x( FloatControlEnable	) \
	x( FloatControlSetValue	) \
	x( FloatControlOnChange	) \
	x( fPut					) \
	x( FrameEnable			) \
	x( FrameIconize		) \
	x( FrameMaximize		) \
	x( FrameOnChar			) \
	x( FrameOnKeyDown		) \
	x( FrameOnKeyUp		) \
	x( FrameOnClose		) \
	x( FrameSetBackgroundColor) \
	x( FrameSetColor		) \
	x( FrameSetFontName	) \
	x( FrameSetFontSize	) \
	x( FrameSetFontStyle	) \
	x( FrameSetFontWeight) \
	x( FrameSetShape		) \
	x( FrameSetSizer		) \
	x( GaugeSetBackgroundColor) \
	x( GaugeSetColor		) \
	x( GaugeSetRange 		) \
	x( GaugeSetValue 		) \
	x( GraphOnChar			) \
	x( GraphOnKeyDown		) \
	x( GraphOnKeyUp		) \
	x(	GraphOnLeftDown	) \
	x(	GraphOnRightDown	) \
	x(	GraphOnMiddleDown	) \
	x(	GraphOnLeftUp		) \
	x(	GraphOnRightUp		) \
	x(	GraphOnMiddleUp	) \
	x(	GraphOnLeftDClick	) \
	x( GraphOnRightDClick) \
	x( GraphOnMiddleDClick) \
	x( GraphOnMotion		) \
	x( gcd					) \
	x( getPortBit			) \
	x( GraphOnChar			) \
	x( GraphOnKeyDown		) \
	x( GraphOnKeyUp		) \
	x( IntControlEnable	) \
	x( IntControlSetValue) \
	x( IntControlOnChange) \
	x( iSeq					) \
	x( leftPortShift		) \
	x( Line					) \
	x( ListBoxAppend		) \
	x( ListBoxEnable		) \
	x( ListBoxOnChar		) \
	x( ListBoxOnDClick	) \
	x( ListBoxOnKeyDown	) \
	x( ListBoxOnKeyUp		) \
	x( ListBoxOnSelect	) \
	x( ListBoxRemoveItem) \
	x( ListBoxSetBackgroundColor	) \
	x( ListBoxSetColor				) \
	x( ListBoxSetChoices				) \
	x( ListBoxSetFontName			) \
	x( ListBoxSetFontSize			) \
	x( ListBoxSetFontStyle			) \
	x( ListBoxSetFontWeight			) \
	x( ListBoxSetSelections			) \
	x( ListControlEnable				) \
	x( ListControlInsertItem		) \
	x( ListControlDeleteItem		) \
	x( ListControlGetColumn			) \
	x( ListControlGetRow				) \
	x( ListControlOnChar				) \
	x( ListControlOnColClick		) \
	x( ListControlOnItemSelected	) \
	x( ListControlOnItemActivated	) \
	x( ListControlOnKeyDown			) \
	x( ListControlOnKeyUp			) \
	x( ListControlSet					) \
	x( ListControlSetBackgroundColor) \
	x( ListControlSetColor			) \
	x( ListControlSetFontName		) \
	x( ListControlSetFontSize		) \
	x( ListControlSetFontStyle		) \
	x( ListControlSetFontWeight	) \
	x(	ListControlSort	) \
	x( loadLocal			) \
	x( lowPassFilter		) \
	x( lowPassFilter2		) \
	x( lPut					) \
	x( lShift				) \
	x( make					) \
	x( MatrixXMatrix		) \
	x( MatrixXVector		) \
	x( mdItem				) \
	x( Member				) \
	x( MemberCount			) \
	x( merge					) \
	x( MidiProgramChange	) \
	x( mod					) \
	x( notPortBit			) \
	x( playWave				) \
	x( PortOut				) \
	x( Power					) \
	x( push					) \
	x( queue					) \
	x( radArcTan			) \
	x( RadioButtonEnable	) \
	x( RadioButtonOnClick) \
	x( RadioButtonSet		) \
	x( Remainder			) \
	x( remove				) \
	x( removeItem			) \
	x( renameFile			) \
	x( resize				) \
	x( rightPortShift		) \
	x( rotate				) \
	x(	saturateAbove		) \
	x(	saturateBelow		) \
	x(	saveImage			) \
	x(	scroll				) \
	x( setEnv				) \
	x( setFogRange			) \
	x( setLabelAlign		) \
	x( setPixel				) \
	x( setPortBit			) \
	x( setTextColor		) \
	x( setTextSelection	) \
	x( setTexXY				) \
	x( setXY					) \
	x( SliderEnable		) \
	x( SliderOnScroll		) \
	x( SliderSetLineSize	) \
	x( SliderSetPageSize	) \
	x( SliderSetValue		) \
	x( Sound					) \
	x( StaticTextSetLabel) \
	x( StaticTextSetBackgroundColor) \
	x( StaticTextSetColor		) \
	x( StaticTextSetFontName	) \
	x( StaticTextSetFontSize	) \
	x( StaticTextSetFontStyle	) \
	x( StaticTextSetFontWeight	) \
	x( SubStringCount				) \
	x( TextControlAppend			) \
	x( TextControlEnable			) \
	x( TextControlOnChange		) \
	x( TextControlOnChar			) \
	x( TextControlOnEnter		) \
	x( TextControlOnKeyDown		) \
	x( TextControlOnKeyUp		) \
	x( TextControlSetBackgroundColor) \
	x( TextControlSetColor		) \
	x( TextControlSetCursor		) \
	x( TextControlSetFontName	) \
	x( TextControlSetFontSize	) \
	x( TextControlSetFontStyle	) \
	x( TextControlSetFontWeight	) \
	x( TextControlSetValue			) \
	x( TextControlWrite				) \
	x( ToggleButtonEnable			) \
	x( ToggleButtonOnClick			) \
	x( ToggleButtonSetValue			) \
	x( toInt								) \
	x( Tone								) \
	x( WindowCenter					) \
	x( WindowCenterOnParent			) \
	x(	WindowGetScrollPos			) \
	x(	WindowGetScrollRange			) \
	x(	WindowGetScrollThumb			) \
	x(	WindowGetTextExtent			) \
	x(	WindowHasFlag					) \
	x(	WindowHasScrollbar			) \
	x(	WindowMakeModal				) \
	x(	WindowMoveAfterInTabOrder	) \
	x(	WindowMoveBeforeInTabOrder	) \
	x(	WindowNavigate					) \
	x(	WindowReparent					) \
	x(	WindowScrollLines				) \
	x(	WindowScrollPages				) \
	x( WindowSetAutoLayout			) \
	x( WindowSetBackgroundColor	) \
	x( WindowSetBackgroundStyle	) \
	x( WindowSetExtraStyle			) \
	x( WindowSetForegroundColor	) \
	x( WindowSetFontName				) \
	x( WindowSetFontSize				) \
	x( WindowSetFontStyle			) \
	x( WindowSetFontWeight			) \
	x( WindowSetHelpText				) \
	x( WindowSetId						) \
	x( WindowSetLabel					) \
	x( WindowSetName					) \
	x( WindowSetOwnBackgroundColor) \
	x( WindowSetOwnFontName			) \
	x( WindowSetOwnFontSize			) \
	x( WindowSetOwnFontStyle		) \
	x( WindowSetOwnFontWeight		) \
	x( WindowSetOwnForegroundColor) \
	x( WindowSetSizer					) \
	x( WindowSetSizerAndFit			) \
	x( WindowSetThemeEnabled		) \
	x( WindowSetToolTip				) \
	x( WindowSetWindowStyle			) \
	x( WindowToggleWindowStyle		) \
	x( WindowUnregisterHotKey		) \
	x( xAdd					) \
	x( xCopy					) \
	x( xDiv					) \
	x( xMod					) \
	x( xMul					) \
	x( xSub					) \

#define Primitives_prefix_two_arg_alias(x) \
	x( BitTrans, BitMakeTransparent) \
	x( Difference, sub			) \
	x( Modulo, mod					) \
	x( setTC , setTextColor		) \


#define Primitives_prefix_three_arg(x) \
	x( DynamicLibraryCall) \
	x( BitFill				) \
	x( BitPixel				) \
	x( ChoiceBoxSetItem	) \
	x( ComboBoxSetItem	) \
	x( FloatControlSetRange) \
	x( FrameFullScreen	) \
	x( FrameSetClientSize) \
	x( HSB					) \
	x( IntControlSetRange) \
	x( intForm				) \
	x( iSeqIntArray		) \
	x( isLikeColor			) \
	x( Items					) \
	x( ListBoxSetItem		) \
	x( ListControlGetItem) \
	x( ListControlSetColumn	) \
	x( ListControlSetRow	) \
	x( mandelIterate		) \
	x( mandelIterateSine	) \
	x( mdSetItem			) \
	x( MidiNoteOn			) \
	x( MidiNoteOff			) \
	x( replace				) \
	x( rSeq					) \
	x( rSeqComplexArray	) \
	x( rSeqFloatArray		) \
	x( setItem				) \
	x( setItems				) \
	x( setCylinderPos		) \
	x( setEye				) \
	x( setPixelXY			) \
	x( setScrunch			) \
	x( setSpherePos		) \
	x( setXYZ				) \
	x( SliderSetRange		) \
	x( StaticBoxSizer		) \
	x(	WindowClientToScreen	) \
	x( WindowMove				) \
	x(	WindowScreenToClient	) \
	x(	WindowScrollWindow	) \
	x( WindowSetCaret			) \
	x( WindowSetClientSize	) \
	x( WindowSetInitialSize	) \
	x( WindowSetMaxSize		) \
	x( WindowSetMinSize		) \
	x( WindowSetSize			) \
	x( WindowSetVirtualSize	) \

#define Primitives_prefix_three_arg_alias(x) \
	x( DLCall, DynamicLibraryCall	) \
	x( iSeqIA, iSeqIntArray			) \
	x( rSeqCA, rSeqComplexArray	) \
	x( rSeqFA, rSeqFloatArray		) \

#define Primitives_prefix_four_arg(x) \
	x( BitPasteTo			) \
	x( BitSetPixel			) \
	x( EllipseArc			) \
	x( GaussianSmooth		) \
	x( HSBA					) \
	x( ListControlSetItem) \
	x( setScreenRange		) \
	x( setPixelXYZ			) \
	x( WindowRegisterHotKey	) \
	x( WindowSetScrollPos	) \

#define Primitives_General_Binary(x) \
	x( and			) \
	x( BitAnd		) \
	x( BitOr			) \
	x( BitXOr		) \
	x( List			) \
	x( or				) \
	x( Sentence		) \
	x( Word			) \

#define Primitives_General_Prefix(x) \
	x( Array						,1,1,2) \
	x( BitPasteToScaled		,6,6,6) \
	x( BoxSizerAdd				,5,5,5) \
	x( Button					,3,3,8) \
	x( CheckBox					,2,3,8) \
	x( ChoiceBox				,3,4,7) \
	x( ChoiceBoxSelection	,0,0,1) \
	x( ComboBox					,4,7,10) \
	x( ComboBoxSelection		,0,0,1) \
	x( ComboBoxValue			,0,0,1) \
	x( ComplexArray			,1,1,2) \
	x( Cylinder					,2,2,7) \
	x( DirSelector				,0,0,3) \
	x( drawGraphic				,1,1,2) \
	x( Ellipsoid				,3,3,5) \
	x( ESimGetAllFields		,7,7,7) \
	x( ESimOneStep				,14,14,14) \
	x( fft						,1,1,1) \
	x( Files						,0,0,2) \
	x( FileSelector			,1,1,7) \
	x( fill						,0,0,1) \
	x( FloatArray				,1,1,2) \
	x( FloatControl			,6,8,12) \
	x( FloatControlValue		,0,0,1) \
	x( Form                 ,2,3,3) \
	x( Frame						,3,5,6) \
	x( Gauge						,3,3,7) \
	x( GarbageCollect			,0,0,1) \
	x( getColorFromUser		,0,1,1) \
	x( getFontFromUser		,0,0,1) \
	x(	getMultipleChoices	,3,3,6) \
	x(	getNumberFromUser		,6,6,7) \
	x(	getPasswordFromUser	,3,3,5) \
	x(	getSingleChoice		,3,3,6) \
	x(	getSingleChoiceIndex	,3,3,6) \
	x(	getTextFromUser		,3,3,5) \
	x( Graph						,1,1,5) \
	x( IntArray					,1,1,2) \
	x( Int16Array				,1,1,2) \
	x( IntControl				,5,6,9) \
	x( IntControlValue		,0,0,1) \
	x( LabelSize				,0,1,1) \
	x( ListBox					,3,5,8) \
	x( ListBoxSelections		,0,0,1) \
	x( ListControl				,2,5,8) \
	x( ListControlInsertColumn,3,3,5) \
	x( MessageBox				,1,1,4) \
	x( MidiOpen					,0,1,2) \
	x( MidiOutStream			,2,2,4) \
	x( MidiOutStreams			,1,1,1) \
	x( Molecules3dMoveThem  ,21,21,21) \
	x( NMR_QMsim				,8,8,8) \
	x( NMRBlochSim				,17,17,17) \
	x( NMRBlochSim2			,19,19,19) \
	x( NMRBlochSimSpectrum	,16,16,16) \
	x( NMRCarterNu          ,10,10,10) \
	x( NMRCarterIntensity_oneTheta,13,13,13) \
	x( NMRCarterIntensity   ,13,13,13) \
	x( NMRCarterIntensity_MAS,13,13,13) \
	x( NMRCarterIntensity_m ,13,13,13) \
	x( partialEllipsoid		,9,9,9) \
	x( PowerSpectrum			,1,1,1) \
	x( reRandom					,0,0,1) \
	x( RadioButton				,2,3,8) \
	x( readFloatArrayBin		,1,1,2) \
	x( readURL					,1,1,2) \
	x( RGB						,1,3,3) \
	x( RGBA						,1,4,4) \
	x( runSecure				,2,2,9) \
	x( saveScreenVector		,1,1,4) \
	x( sendCharEvent			,4,4,4) \
	x( sendKeyDownEvent		,4,4,4) \
	x( sendKeyUpEvent			,4,4,4) \
	x( setFPUStatusFlags		,0,4,7) \
	x( Shell						,0,1,2) \
	x( ShellSpawn				,0,1,2) \
	x( Slider					,5,6,9) \
	x( SliderValue				,0,0,1) \
	x( Sounds					,1,1,2) \
	x( Sphere					,1,1,3) \
	x( splitScreen				,0,0,1) \
	x( StaticText				,2,2,6) \
	x( Table						,1,1,2) \
	x( TextControl				,2,3,8) \
	x( TextControlValue		,0,0,1) \
	x( throw						,1,1,2) \
	x( ToggleButton			,3,3,7) \
	x( Tones						,1,1,2) \
	x( VideoStart				,1,1,2) \
	x( Window					,1,5,6) \
	x( WindowClose				,1,1,2) \
	x( WindowEnable			,1,1,2) \
	x( WindowFindWindowById	,1,1,2) \
	x( WindowFindWindowByLabel	,1,1,2) \
	x( WindowFindWindowByName	,1,1,2) \
	x( WindowIsExposed		,3,3,5) \
	x( WindowRefresh			,0,0,5) \
	x( WindowSetScrollbar	,6,6,6) \
	x( WindowShow				,0,0,1) \
\
	x( combine		,1,2,-1) \
	x( inherit		,1,1,-1) \
	x( print			,0,1,-1) \
	x( show			,0,1,-1) \
	x( type			,0,1,-1) \
	x( typeBin		,0,1,-1) \
\
	x( local			,1,1,-1) \
	x( maxNorm		,1,1,-1) \
	x( Norm			,1,1,-1) \
	x( Norm3			,1,1,-1) \


#define Primitives_General_Prefix_alias(x) \
	x( GC			, GarbageCollect,0, 0, 1) \
	x( Item		, Item			, 2, 2, 2) \
	x( pr			, print			, 0, 1,-1) \
	x( Product	, mul				, 0, 2,-1) \
	x( Quotient	, div				, 1, 2, 2) \
	x( Se			, Sentence		, 0, 2,-1) \
	x( sS			, splitScreen	, 0, 0, 1) \
	x( sum		, add				, 0, 2,-1) \
	x( ?			, questionmark	, 0, 0, 1) \


#define Predicates__no_arg(x) \
	x( CaseIgnored	) \
	x( Eof			) \
	x( BusyCursor	) \
	x( Key			) \
	x( PenDown		) \
	x( redefinable	) \
	x( Refresh		) \
	x( shown			) \

#define Predicates_one_arg(x) \
	x( AlNum			) \
	x( Alpha			) \
	x( Array			) \
	x( ASCII			) \
	x( backslashed	) \
	x( BigFloat		) \
	x( Char			) \
	x( circular		) \
	x( Cntrl			) \
	x( Complex_		) \
	x( ComplexArray) \
	x( CSym			) \
	x( defined		) \
	x( Digit			) \
	x( Directory	) \
	x( empty			) \
	x( File			) \
	x( Float			) \
	x( FloatArray	) \
	x( Graph			) \
	x( Int			) \
	x( IntArray		) \
	x( Int16			) \
	x( Int16Array	) \
	x( Int8			) \
	x( List			) \
	x( Lower			) \
	x( Macro			) \
	x( Name			) \
	x( Number		) \
	x( Prime			) \
	x( Primitive	) \
	x( Print			) \
	x( Procedure	) \
	x( ProcedureDynamic) \
	x( Punct			) \
	x( Space			) \
	x( Table			) \
	x( UInt8			) \
	x( Upper			) \
	x( Word			) \
	x( xDigit		) \

#define Predicates_two_arg(x) \
	x( before		) \
	x( equal			) \
	x( greater		) \
	x( greaterEqual) \
	x( less			) \
	x( lessEqual	) \
	x( Member		) \
	x( NameInTable	) \
	x( Substring	) \
	x( SubList		) \


#define Primitives_prefix_ok(x) \
	x( continue		) \
	x( edit			) \
	x( help			) \

#define Primitives_prefix_ok_alias(x) \
	x( co, continue) \
	x( ed, edit		) \


#define Primitives_prefix_macro_arg(x) \
	x( to				) \
	x( be				) \
	x( end			) \

#define Primitives_macro_one_arg(x) \
	x( forever		) \
	x( goTo			) \
	x( Graphic		) \
	x( ifFalse		) \
	x( ifTrue		) \
	x( Polygon		) \
	x( run			) \
	x( runResult	) \
	x( Surface		) \
	x( Tesselation	) \

#define Primitives_macro_one_arg_alias(x) \
	x( ifF, ifFalse) \
	x( ifT, ifTrue	) \

#define Primitives_macro_two_arg(x) \
	x( apply			) \
	x( case			) \
	x( catch			) \
	x( do_until		) \
	x( do_while		) \
	x( for			) \
	x( repeat		) \
	x( until			) \
	x( while			) \

#define Primitives_macro_three_arg(x) \
	x( ifElse		) \

#define make_prefix(x,n)			{#x	, n,n,n, prefix, l##x	},
#define make_prefix_alias(x,y,n)	{#x	, n,n,n, prefix, l##y	},
#define make_general_binary(x)	{#x	, 0,2,-1,prefix, l##x	},
#define make_macro(x,n)				{#x	, n,n,n, priority_MACRO	, l##x	},
#define make_macro_alias(x,y,n)	{#x	, n,n,n, priority_MACRO	, l##y	},

#define make_prefix_ok(x) \
	{#x, Primitive::ok_if_no_arg,1,1, prefix, l##x	},

#define make_prefix_ok_alias(x,y) \
	{#x, Primitive::ok_if_no_arg,1,1, prefix, l##y	},

#define make_general_prefix(x,min,std,max) \
	{#x	, min,std,max, prefix, l##x	},

#define make_general_prefix_alias(x,y,min,std,max) \
	{#x	, min,std,max, prefix, l##y	},

#define make_predicate(x,n) \
	{#x"P", n,n,n, prefix, lis##x	}, \
	{#x"?", n,n,n, prefix, lis##x	},

#define make_prefix__no_arg(x)	make_prefix(x,0)
#define make_prefix_one_arg(x)	make_prefix(x,1)
#define make_prefix_two_arg(x)	make_prefix(x,2)
#define make_prefix_three_arg(x)	make_prefix(x,3)
#define make_prefix_four_arg(x)	make_prefix(x,4)
#define make_prefix_macro_arg(x)	make_prefix(x,-1)

#define make_prefix__no_arg_alias(x,y)	make_prefix_alias(x,y,0)
#define make_prefix_one_arg_alias(x,y)	make_prefix_alias(x,y,1)
#define make_prefix_two_arg_alias(x,y)	make_prefix_alias(x,y,2)
#define make_prefix_three_arg_alias(x,y)	make_prefix_alias(x,y,3)

#define make_macro_one_arg(x)		make_macro(x,1)
#define make_macro_two_arg(x)		make_macro(x,2)
#define make_macro_three_arg(x)	make_macro(x,3)

#define make_macro_one_arg_alias(x,y)	make_macro_alias(x,y,1)

#define make_predicate__no_arg(x)	make_predicate(x,0)
#define make_predicate_one_arg(x)	make_predicate(x,1)
#define make_predicate_two_arg(x)	make_predicate(x,2)

#define WINDOW_list_WindowOn(x) make_prefix_two_arg(WindowOn##x)

PrimType Primitive::primitives[]=
{
	Primitives_prefix__no_arg		(make_prefix__no_arg)
	Primitives_prefix_one_arg		(make_prefix_one_arg)
	Primitives_prefix_two_arg		(make_prefix_two_arg)
	Primitives_prefix_three_arg	(make_prefix_three_arg)

	Primitives_prefix_four_arg		(make_prefix_four_arg)

	Primitives_prefix__no_arg_alias(make_prefix__no_arg_alias)
	Primitives_prefix_one_arg_alias(make_prefix_one_arg_alias)
	Primitives_prefix_two_arg_alias(make_prefix_two_arg_alias)
	Primitives_prefix_three_arg_alias(make_prefix_three_arg_alias)

	{"max",0,2,-1,prefix, ::lmax},
	{"min",0,2,-1,prefix, ::lmin},
	Primitives_General_Binary			(make_general_binary)
	Primitives_General_Prefix			(make_general_prefix)
	Primitives_General_Prefix_alias	(make_general_prefix_alias)

	Predicates__no_arg			(make_predicate__no_arg)
	Predicates_one_arg			(make_predicate_one_arg)
	Predicates_two_arg			(make_predicate_two_arg)

	WINDOW_EVENTS(WINDOW_list_WindowOn)

	Primitives_prefix_ok			(make_prefix_ok)
	Primitives_prefix_ok_alias	(make_prefix_ok_alias)

	{"--",1,1,1,priority_negate		, lnegate	},
	{"+" ,1,1,1,priority_addition		, ladd		},
	{"-" ,1,1,1,priority_addition		, lsub		},
	{"*" ,1,1,1,priority_product		, lmul		},
	{"/" ,1,1,1,priority_product		, ldiv		},
//	{"%" ,1,1,1,priority_product		, lmod		},
	{"^" ,1,1,1,priority_power			, lPower		},

//	{"!" ,1,1,1,priority_faculty		, lFaculty	},
	{"." ,1,1,1,priority_dot			, ldot		},
	{">" ,2,2,2,priority_comparsion	, lisgreater},
	{"<" ,2,2,2,priority_comparsion	, lisless	},
	{">=",2,2,2,priority_comparsion	, lisgreaterEqual	},
	{"<=",2,2,2,priority_comparsion	, lislessEqual		},
	{"==",2,2,2,priority_comparsion	, lisequal	},
	{"!=",2,2,2,priority_comparsion	, lisunequal},
	{ "=",2,2,2,priority_assignment	, lmake		},
	{"+=",2,2,2,priority_assignment	, lxAdd		},
	{"-=",2,2,2,priority_assignment	, lxSub		},
	{"*=",2,2,2,priority_assignment	, lxMul		},
	{"/=",2,2,2,priority_assignment	, lxDiv		},
//	{"%=",2,2,2,priority_assignment	, lxMod		},
	{"or2",0,2,-1,priority_logical	, lor			},
	{"and2",0,2,-1,priority_logical	, land		},

	Primitives_prefix_macro_arg(make_prefix_macro_arg)

	Primitives_macro_one_arg	(make_macro_one_arg)
	Primitives_macro_two_arg	(make_macro_two_arg)
	Primitives_macro_three_arg	(make_macro_three_arg)

	Primitives_macro_one_arg_alias(make_macro_one_arg_alias)

	{"_defMacro"	,2,2,2, prefix, l_defMacro		},
	{"_eq"			,2,2,2, prefix, l_eq				},
	{"_Macro"	,-1,-1,-1, prefix, l_Macro			},
	{"_beMacro"	,-1,-1,-1, prefix, l_beMacro		},
	{"_setBF"		,2,2,2, prefix, l_setButFirst	},
	{"_setButFirst",2,2,2, prefix, l_setButFirst	},
	{"_setFirst"	,2,2,2, prefix, l_setFirst		},
	{"_setItem"		,3,3,3, prefix, l_setItem		},
	{"?Rest"			,0,0,1, prefix, lquestionmarkRest},

	{"if"				,2,2,3, priority_MACRO , lif		},
	{"foreach"		,2,2,-1,priority_MACRO , lforeach},

	{"_maybeOutput",1,1,1, priority_MAYBE , loutput	},
	{"output"		,1,1,1, priority_OUTPUT, loutput	},
	{"op"				,1,1,1, priority_OUTPUT, loutput	},
	{"stop"			,0,0,0, priority_STOP  , lstop	},

	{0,0,0,0,prefix,0}
};

ObjectP permanent(const charP name) 
{
	StringP str = new String(name);
	if throwing return ObjectP(Unbound);
	ObjectP result = str->intern();
	result->bit.permanent=true;
	return result;
}

ObjectP permanentobj(const charP name) 
{
	StringP str = new String(name);
	if throwing return ObjectP(Unbound);
	ObjectP result = str->intern();
	result->bit.permanentobj=true;
	return result;
}

void init(void) 
{
	GC_::init();

	ThreadP th=Thread::This();
	th->namespce=root;
	_Null_Word = permanentobj("\0");
	th->namespceobj=_Null_Word;
	_One=new Object(new String("1"),0);
	_Minus_One=new Object(new String("-1"),0);

#define           CREATE(x)	_##x = permanent(#x);
#define        CREATEobj(x)	_##x = permanentobj(#x);
#define         CREATEwx(x)	_wx##x = permanent("wx"#x);
#define       CREATEWXK_(x)	_WXK_##x = permanent("WXK_"#x);
#define     CREATEGL2PS_(x)	_GL2PS_##x = permanent("GL2PS_"#x);
#define  CREATESECURITY_(x)	_SECURITY_##x = permanent("SECURITY_"#x);
#define  CREATE_ERR_MSGS(x)	ErrorMessage_##x = permanent("ErrorMessage_"#x);
#define             BURY(x)	_##x->bit.val_buried=true;
#define           BURYwx(x)	_wx##x->bit.val_buried=true;
#define         BURYWXK_(x)	_WXK_##x->bit.val_buried=true;
#define       BURYGL2PS_(x)	_GL2PS_##x->bit.val_buried=true;
#define    BURYSECURITY_(x)	_SECURITY_##x->bit.val_buried=true;
#define    BURY_ERR_MSGS(x)	ErrorMessage_##x->bit.val_buried=true;
#define SET_FILE_POINTER(x)	x=FileP(_##x->var());

	Permanent_Objects(CREATEobj)

	 File::init();
	 Line::init();

	Primitive::init(Primitive::primitives, true);
	Primitive::init(Primitive::primitives, false);
	th->caseIgnored=true;

	_True ->setvarPermanent(_True );
	_False->setvarPermanent(_False);
//	_True ->setvar(_True->name());
//	_True ->bit.permanent=true;
	_True ->bit.permanentobj=true;
//	_False->setvar(_False->name());
//	_False->bit.permanent=true;
	_False->bit.permanentobj=true;

       _Zeroo = permanentobj( "0");
	      _One = permanentobj( "1");
	_Minus_One = permanentobj("-1"); 

	  Int::init();
	Float::init();
	BigFloat::init();

	    Special_Vars(BURY)
	Number_Constants(BURY)

	_Assign_Sign = permanentobj("=");
	_Equality_Op = permanentobj("==");
	  _Plus_Sign = permanentobj("+");
	 _Minus_Sign = permanentobj("-");
	     _Negate = permanentobj("--");
	 _Reciprocal = permanentobj("reciprocal");
	   _Mul_Sign = permanentobj("*");
	   _Div_Sign = permanentobj("/");
	   _Mod_Sign = permanentobj("mod");

	 _Left_Paren = permanentobj("(");
	_Right_Paren = permanentobj(")");
	      _Query = permanentobj("?");
			  _Dot = permanentobj(".");
	_SingleQuote = permanentobj("'");
	       _Else = permanentobj("else");
	      _Word_ = permanentobj("word");
	       _Void = permanentobj("void");
	   _Complex_ = permanentobj("complex");
	  _IntArray_ = permanentobj("intarray");
	_Int16Array_ = permanentobj("int16array");
	_FloatArray_ = permanentobj("floatarray");
	_ComplexArray_ = permanentobj("complexarray");
	    _Unnamed = permanentobj("unnamed");
	th->setfilename(_Unnamed->name());

	_Not_Enough_node = new Line(0,0);

#define Make_permanent(x) type_##x = permanentobj
#define Paren(y) (y);

	Node_Type_Strings(Make_permanent, Paren)
	GC_::initialized=true;

	_End = permanentobj("end");
	__Macro_ = permanentobj("_Macro");
	Thread::main->specialForms=new Array(5, 0);
	if (!throwing)
	{	Thread::main->specialForms->setitem(0, _To);
		Thread::main->specialForms->setitem(1, _Be);
		Thread::main->specialForms->setitem(2, __Macro_);
		Thread::main->specialForms->setitem(3, __BeMacro);
		Thread::main->specialForms->setitem(4, _End);
	}
	Thread::main->logoLanguage=_aucblogo;
	_lmake    = permanent("_lmake");
	_lisequal = permanent("_lisequal");
	_ldot     = permanent("_ldot");
	_lmake->setprim(_Assign_Sign->prim());
	_lisequal->setprim(_Equality_Op->prim());
	_ldot->setprim(_Dot->prim());

#define Make_ErrorMessage_permanent(x) ErrorMessage_##x = permanent("ErrorMessage_"#x);

	ErrorMessages(Make_ErrorMessage_permanent)
	ErrorMessages(BURY_ERR_MSGS)

	ErrorMessage_Out_of_Mem->setvarPermanent(
		new Line(
			new Line(_("; out of space. Delete something or clearScreen!")),
		new Line(0,
		new Line(0,
		new Line(0,
		new Line(0, 0))))));

	ErrorMessage_Stack_Overflow->setvarPermanent(
		new Line(_("; stack overflow")));

	ErrorMessage_Security_MemSize->setvarPermanent(
		new Line(
			new Line(new String(_("; ")),
			new Line(0,
			new Line(new String(_("is not allowed to use more memory")), 0))),
		new Line(0,
		new Line(0,
		new Line(0,
		new Line(0, 0))))));

	ErrorMessage_Security_Nodes->setvarPermanent(
		new Line(
			new Line(new String(_("; ")),
			new Line(0,
			new Line(new String(_("is not allowed to use more nodes")), 0))),
		new Line(0,
		new Line(0,
		new Line(0,
		new Line(0, 0))))));

	ProcedureP proc=new Procedure(
		0, 0, 0, _Editing, priority_prefix, 0, 0, 0, PROC_);
	_Editing->setproc(proc);
	_Editing->flag=ObjectType(PROC_OBJECT | PROC_BURIED);
	
	      wxCONSTANTS(CREATEwx)
			   Keycodes(CREATEWXK_)
		FILL_CONSTANTS(CREATE)
#ifdef OPENGL
		GL_CONSTANTS(CREATE)
	  GL2PS_CONSTANTS(CREATEGL2PS_)
#endif
	SECURITY_CONSTANTS(CREATESECURITY_)

		  wxCONSTANTS(BURYwx)
			  Keycodes(BURYWXK_)
	  FILL_CONSTANTS(BURY)
#ifdef OPENGL
		 GL_CONSTANTS(BURY)
	 GL2PS_CONSTANTS(BURYGL2PS_)
#endif
	SECURITY_CONSTANTS(BURYSECURITY_)

#define SET_wxCONSTANT(x) _wx##x->setvar(new Int( wx##x));
	wxCONSTANTS(SET_wxCONSTANT)
#define SET_WXK_CONSTANT(x) _WXK_##x->setvar(new Int(WXK_##x));
	Keycodes(SET_WXK_CONSTANT)

#define SET_GL_CONSTANT(x) _##x->setvar(new Int(x));
#ifdef OPENGL
	GL_CONSTANTS(SET_GL_CONSTANT)
#define SET_GL2PS_CONSTANT(x) _GL2PS_##x->setvar(new Int(GL2PS_##x));
	GL2PS_CONSTANTS(SET_GL2PS_CONSTANT)
#endif

#define SET_FILL_CONSTANT(x) _##x->setvar(new Int(x));
FILL_CONSTANTS(SET_GL_CONSTANT)

#define SET_SECURITY_CONSTANT(x) _SECURITY_##x->setvar(new Int(SECURITY_##x));
	SECURITY_CONSTANTS(SET_SECURITY_CONSTANT)

	LoadIODLL();

	theApp->createGUI();

	midiInit();
	debugStates.init(theApp->ringBufferSize);

	initWindowClasses();

	if (LogoApp::callback)
		LogoApp::callback();
}
