//___________________________________________________________________
//
//                         Init Header
//___________________________________________________________________

#define Throw_Nodes(x)						\
	x(error) x(runsecuretimer)				\
	x(pause) x(toplevel) x(system)

#define Unary_Arithmetics(x)										\
	x(Negate) x(Reciprocal) x(BitNot) x(Random)				\
	x(Int_) x(Int16_) x(Int8_) x(UInt8_) x(Float_)			\
	x(BigFloat_)														\
	x(Int) x(Int16) x(Int8) x(UInt8) x(Float)					\
	x(BigFloat)															\
	x(IntPtr) x(Int16Ptr) x(Int8Ptr) x(UInt8Ptr)				\
	x(FloatPtr) x(ComplexPtr) x(Bitmap) x(NodePtr)			\
	x(Bool)																\
	x(Truncate) x(Round)												\
	x(SIn) x(COs) x(Tan)												\
	x(ArcSin) x(ArcCos)												\
	x(radSin) x(radCos) x(radTan)									\
	x(radArcSin) x(radArcCos)										\
	x(Abs) x(Sqr) x(Sqrt) x(EXp) x(LN) x(Log10)				\
	x(Real) x(Imag) x(Conjugate) x(Signum)

#define Binary_Arithmetics(x)					\
	x(Remainder_) x(AShift) x(LShift)		\
	x(BitOr) x(BitAnd) x(BitXOr)			\
	x(Power_) x(ArcTan_) x(RadArcTan_)		\
	x(SaturateAbove) x(SaturateBelow)

#define Special_Vars(x)										\
	x(True) x(False)											\
	x(IntMax) x(Int16Max) x(Int8Max) x(UInt8Max)		\
	x(IntMin) x(Int16Min) x(Int8Min) x(UInt8Min)		\
	x(FloatMax) x(NaN) x(QuietNaN)						\
	x(Pi) x(BigFloatPi)										\
	x(Determinant)												\
	x(__Template_Lists) x(CallsList)

#define Eval_Macros(x)												\
	x(To) x(Be) x(End) x(_Macro_) x(_BeMacro)					\
	x(If) x(IfElse)													\
	x(Output) x(Op) x(Stop) x(Goto) x(For) x(Foreach)		\
	x(Tag) x(List) x(_SetItem) x(mdSetItem)					\
	x(Editing) x(Unnamed)											\
	x(aucblogo) x(ucblogo)

#define Permanent_Objects(x)		\
	x(ListEnd)							\
	  Throw_Nodes(x)					\
	  Unary_Arithmetics(x)			\
	 Binary_Arithmetics(x)			\
	Special_Vars(x)					\
	 Eval_Macros(x)

#define Number_Constants(x)		\
	x(Zeroo) x(One) x(Minus_One)

#define Infix_Arithmetics(x)							\
	x(Assign_Sign) x(Equality_Op)						\
	x(Plus_Sign) x(Minus_Sign)							\
	x(Mul_Sign) x(Div_Sign) x(Mod_Sign)
 
#define Special_Symbols(x)								\
	x(Left_Paren) x(Right_Paren)						\
	x(Query) x(Dot) x(SingleQuote)					\
	x(Complex_)												\
	x(IntArray_) x(Int16Array_) x(Int8Array_)		\
	x(UInt8Array_)											\
	x(FloatArray_)	x(ComplexArray_)					\
	x(Else) x(Word_) x(Void) x(Null_Word)			\
	x(lmake) x(lisequal) x(ldot)

#define Permanent_Objects2(x)		\
	 Number_Constants(x)				\
	  Infix_Arithmetics(x)			\
	Special_Symbols(x)

#define Node_Type_Strings(x,y)	\
	x( Node )				y("Node"			) \
	x( Int  )				y("Int"			) \
	x( Int16)				y("Int16"		) \
	x( Int8 )				y("Int8"			) \
	x(UInt8 )				y("UInt8"		) \
	x( Float)				y("Float"		) \
	x( BigFloat)			y("BigFloat"	) \
	x(Complexd)				y("Complex"		) \
	x(Primitive)			y("Primitive"	) \
	x( Array)				y("Array"		) \
	x(IntArray)				y("IntArray"	) \
	x(Int16Array)			y("Int16Array"	) \
	x(Int8Array)			y("Int8Array"	) \
	x(UInt8Array)			y("UInt8Array"	) \
	x(FloatArray)			y("FloatArray"	) \
	x(ComplexArray)		y("ComplexArray"	) \
	x(String)				y("Word"			) \
	x(Bitmap)				y("Bitmap"		) \
	x(Texture)				y("Texture"		) \
	x(TurtleNode)			y("Turtle"		) \
	x(Pair)					y("List"			) \
	x(Line)					y("Line"			) \
	x(Runparsed)			y("Runparsed"	) \
	x(Tree)					y("Tree"			) \
	x(Quote)					y("Quote"		) \
	x(Colon)					y("Colon"		) \
	x(WindowPair)			y("WindowPair"	) \
	x(Procedure)			y("Procedure"	) \
	x(Compiled)				y("Compiled"	) \
	x(File)					y("File"			) \
	x(Table)					y("Table"		) \
	x(Struct)				y("Struct"		) \
	x(GraphicNode)			y("Graphic"		) \
	x(DynamicLibrary)		y("DynamicLibrary") \
	x(SliderNode)			y("Slider"			) \
	x(WindowNode)			y("Window"			) \
	x(FrameNode)			y("Frame"			) \
	x(GraphNode)			y("Graph"			) \
	x(ButtonNode)			y("Button"			) \
	x(ToggleButtonNode)	y("ToggleButton"	) \
	x(CheckBoxNode)		y("CheckBox"		) \
	x(RadioButtonNode)	y("RadioButton"	) \
	x(GaugeNode)			y("Gauge"			) \
	x(IntControlNode)		y("IntControl"		) \
	x(FloatControlNode)	y("FloatControl"	) \
	x(StaticTextNode)		y("StaticText"		) \
	x(TextControlNode)	y("TextControl"	) \
	x(ListBoxNode)			y("ListBox"			) \
	x(ChoiceBoxNode)		y("ChoiceBox"		) \
	x(ComboBoxNode)		y("ComboBox"		) \
	x(BoxSizerNode)		y("BoxSizer"		) \
	x(StaticBoxSizerNode)	y("StaticBoxSizer"	) \
	x(ListControlNode)	y("ListControl"	) \
	x(Object)				y("Object"			) \
	x(LogoObject)			y("LogoObject"		) \

#define ErrorMessages(x)		\
	x(Out_of_Mem)					\
	x(Stack_Overflow)				\
	x(Security_MemSize)			\
	x(Security_Nodes)

#define declare_Object(x)	_##x,
#define declare_Object2(x)	type_##x,
#define declare_ObjectMsg(x)	ErrorMessage_##x,
#define UNUSED(y)

extern Export ObjectP 
	Permanent_Objects (declare_Object) 
	Permanent_Objects2(declare_Object)
	ErrorMessages     (declare_ObjectMsg)
	Node_Type_Strings (declare_Object2, UNUSED) _;

extern LineP _Not_Enough_node;

extern void init(void);
