#ifndef Node_included
	#include "Node.h"
#endif

#ifndef Int16Array_included

struct Int16ArrayStruct
{
	int length, origin;
	int16P data;
};

typedef Int16ArrayStruct *Int16ArrayStructP;

class Int16Array: public Node // is an int array with a length and an origin.
{
	int _length, _origin;
	int16P _data;

	public:
		union {ObjectType flag; ObjectBits bit; int tint;};

		static const Int16Array aInt16Array;

		operator_new;
		Int16Array(): Node(INT16ARRAY), _length(0), _origin(0), _data(0) {}
		Int16Array(int length_, int origin_=1);
		Int16Array(Int16ArrayP array_);
		void free();

		DataInputStream &read(DataInputStream &istr);
		wxDataOutputStream &write(wxDataOutputStream &ostr);

		NodeP copy(PtrToInt_ &ptrToInt);

		StringP string();
		void print(FILEP strm, int &width, int depth, int noBrackets=0, int noSpacers=0);
		void printBin(FILEP strm);
		NodeP contentsTree(	wxArrayString &namearr, 
									wxArrayString &valarr, 
									wxArrayPtrVoid &objarr, 
									ObjectType want, 
									ObjectType dont, 
									ObjectType must, 
									int &count, int level);
		bool expanded() {return bit.table_expand;}
		bool expandable() {return true;}
		void setExpanded(bool state) {bit.table_expand=state;}

		OPERATORS_DECL
		NodeP compare(NodeP nd);
		int count();
		int _sizeof();
		StringP _typeof();
		bool equalP(NodeP b);
		NodeP first_();
		NodeP butFirst();
		NodeP last();
		NodeP butLast();
		NodeP fPut(NodeP nd);
		NodeP lPut(NodeP nd);
		double _min(double d);
		double _max(double d);
		NodeP Norm();
		NodeP maxNorm();
		NodeP resize(int newsize);
		NodeP lowPassFilter(double weight);
		NodeP saturateAbove(double limit);
		NodeP saturateBelow(double limit);
		NodeP item(int index);
		NodeP item(NodeP index, NodeP result);
		NodeP items(NodeP start, NodeP end);
		NodeP setitem(NodeP index, NodeP newitem, bool safe);
		NodeP memberP(NodeP subobj, bool notp=false, bool substr=false);
		NodeP setitems(NodeP start, NodeP newitems);
		NodeP reverse();
		NodeP rotate(int places);
		NodeP shuffle();
		PairP list();
		ArrayP array(int origin=1);
		IntArrayP intarray(int origin=1);
		Int16ArrayP int16array(int origin=1);
		FloatArrayP floatarray(int origin=1);
		StringP tochar();
		void combSortInPlace();
		NodeP combSort();
		NodeP readbin(FileP file);

		 int length() {return _length;}
		 int origin() {return _origin;}
		int16P data() {return _data;}
		void setorigin(int origin_) {_origin=origin_;}

	friend NodeP lDynamicLibraryCall(PairPP arg);
};

	#define Int16Array_included
#endif
