#include "stdafx.h"
//___________________________________________________________________
//
//                         Class IntToPtr_
//
//                           Definitions
//___________________________________________________________________

#ifdef WIN32
	#include <crtdbg.h>
#endif

#include "Main.h"
#include "GC.h"
#include "IntToPtr_.h"

#ifdef _DEBUG
	#undef THIS_FILE
	static char THIS_FILE[]= __FILE__;
	#define new new(_NORMAL_BLOCK, THIS_FILE, __LINE__)

	#define  calloc(n, m)	 _calloc_dbg((n), (m),   _NORMAL_BLOCK, __FILE__, __LINE__)
#endif

IntToPtr_::IntToPtr_(int size_):
	size(0), nr(0)
{
	data = (PtrIntPairP*)(GC_::calloc(size_, sizeof(PtrIntPairP)));
	if (data)
		size=size_;
}

IntToPtr_::~IntToPtr_()
{
	for (int i=0; i < size; i++)
	{	if (data[i])
			delete data[i];
	}
	GC_::free(data); data=0;
}

int IntToPtr_::hash(int i)
{
	unsigned int index = (unsigned int)i;
	if (size)
		index %= size;
	else
		index=0;
	return index;
}

void *IntToPtr_::find(int i)
{
	PtrIntPairP obj;
	for (obj=data[hash(i)];  obj;  obj=obj->tail)
		if (obj->i==i)
			return obj->p;
	return 0;
}

IntToPtr_::PtrIntPairP IntToPtr_::findPair(int i)
{
	PtrIntPairP obj;
	for (obj=data[hash(i)];  obj;  obj=obj->tail)
		if (obj->i==i)
			return obj;
	return 0;
}

void IntToPtr_::insert(void *p)
{
	nr++;
	PtrIntPairP &obj=data[hash(nr)];
	obj = new PtrIntPair(p, nr, obj);
}
