//___________________________________________________________________
//
//                         ListControl Header
//___________________________________________________________________

#ifndef WINDOWNODE
	#include "Window.h"
#endif

extern Function 
	lListControl, lListControlDestroy,
	lListControlInsertColumn,
	lListControlInsertItem, 
	lListControlSetItem, lListControlGetItem, lListControlDeleteItem, 
	lListControlSetRow, lListControlSetColumn, lListControlSet, 
	lListControlGetRow, lListControlGetColumn, lListControlGet, 
	lListControlItemCount, lListControlColumnCount,
	lListControlColumn, lListControlRow, lListControlText,
	lListControlSort,
	lListControlSetBackgroundColor, lListControlSetColor,
	lListControlSetFontSize, lListControlSetFontName,
	lListControlSetFontStyle, lListControlSetFontWeight,
	lListControlOnChar, lListControlOnKeyDown, lListControlOnKeyUp,
	lListControlOnItemSelected, lListControlOnItemActivated,
	lListControlOnColClick,
	lListControlEnable;

class wxStaticText;
class wxListEvent;
class MyListControl;

#define LISTCONTROL_EVENTS(x)					\
	x(ItemSelected) x(ItemActivated)	\
	x(ColClick) x(ColEndDrag)

class ListControl: public wxControl
{
	public:
		wxStaticText *label;
		MyListControl *listControl;
		wxSize bestSize;
		enum Data
		{	WINDOW_DATA,
			LISTCONTROL_EVENTS(WINDOW_MAKE_DATA_ON)	
			dataCount
		};
		NodeP data[dataCount];

		static int vmt;

		virtual NodePP d(int i) {return &data[i];}

		ListControl(wxWindow *parent);
		ListControl(ListControlNodeP listControlNode_, int style);
		ListControl(ListControlNodeP listControlNode_,
			wxWindow* parent, wxWindowID id, 
			PairP onItemSelect_=PairP(0),
			PairP onItemActivated_=PairP(0),
			PairP onColClick_=PairP(0),
			const wxPoint& pos=wxDefaultPosition, 
			const wxSize& size=wxDefaultSize, 
			long style = 0, 
			const wxValidator& validator = wxDefaultValidator, 
			const wxString& name = _("ListControl"));

		bool create(wxWindow* parent, wxWindowID id, 
			const wxPoint& pos, 
			const wxSize& size, 
			long style, 
			const wxValidator& validator, 
			const wxString& name);

		~ListControl();

		virtual void DoSetSize(int x, int y, int width, int height,
						   int sizeFlags = wxSIZE_AUTO);

		virtual wxSize DoGetBestSize();

		virtual void 
			OnItemSelected	(wxListEvent &event),
			OnItemActivated(wxListEvent &event),
			OnColClick		(wxListEvent &event),
			OnChar	(wxKeyEvent &event),
			OnKeyDown(wxKeyEvent &event),
			OnKeyUp	(wxKeyEvent &event);

		virtual wxString wxstring();
		virtual DataInputStream &read(DataInputStream &istr);
		virtual wxDataOutputStream &write(wxDataOutputStream &ostr);

		virtual bool SetBackgroundColour(const wxColour& colour);
		virtual bool SetForegroundColour(const wxColour& colour);
		virtual bool SetFont(const wxFont& font);

		DECLARE_EVENT_TABLE()
};
typedef ListControl *ListControlP;

class ListControlNode: public WindowNode
{
	public:
		ListControlP &listControl;
		int style;

		static const ListControlNode aListControlNode;

		operator_new;
		WINDOW_EVENTS(WINDOW_MAKE_NODE_ON)	
		LISTCONTROL_EVENTS(WINDOW_MAKE_NODE_ON)	

		ListControlNode();
		ListControlNode(WindowNodeP parent_);

		void free();

		void inc_gc();
		int youngs();
		int youngsPtr(PtrToInt_ &ptrToInt);
		void check_oldyoungs();
		
		DataInputStream &read(DataInputStream &istr);
		wxDataOutputStream &write(wxDataOutputStream &ostr);
		void setPtrs(IntToPtr_ &intToPtr);
		void recreate();

		StringP string();
		wxString wxstring();
		void print(FILEP strm, int &width, int depth, int noBrackets=0, int noSpacers=0);
		StringP _typeof();
};
