#include "stdafx.h"
#include <wx/dynlib.h>
#include <wx/wfstream.h>
#include <wx/datstrm.h>
#include <wx/txtstrm.h>
#include <wx/slider.h>
#include <wx/button.h>
#include <wx/radiobut.h>
#include <wx/checkbox.h>
#include <wx/tglbtn.h>
#include <wx/stattext.h>
#include <wx/textctrl.h>
#include <wx/frame.h>
#include <wx/sizer.h>
#include <wx/filename.h>

#include <limits>

#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <stdarg.h>
#include <ctype.h>
#include <string.h>
#include <signal.h>

#include <m_apm.h>

#include "spinctld.h"
#include "spinctli.h"

#include "Main.h"

#include "Segment.h"
#include "String.h"
#include "Float.h"
#include "Complex.h"
#include "BigFloat.h"
#include "File.h"
#include "Pair.h"
#include "Procedure.h"
#include "Primitive.h"
#include "IntNodeTable.h"
#include "Compiled.h"
#include "Object.h"
#include "Table.h"
#include "PtrTable.h"
#include "LogoObject.h"
#include "Struct.h"
#include "Line.h"
#include "RunLine.h"
#include "List.h"
#include "Quote.h"
#include "Colon.h"
#include "Runparsed.h"
#include "Tree.h"
#include "WindowPair.h"
#include "Int.h"
#include "Int16.h"
#include "Int8.h"
#include "UInt8.h"
#include "Array.h"
#include "IntArray.h"
#include "Int16Array.h"
#include "Int8Array.h"
#include "UInt8Array.h"
#include "FloatArray.h"
#include "ComplexArray.h"
#include "Slider.h"
#include "Gauge.h"
#include "IntControl.h"
#include "FloatControl.h"
#include "Button.h"
#include "ToggleButton.h"
#include "CheckBox.h"
#include "RadioButton.h"
#include "Window.h"
#include "Frame.h"
#include "StaticText.h"
#include "TextControl.h"
#include "ListBox.h"
#include "ChoiceBox.h"
#include "ComboBox.h"
#include "ListControl.h"
#include "BoxSizer.h"
#include "StaticBoxSizer.h"

#include "Point.h"
#include "Color.h"
#include "Bitmap.h"
#include "Texture.h"
#include "TurtleNode.h"
#include "GraphicNode.h"
#include "DL.h"

#include "IntToPtr_.h"
#include "PtrToInt_.h"

#include "StringToPtr.h"
#include "PtrToString.h"

#include "Error.h"
#include "Eval.h"
#include "Stack.h"
#include "NodePStack.h"
#include "Init.h"
#include "Mem.h"

#include "Console.h"
#include "Consolew.h"
#include "Graph.h"
#include "MainFrame.h"
#include "MemoryWindow.h"
#include "LogoApp.h"
#include "Security.h"
#include "Thread.h"

#undef min
#undef max


#ifdef _DEBUG_rubbish
extern char *eat_mem_mem;

inline void *__cdecl operator new(size_t size)
{
	void *mem=0;
	try
	{	mem=::operator new(size, _NORMAL_BLOCK, __FILE__, __LINE__);
		ThreadP th=Thread::This();
		if (th)
		{	int size=_msize(mem);
		th->memsize+= size? ((size-1) & GC_::MemBlockMask)+GC_::MemBlockSize : GC_::MemBlockSize;
		}
	}
	catch(...)
	{	free(eat_mem_mem);
		throw;
	}
	return mem;
}

inline void __cdecl operator delete(void *mem)
{
	ThreadP th=Thread::This();
	if (th)
	{	int size=_msize(mem);
		th->memsize-= size? ((size-1) & GC_::MemBlockMask)+GC_::MemBlockSize : GC_::MemBlockSize;
	}
	::operator delete(mem);
}
#endif


#ifdef WIN32
	#include <crtdbg.h>
	#include <direct.h>
#else
	#include <unistd.h>
#endif


#ifdef _DEBUG
	#undef THIS_FILE
	static char THIS_FILE[]= __FILE__;
	#define new new(_NORMAL_BLOCK, THIS_FILE, __LINE__)

	#define  malloc(m)       _malloc_dbg((m),        _NORMAL_BLOCK, __FILE__, __LINE__)
	#define  calloc(n, m)	 _calloc_dbg((n), (m),   _NORMAL_BLOCK, __FILE__, __LINE__)
#endif

#ifdef PTR_DEBUG
	#include "PtrDebug.cpp"
#endif

double versionNumber=4.7;

wxString 
	aUCBLogo="aUCBLogo", 
	versionString="4.7", 
	aUCBLogoVersion=aUCBLogo+'-'+versionString+' '+__DATE__;

//___________________________________________________________________
//	The following macro section is quite ugly. 
//	I don`t know a better way of doing this now.  :-(

#define Node_Classes(x)												\
	x(Node)																\
	x(Int) x(Int16) x(Int8) x(UInt8)								\
	x(Float) x(BigFloat) x(Complexd)								\
	x(Array) x(IntArray) x(Int16Array) x(Int8Array)			\
	x(UInt8Array)														\
	x(FloatArray) x(ComplexArray)									\
	x(String)															\
	x(Pair) x(List) x(Quote) x(Line) x(RunLine)				\
	x(Runparsed) x(Tree)												\
	x(Procedure) x(Compiled)										\
	x(Primitive) x(Object) x(LogoObject)						\
	x(Colon)																\
	x(File) x(ToDoNode) x(WindowPair)							\
	x(Table) x(Struct) x(PtrTable)								\
	x(Bitmap) x(Texture) x(TurtleNode) x(GraphicNode)		\
	x(DynamicLibrary)													\
	x(SliderNode) x(FrameNode) x(WindowNode) x(GraphNode)	\
	x(ButtonNode) x(ToggleButtonNode) x(CheckBoxNode)		\
	x(RadioButtonNode) x(GaugeNode)								\
	x(IntControlNode) x(FloatControlNode)						\
	x(StaticTextNode) x(TextControlNode)						\
	x(BoxSizerNode) x(StaticBoxSizerNode)						\
	x(ListBoxNode) x(ChoiceBoxNode) x(ComboBoxNode)			\
	x(ListControlNode) 

#define make_aNode(x)	const x x::a##x;

Node_Classes(make_aNode)

const int 
	Node::vmtNode      = *intP(&Node::aNode),	// get pointer to virtual method table of Node
	Node::vmtPair      = *intP(&Pair::aPair),
	Node::vmtRunparsed = *intP(&Runparsed::aRunparsed),
	Node::vmtTree      = *intP(&Tree::aTree),
	Node::vmtLine      = *intP(&Line::aLine);

#ifdef _DEBUG
	#undef new
	#define new new

	#define newOp_decl	\
		::operator new(size_t nSize, int blocktype, const char* newFilename_, int newLine_)

	#define newOp_debuginfo				\
		n->newFilename=newFilename_;	 \
		n->newLine=newLine_;
#else
	#define newOp_decl	\
		::operator new(size_t s)

	#define newOp_debuginfo
#endif

#define newOp(anything, type_, init)			  \
	newOp_decl												\
	{	union													 \
		{	int* i;											  \
			Node *n; Array *a; ToDoNode *t; File *f;	\
			Pair *p; Quote *q; Colon *c; List *li;		 \
			Runparsed *r; Tree *tr; Line *l;				  \
			Procedure *pr; Compiled *cm;						\
			Object *o; LogoObject *lo;							 \
			Table *tbl; PtrTable *ptb; Struct *strct;		  \
			Texture *tex;											   \
			SliderNode *slider; FrameNode *frame;			    \
			WindowNode *window; WindowPair *wp;					  \
		};															         \
		n=GC_::newnode();										          \
		init;													              \
		*i= *intP(&anything);								            \
		n->type=type_;											             \
		newOp_debuginfo										              \
		if (memoryWindow)													      \
			memoryWindow->updateNode(n);									    \
		return n;																     \
}

#define initArray     { a->_data=0;}
#define initToDo      { t->_tail=0;}
#define initFile      { f->_tail=0; f->_name=0; f->_mode=0;}
#define initPair      { p->_tail= p->_first=0;}
#define initQuote     { q->_tail= q->_first=0; q->_filename=0;}
#define initColon     { c->_tail= c->_first=0; c->_filename=0;}
#define initList      {li->_tail=li->_first=0;}
#define initLine      { l->_tail= l->_first=0; l->_filename=0;}
#define initRunparsed { r->_tail= r->_first=0; r->_filename=0;  r->_parsed=0;}
#define initTree      {tr->_tail=tr->_first=0;tr->_filename=0; tr->_tree=0;}
#define initProcedure {pr->_bodywords=pr->_bodylist=pr->_formals=0;}
#define initCompiled  {cm->_object=0; cm->_assembly=0; cm->links=0; cm->refs=0; cm->code=0; cm->size=0;}
#define initObject    {o->_name=0; o->_tail=0; o->_var=0; o->_table=0; o->_parent=0;}
#define initLogoObject {lo->_proc=0; lo->_table=0; lo->_parents=0;}
#define initTable     {tbl->base=0;}
#define initPtrTable  {ptb->base=0;}
#define initStruct    {strct->base=0; strct->_first=0;}
#define initTexture   {tex->_bitmap=0; tex->_texnr=0;}
#define initSlider    {slider->window=0;}
#define initWindow	 {window->window=0;}
#define initFrame		 {frame->window=0;}
#define initWindowPair {wp->_tail=wp->_first=0;}

void *       Node newOp(aNode,			UNBOUND,    {})
void *        Int newOp(aInt,				INT_,       {})
void *      Int16 newOp(aInt16,			NINT16,      {})
void *       Int8 newOp(aInt8,			NINT8,       {})
void *      UInt8 newOp(aUInt8,			NUINT8,      {})
void *      Float newOp(aFloat,			FLOAT_,     {})
void *   BigFloat newOp(aBigFloat,		BIGFLOAT,   {})
void *   Complexd newOp(aComplexd,		COMPLEX,    {})
void *  Primitive newOp(aPrimitive,		PRIM,       {})
void *     String newOp(aString,			STRING,     {})
void *     Bitmap newOp(aBitmap,			BITMAP_,    {})
void *    Texture newOp(aTexture,		TEXTURE,    initTexture)
void * TurtleNode newOp(aTurtleNode,	TURTLE_,    {})
void *GraphicNode newOp(aGraphicNode,	GRAPHIC,    {})
void *DynamicLibrary newOp(aDynamicLibrary, DYNAMIC_LIB, {})
void *      Array newOp(aArray,			ARRAY,      initArray)
void *   IntArray newOp(aIntArray,		INTARRAY,   {})
void * Int16Array newOp(aInt16Array,	INT16ARRAY, {})
void *  Int8Array newOp(aInt8Array,		INT8ARRAY,	{})
void * UInt8Array newOp(aUInt8Array,	UINT8ARRAY,	{})
void * FloatArray newOp(aFloatArray,	FLOATARRAY, {})
void *ComplexArray newOp(aComplexArray,COMPLEXARRAY, {})
void *   ToDoNode newOp(aToDoNode,		TODO,       initToDo)
void *       File newOp(aFile,			FILE_,      initFile)
void *       Pair newOp(aPair,			PAIR,       initPair)
void *      Quote newOp(aQuote,			QUOTE,      initQuote)
void *      Colon newOp(aColon,			COLON,      initColon)
void *       List newOp(aList,			PAIR,			initList)	
// ...will set type to PAIR; only constructor is different from Pair
void *       Line newOp(aLine,			LINE,       initLine)
void *    RunLine newOp(aRunLine,		RUNLINE,    initLine)
void *  Runparsed newOp(aRunparsed,		RUNPARSED,  initRunparsed)
void *       Tree newOp(aTree,			TREE,       initTree)
void * WindowPair newOp(aWindowPair,	WINDOWPAIR, initWindowPair)
void *  Procedure newOp(aProcedure,		PROC_,      initProcedure)
void *   Compiled newOp(aCompiled,		COMPILED,   initCompiled)
void *     Object newOp(aObject,			OBJECT,     initObject)
void * LogoObject newOp(aLogoObject,	LOGOOBJECT, initLogoObject)
void *      Table newOp(aTable,			TABLE,      initTable)
void *   PtrTable newOp(aPtrTable,		PTRTABLE,   initPtrTable)
void *     Struct newOp(aStruct,			STRUCT,     initStruct)
void * SliderNode newOp(aSliderNode,	SLIDER,		initSlider)
void * WindowNode newOp(aWindowNode,	WINDOW,		initWindow)
void *  FrameNode newOp(aFrameNode,		FRAME,		initFrame)
void *  GraphNode newOp(aGraphNode,		GRAPH,		{})
void * ButtonNode newOp(aButtonNode,	BUTTON,		{})
void *ToggleButtonNode newOp(aToggleButtonNode,	TOGGLEBUTTON,	{})
void *	 CheckBoxNode newOp(aCheckBoxNode	 ,     CHECKBOX,	{})
void * RadioButtonNode newOp(aRadioButtonNode ,  RADIOBUTTON,	{})
void *		 GaugeNode newOp(aGaugeNode		 ,			 GAUGE,	{})
void *  IntControlNode newOp(aIntControlNode	 ,	  INTCONTROL,	{})
void *FloatControlNode newOp(aFloatControlNode,	FLOATCONTROL,	{})
void *  StaticTextNode newOp(aStaticTextNode	 ,	  STATICTEXT,	{})
void * TextControlNode newOp(aTextControlNode ,	 TEXTCONTROL,	{})
void *     ListBoxNode newOp(aListBoxNode		 ,	     LISTBOX,	{})
void *   ChoiceBoxNode newOp(aChoiceBoxNode	 ,	   CHOICEBOX,	{})
void *    ComboBoxNode newOp(aComboBoxNode	 ,	    COMBOBOX,	{})
void * ListControlNode newOp(aListControlNode ,	 LISTCONTROL,	{})
void *	 BoxSizerNode newOp(aBoxSizerNode	 ,		 BOXSIZER,	{})
void *StaticBoxSizerNode newOp(aStaticBoxSizerNode, STATICBOXSIZER,	{})

#ifdef _DEBUG
	#undef new
	#define new new(_NORMAL_BLOCK, THIS_FILE, __LINE__)
#endif

#define Window_Classes(x)						\
	x(Window_) x(Frame)							\
	x(Button) x(ToggleButton) x(CheckBox)	\
	x(RadioButton)									\
	x(Slider)										\
	x(IntControl) x(FloatControl)				\
	x(StaticText) 

#define All_Window_Classes(x)			\
	Window_Classes(x)						\
	x(ChoiceBox) x(Gauge) x(Graph)	\
	x(ListBox_) x(ComboBox)				\
	x(ListControl) 						\
	x(TextControl)	

#define make_vmt(x)	int x::vmt=0;

All_Window_Classes(make_vmt)

#define make_default_ctor(x)			\
x::x(wxWindow *parent)					\
{	for (int i=0; i<dataCount; i++)	\
		data[i]=0;							\
}

Window_Classes(make_default_ctor)

#define init_vmt(x)	{x *win=new x(frame); win->vmt=*(int*)win; delete win;}

void initWindowClasses()
{
	wxFrame *frame=new wxFrame(0, wxID_ANY, 
		aUCBLogo+_("initWindowClasses"), 
		wxDefaultPosition, wxSize(0,0), wxNO_BORDER);
	All_Window_Classes(init_vmt)
	delete frame;
}

#define KIND_of_window(x) (*(int*)window==*(int*)&x::vmt) ||

bool isLogoWindow(wxWindow *window)
{
	if (!window)
		return false;
	if (All_Window_Classes(KIND_of_window) false) 
		return true;
	return false;
}

//_____________________End of ugly macro section_____________________

DataInputStream &IntToPtr_::readNodes(DataInputStream &istr)
{
	GC_::disabled=true;
	int k=0;
	while (!istr.Eof())
	{	int i;
		istr >> i;
		if (istr.Eof())
			break;
/*		if (!istr.CanRead()) 
		{	//error(FILE_ERROR, new String(
			//	_("File bad format or some strange bug in Recorder::load")));
			return istr;
		}
*/		NodeType t=NodeType(i);
		NodeP n;
		switch(t)
		{

		case UNBOUND:		n=Unbound;					break;//
		case SPARE_NODE:	n=new Node;					break;//
//		case BACKSLASHED:
//		case VBAR_STRING:	
		case STRING:		n=new String;				break;//
		case INT_:			n=new Int;					break;//
		case FLOAT_:		n=new Float;				break;//
		case BIGFLOAT:		n=new BigFloat;			break;//
		case COMPLEX:		n=new Complexd;			break;//
		case NINT16:		n=new Int16;				break;//
		case NINT8:			n=new Int8;					break;//
		case NUINT8:		n=new UInt8;				break;//
		case QUOTE:			n=new Quote;				break;//
		case COLON:			n=new Colon;				break;//
		case OBJECT:		n=new Object;				break;//
		case PAIR:			n=new Pair;					break;//
		case WINDOWPAIR:	n=new WindowPair;			break;//
		case LINE:			n=new Line;					break;//
		case RUNLINE:		n=new RunLine;				break;//
		case RUNPARSED:	n=new Runparsed;			break;//
		case TREE:			n=new Tree;					break;//
		case TODO:			n=new ToDoNode;			break;//
		case FILE_:			n=new File;					break;//
		case PROC_:
		case INFIXPROC:	n=new Procedure;			break;//
		case COMPILED:		n=new Compiled;			break;//
		case ARRAY:			n=new Array;				break;//
		case BITMAP_:		n=new Bitmap;				break;//
		case TEXTURE:		n=new Texture;				break;//
		case TURTLE_:		n=new TurtleNode;			break;//
		case TABLE:			n=new Table;				break;//
		case PTRTABLE:		n=new PtrTable;			break;//
		case STRUCT:		n=new Struct;				break;//
		case GRAPHIC:		n=new GraphicNode;		break;//
		case DYNAMIC_LIB:	n=new DynamicLibrary;	break;//
		case INTARRAY:		n=new IntArray;			break;//
		case INT16ARRAY:	n=new Int16Array;			break;//
		case INT8ARRAY:	n=new Int8Array;			break;//
		case UINT8ARRAY:	n=new UInt8Array;			break;//
		case FLOATARRAY:	n=new FloatArray;			break;//
		case COMPLEXARRAY:n=new ComplexArray;		break;//
		case SLIDER:		n=new SliderNode;			break;//
		case GAUGE:			n=new GaugeNode;			break;//
		case INTCONTROL:	n=new IntControlNode;	break;//
		case FLOATCONTROL:n=new FloatControlNode;	break;//
		case WINDOW:		n=new WindowNode;			break;//
		case FRAME:			n=new FrameNode;			break;//
		case GRAPH:			n=new GraphNode;			break;//
		case BUTTON:		n=new ButtonNode;			break;//
		case TOGGLEBUTTON:n=new ToggleButtonNode;	break;//
		case CHECKBOX:		n=new CheckBoxNode;		break;//
		case RADIOBUTTON:	n=new RadioButtonNode;	break;//
		case STATICTEXT:	n=new StaticTextNode;	break;//
		case TEXTCONTROL:	n=new TextControlNode;	break;//
		case LISTBOX:		n=new ListBoxNode;		break;//
		case CHOICEBOX:	n=new ChoiceBoxNode;		break;//
		case COMBOBOX:		n=new ComboBoxNode;		break;//
		case LISTCONTROL:	n=new ListControlNode;	break;//
		case BOXSIZER:		n=new BoxSizerNode;		break;//
		case STATICBOXSIZER:	n=new StaticBoxSizerNode;	break;//
		case PRIM:
		case MACRO:
		case TAILFORM:
		case INFIX:			n=new Primitive;			break;//
		default: 
//			_pause(0);
					n=new Node;	// should never be reached if file format is correct!
					t=PNIL;
		}
		if throwing return istr;	// this is probably fatal
		if (t==PNIL)
			break;
		n->type=t;
		n->read(istr);
		insert(n);
		k++;
	}
	int i;
	for (i=0; i < size; i++)
	{	PtrIntPairP obj;
		for (obj=data[i];  obj;  obj=obj->tail)
			if (obj && obj->p) 
				((Node*)(obj->p))->setPtrs(*this);
	}
	for (i=0; i < size; i++)
	{	PtrIntPairP obj;
		for (obj=data[i];  obj;  obj=obj->tail)
			if (obj && obj->p) 
				((Node*)(obj->p))->aftersetPtrs();
	}
	for (i=0; i < size; i++)
	{	PtrIntPairP obj;
		for (obj=data[i];  obj;  obj=obj->tail)
			if (obj && obj->p) 
				((Node*)(obj->p))->aftersetPtrs2();
	}
	for (i=0; i < size; i++)
	{	PtrIntPairP obj;
		for (obj=data[i];  obj;  obj=obj->tail)
			if (obj && obj->p) 
				((Node*)(obj->p))->aftersetPtrs3();
	}
	GC_::disabled=false;
	return istr;
}

#ifdef WIN32
	#define PUSH(i)	__asm push i
#else
	#define PUSH(i)
#endif

#pragma optimize("",off)

NodeP lDynamicLibraryCall(PairPP arg)
{
	ThreadP th=Thread::This();
	if (!th->security->dlcall)
	{	error(SECURITY_ERROR, new String(_("to use DynamicLibraryCall"))); return Unbound;
	}
	wxDynamicLibrary *dl=arg[1]->a_dynamicLibrary(1);
	if throwing return Unbound;
	StringP symbol=arg[2]->a_stringex(2);
	if throwing return Unbound;
	PairP list=arg[3]->a_list(3), l=list;
	if throwing return Unbound;
	if (!list)
	{	error(BAD_DATA, list, 3);
		return Unbound;
	}
	if (!dl->HasSymbol(symbol->ptr()))
	{	error(BAD_DATA, symbol, 2);
		return Unbound;
	}
	void *function=dl->GetSymbol(symbol->ptr());

	ObjectP ret=0;
	if (l->first())
		ret=l->first()->intern();
	else
		ret=_Void;
	if (!ret)
	{	error(BAD_DATA, NodeP(ret), 3); return Unbound;
	}
	next(l);
	if (l && l->count() % 3)
	{	error(BAD_DATA, list, 3); return Unbound;
	}
	if (l)
		l=PairP(l->reverse());
	NodeP t=0, n=0, third=0, n3=0;
	int type, i;
	bool ptr;

	int i32;
	int16 i16;
	char i8;
	unsigned char ui8;
	double d;
	complexd c;
	IntArrayStructP i32ap;
	IntArrayP i32a;
	Int16ArrayStructP i16ap;
	Int16ArrayP i16a;
	FloatArrayStructP fap;
	FloatArrayP fa;
	ComplexArrayStructP cap;
	ComplexArrayP ca;
	BitmapStructP bm;

	while (l && l->tail() && l->tail()->tail())
	{
		t=l->second()->intern(); n=t;
		third=l->first(); n3=third;
		if (!n3)
			n3=_Null_Word;

		ptr=false;

		if (t==_Int)
		{	n3=n3->_int();			type=INT_;
		}else if (t==_Int16)
		{	n3=n3->toint16();		type=NINT16;
		}else if (t==_Int8)
		{	n3=n3->toint8();		type=NINT8;
		}else if (t==_UInt8)
		{	n3=n3->touint8();		type=NUINT8;
		}else if (t==_Float)
		{	n3=n3->_float();		type=FLOAT_;
		}else if (t==_Complex_)
		{	n3=n3->tocomplex();	type=COMPLEX;
		}else if (t==_IntPtr)
		{	n3=n3->_int();			type=INT_;		ptr=true;
		}else if (t==_Int16Ptr)
		{	n3=n3->toint16();		type=NINT16;	ptr=true;
		}else if (t==_Int8Ptr)
		{	n3=n3->toint8();		type=NINT8;		ptr=true;
		}else if (t==_UInt8Ptr)
		{	n3=n3->touint8();		type=NUINT8;	ptr=true;
		}else if (t==_FloatPtr)
		{	n3=n3->_float();		type=FLOAT_;	ptr=true;
		}else if (t==_ComplexPtr)
		{	n3=n3->tocomplex();	type=COMPLEX;	ptr=true;
		}else if (t==_Word_)
		{	if (n3->type!=STRING)
				n3=n3->string();
										type=STRING;
		}else if (t==_IntArray_)
		{	if (n3->type!=INTARRAY)
				n3=n3->intarray();
										type=INTARRAY;
		}else if (t==_Int16Array_)
		{	if (n3->type!=INT16ARRAY)
				n3=n3->int16array();
										type=INT16ARRAY;
		}else if (t==_Int8Array_)
		{	if (n3->type!=INT8ARRAY)
				n3=n3->int8array();
										type=INT8ARRAY;
		}else if (t==_UInt8Array_)
		{	if (n3->type!=UINT8ARRAY)
				n3=n3->uint8array();
										type=UINT8ARRAY;
		}else if (t==_FloatArray_)
		{	if (n3->type!=FLOATARRAY)
				n3=n3->floatarray();	
										type=FLOATARRAY;
		}else if (t==_ComplexArray_)
		{	if (n3->type!=COMPLEXARRAY)
				n3=n3->complexarray();	
										type=COMPLEXARRAY;
		}else if (t==_Bitmap)
		{	if (n3->type!=BITMAP_)
			{	error(BAD_DATA, t, 3);	return Unbound;
			}
			type=BITMAP_;ptr=true;
		}else if (t==_NodePtr)
		{	type=NTFREE;	// special meaning: general NodeP parameter.
		}else if (t==_Bool)
		{	type=OBJECT;
		}else
		{	error(BAD_DATA, t, 3);	return Unbound;
		}
		if (n3->type != type && !(type==STRING && n3->is.string))
		{	error(BAD_DATA, third, 3); return Unbound;
		}
		if (n3->type==INT_) 
		{	if (ptr)
			{	i=(int)&IntP(n3)->int_;				PUSH(i);
			}else
			{	i=IntP(n3)->int_;						PUSH(i);
			}
		}else if (n3->type==NINT16) 
		{	if (ptr)
			{	i=(int)&Int16P(n3)->int_;			PUSH(i);
			}else
			{	i=Int16P(n3)->int_;					PUSH(i);
			}
		}else if (n3->type==NINT8) 
		{	if (ptr)
			{	i=(int)&Int8P(n3)->int_;			PUSH(i);
			}else
			{	i=Int8P(n3)->int_;					PUSH(i);
			}
		}else if (n3->type==NUINT8) 
		{	if (ptr)
			{	i=(int)&UInt8P(n3)->int_;			PUSH(i);
			}else
			{	i=UInt8P(n3)->int_;					PUSH(i);
			}
		}else if (n3->type==FLOAT_) 
		{	if (ptr)
			{	i=(int)&FloatP(n3)->float_;		PUSH(i);
			}else
			{	i=*(intP(&FloatP(n3)->float_)+1);PUSH(i);
				i=*intP(&FloatP(n3)->float_);		PUSH(i);
			}
		}else if (n3->type==COMPLEX) 
		{	if (ptr)
			{	i=(int)&ComplexdP(n3)->complex_;	PUSH(i);
			}else
			{	i=*(intP(&ComplexdP(n3)->complex_)+3);	PUSH(i);
				i=*(intP(&ComplexdP(n3)->complex_)+2);	PUSH(i);
				i=*(intP(&ComplexdP(n3)->complex_)+1);	PUSH(i);
				i=*(intP(&ComplexdP(n3)->complex_)  );	PUSH(i);
			}
		}else if (n3->is.string) 
		{	i=int(StringP(n3)->ptr());				PUSH(i);
		}else if (n3->type==INTARRAY) 
		{	i=int(IntArrayP(n3)->data());			PUSH(i);
		}else if (n3->type==INT16ARRAY) 
		{	i=int(Int16ArrayP(n3)->data());		PUSH(i);
		}else if (n3->type==INT8ARRAY) 
		{	i=int(Int8ArrayP(n3)->data());		PUSH(i);
		}else if (n3->type==UINT8ARRAY) 
		{	i=int(UInt8ArrayP(n3)->data());		PUSH(i);
		}else if (n3->type==FLOATARRAY) 
		{	i=int(FloatArrayP(n3)->data());		PUSH(i);
		}else if (n3->type==COMPLEXARRAY) 
		{	i=int(ComplexArrayP(n3)->data());		PUSH(i);
		}else if (n3->type==BITMAP_) 
		{	i=int(&(BitmapP(n3)->width));			PUSH(i);
		}else if (n3->type==NTFREE) 
		{	i=int(n3);									PUSH(i);
		}else if (n3->type==OBJECT) 
		{	if (n3==_True)
				i=1;
			else
				i=0;
															PUSH(i);
		}else
		{	error(BAD_DATA, third, 3);	return Unbound;
		}
		l=l->tail()->tail()->tail();
	}

	if (ret==_Int)
	{	i32 = (*(int(__cdecl*)())function)();	
		return new Int(i32);
	}else if (ret==_Int16)
	{	i16 = (*(int16(__cdecl*)())function)();
		return new Int16(i16);
	}else if (ret==_Int8)
	{	i8 = (*(char(__cdecl*)())function)();
		return new Int8(i8);
	}else if (ret==_UInt8)
	{	ui8 = (*(unsigned char(__cdecl*)())function)();
		return new UInt8(ui8);
	}else if (ret==_Float)
	{	d = (*(double(__cdecl*)())function)();
		return new Float(d);
	}else if (ret==_Complex_)
	{	c = (*(complexd(__cdecl*)())function)();
		return new Complexd(c);
	}else if (ret==_IntArray_)
	{	i32ap = (*(IntArrayStructP(__cdecl*)())function)();
		i32a=new IntArray();
		if throwing return Unbound;
		i32a->_length=i32ap->length;
		i32a->_origin=i32ap->origin;
		i32a->_data=i32ap->data;
		return i32a;
	}else if (ret==_Int16Array_)
	{	i16ap = (*(Int16ArrayStructP(__cdecl*)())function)();
		i16a=new Int16Array();
		if throwing return Unbound;
		i16a->_length=i16ap->length;
		i16a->_origin=i16ap->origin;
		i16a->_data=i16ap->data;
		return i16a;
	}else if (ret==_FloatArray_)
	{	fap = (*(FloatArrayStructP(__cdecl*)())function)();
		fa=new FloatArray();
		if throwing return Unbound;
		fa->_length=fap->length;
		fa->_origin=fap->origin;
		fa->_data=fap->data;
		return fa;
	}else if (ret==_ComplexArray_)
	{	cap = (*(ComplexArrayStructP(__cdecl*)())function)();
		ca=new ComplexArray();
		if throwing return Unbound;
		ca->_length=cap->length;
		ca->_origin=cap->origin;
		ca->_data=cap->data;
		return ca;
	}else if (ret==_Bitmap)
	{	bm = (*(BitmapStructP(__cdecl*)())function)();
		return new Bitmap(bm->width, bm->height, bm->winx, bm->winy, bm->pixels);
	}else if (ret==_Word_)
	{	charP i = (*(charP(__cdecl*)())function)();
		if (!i)
			return _Null_Word;
		return new String(i);
	}else if (ret==_Void)
	{	(*(void(__cdecl*)())function)();
		return Unbound;
	}else if (ret==_Bool)
	{	bool i = (*(bool(__cdecl*)())function)();
		return Node::boolnode(i);
	}else
	{	error(BAD_DATA, ret, 3);	return Unbound;
	}
}

#pragma optimize("",on)

bool checkThrowing() 
{	ThreadP th=Thread::This();
	return th->checkBreak() || throwing;
}
void push(PairP &stack, NodeP obj) 
{	stack = new Pair(obj, stack);
}

void Var::mark() {object->mark(); val->mark();}
void Var::markPtr(PtrToInt_ &ptrToInt) 
{	if (object)
		object->markPtr(ptrToInt); 
	if (val)
		val->markPtr(ptrToInt);
}
void ErrorStruct::mark() 
{	fun->mark();  ufun->mark();  this_line->mark();
}
void ErrorStruct::markPtr(PtrToInt_ &ptrToInt) 
{	fun->markPtr(ptrToInt);  
	ufun->markPtr(ptrToInt);  
	this_line->markPtr(ptrToInt);
}

void __cdecl logo_stop(int)
{
	if (GC_::is_running) 
		GC_::interrupt=GC_::stop;
	else
	{	Thread::This()->toPending=0;
		error(STOP_ERROR, 0);
		signal(SIGINT, logo_stop);
		File::unblockInput();
	}
}

void __cdecl logo_pause(int)
{
	if (GC_::is_running) 
		GC_::interrupt=GC_::pause;
	else 
	{	Thread::This()->toPending=0;
		signal(SIGABRT, logo_pause);
		lpause(PairPP(Thread::This()->argStack->index));
	}
}

#define Create_typeof(x) \
	StringP  x::_typeof() {return type_##x ->name();}

Node_Type_Strings(Create_typeof, UNUSED)

//StringP Object::_typeof() {return _name->_typeof();}

//___________________________________________________________________

const unsigned char 
	UInt8::max = (uint8)(-1),
	UInt8::min =-UInt8::max-(uint8)1,
	UInt8::digits = sizeof(unsigned char)*256/100 + 3;

DataInputStream &UInt8::read(DataInputStream &istr)
{	return istr >> int_;
}
wxDataOutputStream &UInt8::write(wxDataOutputStream &ostr)
{	return ostr << type << int_;
}

NodeP UInt8::copy(PtrToInt_ &ptrToInt)
{	return new UInt8(int_);
}

StringP UInt8::string()
{
	char s[digits];
	sprintf(s, "%u", int_);
	return new String(s, 0, strlen(s), STRING, String::copy);
}

void UInt8::print(FILEP strm, int &width, int depth, int noBrackets, int noSpacers)
{
	::print(strm, width, int_);
}

void UInt8::printBin(FILEP strm) 
{
	::printBin(strm, int_);
}
//___________________________________________________________________

#ifdef WIN32
	#pragma warning(disable: 4096)
#endif

List::List(NodeP first_, ...)
{
	if (first_==_ListEnd) return;
	setfirst(first_);

	va_list args;
	va_start(args, first_);
	NodeP arg;
	PairP lastnode=this;

	while ( (arg=va_arg(args, NodeP )) != _ListEnd ) 
	{
		PairP val = new Pair(arg, 0);
		if throwing return;
		lastnode->settail( val );
		lastnode=val;
	}
	va_end(args);
}

#ifdef WIN32
	#pragma warning(default: 4096)
#endif

List::List(PairP list)	
{
	PairP last;

	if (list)
	{	last=this;
		setfirst( list->first() );
		next(list);
	}
	while (list)
	{	PairP newpair = new Pair(list->first(), 0);
		if throwing return;
		last->settail( newpair );
		last=newpair;
		next(list);
	}
}

//___________________________________________________________________

Quote::Quote()
{	type=QUOTE;
}
Quote::Quote(NodeP node): Line(node, 0, QUOTE) {}

StringP Quote::string()
{
	if (quote())
	{	StringP str = quote()->string();
		str = new String(str->ptr(), 0, str->length()+1, str->type, String::copy_quote);
		return str;
	}
	else
		return _Null_Word->name();
}

void Quote::print(FILEP strm, int &width, int depth, int noBrackets, int noSpacers)
{
	::print(strm, width, '"'); 
	if (first())
		first()->print(strm, width, depth, noBrackets-1, noSpacers-1);
//	::print(strm, width, '\''); 
}

void Quote::printBin(FILEP strm)
{
	int width=Int::max;
	::print(strm, width, '\"'); 
	first()->printBin(strm);
}
//___________________________________________________________________

void Runparsed::setparsed(NodeP nd) 
{	wxASSERT(type==RUNPARSED || type==TREE);
	wxASSERT(*intP(this)==vmtRunparsed || *intP(this)==vmtTree);
	_parsed = RunparsedP(LineP(nd));  
	check_oldyoung(nd);
}

Runparsed::Runparsed()
{
	_first=0;
	_tail=0;
	_parsed=0;
	_filename=0;
	type=RUNPARSED;
}
Runparsed::Runparsed(NodeP first_, NodeP tail_):
Line(first_, tail_, RUNPARSED)
{	_parsed=0;
}
Runparsed::Runparsed(NodeP first_, NodeP tail_, NodeType type_):
Line(first_, tail_, type_)
{ _parsed=0;
}

void Runparsed::inc_gc() 
{	fifo << first() << parsed() << filename() << tail();
}
int Runparsed::youngs() 
{	return gmark(first())+gmark(parsed())+gmark(filename())+gmark(tail());
}
int Runparsed::youngsPtr(PtrToInt_ &ptrToInt) 
{	return 
		gmarkPtr(first(), ptrToInt)
		+gmarkPtr(parsed(), ptrToInt)
		+gmarkPtr(filename(), ptrToInt)
		+gmarkPtr(tail(), ptrToInt);
}
void Runparsed::check_oldyoungs() 
{	check_oldyoung(first()); 
	check_oldyoung(parsed()); 
	check_oldyoung(filename());
	check_oldyoung(tail());
}

void Runparsed::setPtrs(IntToPtr_ &intToPtr)
{	setfirst(  (Node*)intToPtr.find(int(_first  )));
	settail (  (Node*)intToPtr.find(int(_tail   )));
	setfilename((String*)intToPtr.find(int(_filename)));
	setparsed( (Node*)intToPtr.find(int(_parsed)));
}
DataInputStream &Runparsed::read(DataInputStream &istr) 
{	return istr >> (int&)_first >> (int&)_tail 
		>> col >> tcol >> row >> (int&)_filename >> (int&)_parsed;
}
wxDataOutputStream &Runparsed::write(wxDataOutputStream &ostr) 
{	return ostr << type 
		<< GC_::ptrToInt->find(first()) 
		<< GC_::ptrToInt->find(tail())
		<< col << tcol << row
		<< GC_::ptrToInt->find(filename())
		<< GC_::ptrToInt->find(parsed());
}

NodeP Runparsed::copy(PtrToInt_ &ptrToInt)
{
	RunparsedP rp=new Runparsed();
	if throwing return Unbound;
	rp->_tail=PairP(ptrToInt.find(tail()));
	rp->_first=PairP(ptrToInt.find(first()));
	rp->_filename=StringP(ptrToInt.find(filename()));
	rp->_parsed=RunparsedP(ptrToInt.find(parsed()));
	rp->col=col;
	rp->tcol=tcol;
	rp->row=row;
	return rp;
}
//___________________________________________________________________

void Tree::inc_gc() 
{	fifo << first() << filename() << parsed() << tree() << tail();
}

int Tree::youngs() 
{	return gmark(first())
			+gmark(filename())
			+gmark(parsed())
			+gmark(tree())
			+gmark(tail());
}
int Tree::youngsPtr(PtrToInt_ &ptrToInt) 
{	return gmarkPtr(first(), ptrToInt)
			+gmarkPtr(filename(), ptrToInt)
			+gmarkPtr(parsed(), ptrToInt)
			+gmarkPtr(tree(), ptrToInt)
			+gmarkPtr(tail(), ptrToInt);
}
void Tree::check_oldyoungs() 
{	check_oldyoung(first()); 
	check_oldyoung(filename()); 
	check_oldyoung(parsed()); 
	check_oldyoung(tree()); 
	check_oldyoung(tail());
}

void Tree::setPtrs(IntToPtr_ &intToPtr)
{	setfirst     ((Node*)intToPtr.find(int(_first     )));
	settail      ((Node*)intToPtr.find(int(_tail      )));
	setfilename  ((String*)intToPtr.find(int(_filename)));
	setparsed    (PairP((Pair*)intToPtr.find(int(_parsed))));
	settree      (PairP((Pair*)intToPtr.find(int(_tree  ))));
}

DataInputStream &Tree::read(DataInputStream &istr) 
{	return istr >> (int&)_first >> (int&)_tail 
		>> col >> tcol >> row >> (int&)_filename 
		>> (int&)_parsed >> (int&)_tree;
}
wxDataOutputStream &Tree::write(wxDataOutputStream &ostr) 
{	return ostr << type
		<< GC_::ptrToInt->find(first()) 
		<< GC_::ptrToInt->find(tail())
		<< col << tcol << row
		<< GC_::ptrToInt->find(filename())
		<< GC_::ptrToInt->find(parsed())
		<< GC_::ptrToInt->find(tree());
}

NodeP Tree::copy(PtrToInt_ &ptrToInt)
{
	TreeP tr=new Tree();
	if throwing return Unbound;
	tr->type=type;
	tr->_tail=PairP(ptrToInt.find(tail()));
	tr->_first=PairP(ptrToInt.find(first()));
	tr->_filename=StringP(ptrToInt.find(filename()));
	tr->_parsed=RunparsedP(ptrToInt.find(parsed()));
	tr->_tree=TreeP(ptrToInt.find(tree()));
	tr->col=col;
	tr->tcol=tcol;
	tr->row=row;
	return tr;
}

void Tree::settree(PairP tree_) 
{
	wxASSERT(type==TREE);
	_tree=TreeP(tree_);  
	check_oldyoung(tree_);
}

Tree::Tree()
{	type=TREE; 
	_tail=0; 
	_first=0;
	_parsed=0;
	_tree=0;
}

Tree::Tree(NodeP first_, NodeP tail_): 
Runparsed(first_, tail_, TREE) 
{	_tree=TreeP(new Line(new Line(first(), tail()), 0));
}

void Tree::untreeify() 
{
	if (first())
		first()->untreeify();
	if (tail())
		tail()->untreeify();
	settype_RUNPARSED();
}

void Tree::setline(PairP nd)  // Set the line pointer for a tree.
{
	wxASSERT(type==LINE || type==RUNPARSED || type==TREE);
	settype_TREE();  
	settree(nd);  
}
//___________________________________________________________________

void ToDoNode::setPtrs(IntToPtr_ &intToPtr)
{	settail((Node*)intToPtr.find(int(_tail)));
}
DataInputStream &ToDoNode::read(DataInputStream &istr) 
{	istr >> (int&)_tail;
#ifdef PROC_EVAL
	#ifdef _DEBUG
		istr >> (int&)toDo.mnemonic;
	#endif
		istr >> (int&)toDo.instruction;
#else
	istr >> (int&)toDo.mnemonic;
#endif
	return istr;
}
wxDataOutputStream &ToDoNode::write(wxDataOutputStream &ostr) 
{	ostr << type 
		<< GC_::ptrToInt->find(tail());
#ifdef PROC_EVAL
	#ifdef _DEBUG
		ostr << toDo.mnemonic;
	#endif
		ostr << (int&)toDo.instruction;
#else
	ostr << toDo.mnemonic;
#endif
	return ostr;
}

void ToDoNode::print(FILEP strm, int &width, int depth, int noBrackets, int noSpacers)
{
#ifdef _DEBUG
	EvalCommand evco=toDo.mnemonic;
	if (evco > 0  &&  evco <= end)
		::print(strm, width, "%t", Evaluator::commandName[evco]);
	else
		::print(strm, width, _("unknown EvalCommand"));
#endif
}

void ToDoNode::printBin(FILEP strm)
{
#ifdef _DEBUG
	int width=Int::max;
	EvalCommand evco=toDo.mnemonic;
	if (evco > 0  &&  evco <= end)
		::print(strm, width, "%t", Evaluator::commandName[evco]);
	else
		::print(strm, width, _("unknown EvalCommand"));
#endif
}
//___________________________________________________________________
//
//                              Main
//___________________________________________________________________

#ifdef WIN32
	#pragma optimize("", off)
#endif
int __cdecl _main(int argc, charP argv[]) 
{
	PairP execList=0;
	Thread::This()->bottomStack = NodePP(&execList);
	// from now until exit all new vars allocated on the stack have addresses 
	// between <GC_::bottom_stack> and the recent var on the stack (<top> in GC_).

	argc--;
	argv++;
	if (argc>=1 && wxString(*argv)==_T("-nogui"))
	{	theApp->mainShown=false;
		argc--;
		argv++;
	}
#ifdef WIN32
	else if (consolew)
		consolew->show(SW_HIDE);
#else
//	TODO
#endif

	init();
	if (Thread::This()->graph)
		Thread::This()->graph->autoload();
	if (theApp->mainFrame && theApp->mainFrame->nodesAutosave)
	{	if (wxFileExists(theApp->nodesFileName))
			GC_::load(charP(theApp->nodesFileName.c_str()));
	}

	ThreadP th=Thread::This();

	if (argc==0 && (!console || console->GetLastPosition()==0)) 
		c_out << _("; Welcome to aUCBLogo version 4.7") << endL;

//printf("Content-type: text/html; charset=iso-8859-1\n\n");
	while (argc-- > 0)
	{	StringP str=0;
		wxString s(*argv);
		if (s.Find("-run")==0)
		{	
#ifdef WIN32
			s=GetCommandLine();
#else
// TODO
			while (argc-- > 0)
				s+=*argv++;
#endif
			s=s.Mid(s.Find("-run")+1);
			str=new String(s);
			argc=0;
		}
		else
		{	wxFileName fn(s);
			s=fn.GetFullPath();
			str=new String(s);
			if throwing break;
			str->silent_load(0);
			{	int pos=s.rfind('.');
				s.Truncate(pos);
				pos=s.rfind(wxFileName::GetPathSeparator());
				if (pos>=0)
				{	wxString path;
					path=s.Left(pos);
					if (!wxSetWorkingDirectory(path))
						error(FILE_ERROR, new List(
							new String(_("couldn't change dir to ")),
							new String(path),	_ListEnd));
					s.Remove(0,pos+1);
				}
				str=new String(s);
			}
		}
		if (!throwing)
		{	th->currentLine=str;
			execList = th->currentLine->parser(true);
			if (execList)
			{	th->nodeList=execList;
				th->val_status = no_value_allowed;
				*th->what=__begin_line;
				th->Entry();
			}
		}
		if (theApp->action==EXIT_LOGO 
		|| theApp->action==EXIT_DELAYED)
		{	Segment::freeAll();
			return 0;
		}
		if throwing break;
		argv++;
		if (!*argv)
			break;
	}
	while (true)
	{	if throwing
		{	if (th->throw_node==_system  )
			{	if (theApp->action==RECREATE_GUI)
				{	theApp->action=NOP;
					th->throw_node=0;
					th->stoppingFlag=RUN;
					bool mainShown=theApp->mainShown;
					theApp->destroyGUI();
					theApp->mainShown=mainShown;
					theApp->createGUI();
				}else if (theApp->action==HIDE_MAIN)
				{	theApp->action=NOP;
					th->throw_node=0;
					th->stoppingFlag=RUN;
					theApp->destroyGUI();
				}else
					break;
			}
			else if (th->throw_node==_error   ) error_print();
			else if (th->throw_node!=_toplevel)
			{	error(NO_CATCH_TAG, th->throw_node);	error_print();
			}
			th->stoppingFlag=RUN;
			th->inpause=false;
		}
		if (stopping || outputting)
		{	c_out << _("; You must be in a procedure to use OUTPUT or STOP.") << endL;
			th->stoppingFlag=RUN;
		}
		th->argStack->clean();

		th->stepArmed=false;
		GC_::reserve_tank_check();
		th->currentLine = c_in.read("");
		// no prompt, because every line shall be executable

		if throwing continue;
		
		execList = th->currentLine->parser(true);
		if (execList)
		{	th->nodeList=execList;
			th->val_status = no_value_allowed;
			*th->what=__begin_line;
			th->Entry();
		}
	}
	Segment::freeAll();
	return 0;
}
