//___________________________________________________________________
//
//                          Main Header
//___________________________________________________________________

#ifndef WIN32
	#define __cdecl
	#define __stdcall
	#define __single_inheritance
	#define __int64  long long
	#define DWORD  unsigned int
	#define BOOL int
	#define WINAPI
	#define HANDLE  void *
	#define LPVOID  void *
	#define CALLBACK
	#define byte  unsigned char
	#define _MAX_PATH 32000
#endif

#ifdef LOGODLL
	#ifdef LOGOEXPORT
		#define Class  class __declspec(dllexport) 
		#define EStruct  struct __declspec(dllexport) 
		#define Export __declspec(dllexport) 
	#else
		#define Class  class __declspec(dllimport) 
		#define EStruct  struct __declspec(dllimport) 
		#define Export __declspec(dllimport) 
	#endif
#else
	#define Class class
	#define EStruct  struct 
	#define Export
#endif

#ifdef _DEBUG
//	#define DEBUG_NEW new(THIS_FILE, __LINE__)
#endif

#define NIL PairP(0)

#ifdef WIN32
	typedef  __int8  int8;
	typedef  __int16 int16;
	typedef  unsigned __int8   uint8;
	typedef  unsigned __int16  uint16;
#endif

typedef   char*   charP;	typedef charP* charPP;
typedef   int8*   int8P;
typedef  uint8*  uint8P;
typedef  int16*  int16P;
typedef uint16* uint16P;
typedef    int*    intP;
typedef double* doubleP;
typedef  float*  floatP;

#ifdef WIN32
#ifndef _FILE_DEFINED
struct _iobuf {
        char *_ptr;
        int   _cnt;
        char *_base;
        int   _flag;
        int   _file;
        int   _charbuf;
        int   _bufsiz;
        char *_tmpfname;
        };
typedef struct _iobuf FILE;
#define _FILE_DEFINED
#endif
#endif
typedef FILE* FILEP;

#ifdef PTR_DEBUG
	#include "PtrDebug.h"
#else
		Class Node;			typedef Node* NodeP;		typedef NodeP* NodePP;
		Class GC_;
			Class Int;			typedef Int* IntP;
			Class Int16;		typedef Int16* Int16P;
			Class Int8;			typedef Int8* Int8P;
			Class UInt8;		typedef UInt8* UInt8P;
			Class Float;		typedef Float* FloatP;
			Class BigFloat;	typedef BigFloat* BigFloatP;
			Class Complexd;	typedef Complexd* ComplexdP;
			Class Primitive;	typedef Primitive* PrimitiveP;
			Class Array;		typedef Array* ArrayP;
			Class IntArray;	typedef IntArray* IntArrayP;
			Class Int16Array;	typedef Int16Array* Int16ArrayP;
			Class Int8Array;	typedef Int8Array* Int8ArrayP;
			Class UInt8Array;	typedef UInt8Array* UInt8ArrayP;
			Class FloatArray;	typedef FloatArray* FloatArrayP;
			Class ComplexArray;	typedef ComplexArray* ComplexArrayP;
			Class String;		typedef String* StringP;
			Class Bitmap;		typedef Bitmap* BitmapP;
			Class Texture;		typedef Texture* TextureP;
			Class TurtleNode;	typedef TurtleNode* TurtleNodeP;

			Class Pair;			typedef Pair* PairP;		typedef PairP* PairPP;
				Class Line;			typedef Line* LineP;	typedef LineP* LinePP;
					Class Runparsed;	typedef Runparsed* RunparsedP;
					Class Tree;			typedef Tree* TreeP;
				Class List;			typedef List* ListP;
				Class Quote;		typedef Quote* QuoteP;
				Class Colon;		typedef Colon* ColonP;
				Class WindowPair;	typedef WindowPair* WindowPairP;
			Class Object;		typedef Object* ObjectP;		typedef ObjectP* ObjectPP;
			Class LogoObject;	typedef LogoObject* LogoObjectP; typedef LogoObjectP* LogoObjectPP;
			Class Procedure;	typedef Procedure* ProcedureP;
			Class Compiled;	typedef Compiled* CompiledP;
			Class File;			typedef File* FileP;
			Class Table;		typedef Table* TableP;
			Class PtrTable;	typedef PtrTable* PtrTableP;
			Class Struct;		typedef Struct* StructP;
			Class DynamicLibrary;typedef DynamicLibrary* DynamicLibraryP;
			Class WindowNode;			typedef WindowNode* WindowNodeP;
			Class GraphicNode;typedef GraphicNode* GraphicNodeP;
			Class SliderNode;			typedef SliderNode* SliderNodeP;
			Class GaugeNode;			typedef GaugeNode* GaugeNodeP;
			Class IntControlNode;	typedef IntControlNode* IntControlNodeP;
			Class FloatControlNode;	typedef FloatControlNode* FloatControlNodeP;
			Class FrameNode;			typedef FrameNode* FrameNodeP;
			Class GraphNode;			typedef GraphNode* GraphNodeP;
			Class ButtonNode;			typedef ButtonNode* ButtonNodeP;
			Class ToggleButtonNode;	typedef ToggleButtonNode* ToggleButtonNodeP;
			Class CheckBoxNode;		typedef CheckBoxNode* CheckBoxNodeP;
			Class RadioButtonNode;	typedef RadioButtonNode* RadioButtonNodeP;
			Class StaticTextNode;	typedef StaticTextNode* StaticTextNodeP;
			Class TextControlNode;	typedef TextControlNode* TextControlNodeP;
			Class ListBoxNode;		typedef ListBoxNode* ListBoxNodeP;
			Class ChoiceBoxNode;		typedef ChoiceBoxNode* ChoiceBoxNodeP;
			Class ComboBoxNode;		typedef ComboBoxNode* ComboBoxNodeP;
			Class ListControlNode;	typedef ListControlNode* ListControlNodeP;
			Class BoxSizerNode;		typedef BoxSizerNode* BoxSizerNodeP;
				Class StaticBoxSizerNode;	typedef StaticBoxSizerNode* StaticBoxSizerNodeP;

	Class PtrToInt_;
	Class IntToPtr_;

	Class Color;

	Class wxMutex;
	Class DispatchMutex;
	Class wxCriticalSection;
	Class wxString;
	Class wxThread;
	Class wxListBase;

	Class ThreadList;
	Class Thread;
	typedef Thread *ThreadP;

	Class MAPM;
#endif

typedef NodeP Export (Function)(PairPP);
typedef Function *FunctionP;


struct ToDo;
typedef ToDo *ToDoP;


enum ControlType {RUN=0, BREAK, CONTINUE, STOP, OUTPUT, THROWING, MACRO_RETURN};

#define running    (Thread::This()->stoppingFlag==RUN)
#define stopping   (Thread::This()->stoppingFlag==STOP)
#define outputting (Thread::This()->stoppingFlag==OUTPUT)
#define throwing   (Thread::This()->stoppingFlag==THROWING)

#define exist(nr)  (Thread::This()->argStack->greaterEqual(arg+(nr)))
#define noarg      (NodePP(arg)==Thread::This()->argStack->index)

#define next(p)    (p) = (p)->tail()

enum TailCall
{	tailcall_arg=-1,
	in_sequence,  // 0
	tailcall_tail,  // 1
};

enum ValStatus 
{	no_value_allowed,  // body of command = 0
	value_required,    // argument = 1
	output_ok,         // body of function = 2
	dont_care,       // function inside catch = 3
	no_value_in_macro,  // repeat = 4
	value_maybe_ok_in_macro  // catch = 5
};

Class ErrorStruct
{	public:
		ObjectP fun, ufun;
		LineP this_line;
		void mark();
		void markPtr(PtrToInt_ &ptrToInt);
};
typedef ErrorStruct *ErrorStructP;

Class Environment;

Class wxPoint;
Class wxTextCtrl;
EStruct wxEventTableEntry;
Class wxEventHashTable;
Class Console;
extern Export Console *console;

enum ErrorType
{
	FATAL, 
	OUT_OF_MEM, 
	STACK_OVERFLOW, 
	TURTLE_OUT_OF_BOUNDS,
	BAD_DATA_UNREC, 
	DIDNT_OUTPUT, 
	NOT_ENOUGH, 
	BAD_DATA, 
	TOO_MUCH,
	DK_WHAT, 
	PAREN_MISMATCH, 
	NO_VALUE, 
	UNEXPECTED_PAREN, 
	DK_HOW,
	NO_CATCH_TAG, 
	ALREADY_DEFINED, 
	STOP_ERROR, 
	ALREADY_DRIBBLING,
	FILE_ERROR, 
	IF_WARNING, 
	SHADOW_WARN, 
	USER_ERR, 
	IS_PRIM,
	NOT_INSIDE, 
	DK_HOW_UNREC, 
	NO_TEST, 
	UNEXPECTED_BRACKET,
	UNEXPECTED_BRACE, 
	BAD_GRAPH_INIT, 
	ERR_MACRO,
	DK_WHAT_UP, 
	AT_TOPLEVEL, 
	APPLY_BAD_DATA, 
	DEEPEND,
	OUT_OF_MEM_UNREC,
	NOT_YET_SUPPORTED,
	SECURITY_ERROR,
	SECURITY_MEMSIZE,
	SECURITY_NODES,
	IS_ALREADY_A_PROC,
	VBAR_MISMATCH, 
	BRACKET_MISMATCH, 
	BRACE_MISMATCH, 
	END_MISMATCH,
	UNEXPECTED_END, 
};

extern bool isLogoWindow(wxWindow *window);
extern void initWindowClasses();
extern bool checkThrowing();
extern void push(PairP &stack, NodeP obj);

extern void mySwapBuffers();

extern int __cdecl _main(int argc, charP *argv);

extern double versionNumber;
extern wxString aUCBLogo, versionString, aUCBLogoVersion;

enum EvalStackMarker
{
	ESM_dummy,	// for pop_till
	ESM_accumulate_arg,
	ESM_accumulate_arg_this,
	ESM_after_formals,
	ESM_after_lambda,
	ESM_apply_dispatch,
	ESM_arg_loop,
	ESM_arg_is_function,
	ESM_args_done,
	ESM_begin_apply,
	ESM_begin_formal_loop,
	ESM_begin_line,
	ESM_catch_continuation,
	ESM_catch_followup, 
	ESM_compound_apply_continue, 
	ESM_compound_apply_end,
	ESM_compound_apply_end_pop_fun, 
	ESM_compound_apply_end_this, 
	ESM_dispatch,
	ESM_do_until_again,
	ESM_do_until_cond,
	ESM_do_until_continuation, 
	ESM_do_until_end,
	ESM_do_until_followup,
	ESM_do_while_again,
	ESM_do_while_cond,
	ESM_do_while_continuation,
	ESM_do_while_end,
	ESM_do_while_followup,
	ESM_end,
	ESM_eval,
	ESM_fetch_command,
	ESM_for_again,
	ESM_for_continuation, 
	ESM_for_followup,
	ESM_foreach_again, 
	ESM_foreach_continuation,
	ESM_foreach_end,
	ESM_foreach_followup,
	ESM_forever_continuation,
	ESM_forever_again,
	ESM_forever_followup,
	ESM_if_continuation,
	ESM_if_followup,
	ESM_ifElse_continuation,
	ESM_ifElse_else,
	ESM_ifElse_followup,
	ESM_ifor_again,
	ESM_ifor_continuation, 
	ESM_ifor_followup,
	ESM_lambda_apply,
	ESM_lambda_questionmark,
	ESM_load,
	ESM_local,
	ESM_macro_return,
	ESM_non_tail_eval,
	ESM_proc_with_args,
	ESM_questionmark_continue,
	ESM_questionmark_failed,
	ESM_repeat_continuation,
	ESM_repeat_again,
	ESM_repeat_followup,
	ESM_run,
	ESM_runresult_continuation,
	ESM_sequence,
	ESM_sequence_continue,
	ESM_sequence_continue_this,
	ESM_set_args_continue,
	ESM_set_args_continue2,
	ESM_until_again,
	ESM_until_cond,
	ESM_until_continuation,
	ESM_until_end,
	ESM_until_followup,
	ESM_while_again,
	ESM_while_cond,
	ESM_while_continuation,
	ESM_while_end,
	ESM_while_followup,
	ESM_polygon_continuation,
	ESM_tess_continuation,
	ESM_surface_continuation,
	ESM_graphic_continuation,

	ESM_paren,
	ESM_bracket,
	ESM_brace,
	ESM_vbar,
	ESM_to,
};

