//___________________________________________________________________
//
//                        Class MemoryWindow
//___________________________________________________________________

class wxClientDC;
class wxTipWindow;
class MemoryWindow;

class MemoryFrame: public wxPanel
{
	public:
		wxFlatMenu *optionsMenu;
		wxFlatMenuBar *menuBar;
		MemoryWindow *memoryWindow;

		MemoryFrame() {}
		MemoryFrame(wxWindow* parent_, wxWindowID id, 
						const wxString& title, 
						const wxPoint& pos, 
						const wxSize& size, 
						long style, 
						const wxString& name,
						int blockx, int blocky, int border);
		~MemoryFrame();

		void show(bool shown=true);
		void OnChangeBlockSize(wxCommandEvent& WXUNUSED(event));
		void OnChangeBlockBorder(wxCommandEvent& WXUNUSED(event));

		DECLARE_DYNAMIC_CLASS(MemoryFrame)
		DECLARE_EVENT_TABLE()
};

class MemoryWindow: public wxScrolledWindow
{
	public:
		bool inMouseMove, inOnPaint;
		int width, height, winwidth, winheight,
			blockx, blocky, blocksx, palsize, border;
		ColorP palette, paletteBGR;
		wxPen *pen;
		wxBrush *brush;
		wxTipWindow *tip;
		wxWindow *parent;

		MemoryWindow() {}
		MemoryWindow(wxWindow* parent_, wxWindowID id, 
			const wxString& title, 
			const wxPoint& pos = wxDefaultPosition, 
			const wxSize& size = wxDefaultSize, 
			long style = wxDEFAULT_FRAME_STYLE, 
			const wxString& name = _("MemoryWindow"),
			int blockx_=5, int blocky_=5, int border_=1);

		~MemoryWindow();

		void updateNode(NodeP nd),
			OnPaint(wxPaintEvent &event),
			OnErase(wxEraseEvent &event),
			OnSize(wxSizeEvent  &event),
			OnMouseMove(wxMouseEvent &event);

		DECLARE_DYNAMIC_CLASS(MemoryWindow)
		DECLARE_EVENT_TABLE()
};

extern MemoryWindow *memoryWindow;
