#include "stdafx.h"
#include <math.h>

#ifdef WIN32
	#include <crtdbg.h>
#endif

#include <wx/thread.h>
#include <wx/datstrm.h>

#include "Main.h"
#include "File.h"
#include "IntToPtr_.h"
#include "PtrToInt_.h"
#include "String.h"
#include "Int.h"
#include "Int16.h"
#include "Int8.h"
#include "Float.h"
#include "Pair.h"
#include "Line.h"
#include "Tree.h"
#include "Object.h"
#include "Array.h"
#include "IntArray.h"
#include "Int16Array.h"
#include "FloatArray.h"
#include "Table.h"
#include "LogoObject.h"
#include "Eval.h"
#include "Init.h"
#include "Error.h"
#include "Stack.h"
#include "Thread.h"

#ifdef _DEBUG
	#undef THIS_FILE
	static char THIS_FILE[]= __FILE__;
	#define new new(_NORMAL_BLOCK, THIS_FILE, __LINE__)
#else
	static char THIS_FILE[]= __FILE__;
#endif

//#define _DEBUG_LINES 1

int Pair::maxStringLength=65536;

Pair::Pair(charP str):	
	Node(PAIR), _tail(0), _circcounter(0)
{	setfirst(new String(str));
	flag=ObjectType(0);
}

void Pair::setPtrs(IntToPtr_ &intToPtr)
{	setfirst((Node*)intToPtr.find(int(_first)));
	settail ((Node*)intToPtr.find(int(_tail )));
}
DataInputStream &Pair::read(DataInputStream &istr) 
{	return istr >> (int&)_first >> (int&)_tail;
}
wxDataOutputStream &Pair::write(wxDataOutputStream &ostr) 
{	return ostr << type 
		<< GC_::ptrToInt->find(first()) 
		<< GC_::ptrToInt->find(tail());
}

NodeP Pair::copy(PtrToInt_ &ptrToInt)
{
	PairP pair=new Pair();
	if throwing return Unbound;
	pair->_tail=PairP(ptrToInt.find(tail()));
	pair->_first=PairP(ptrToInt.find(first()));
	pair->type=type;
	return pair;
}

StringP Pair::string()
{
	char textbuf[65536];
	Thread::This()->stringptr=textbuf;
	Thread::This()->stringlen=maxStringLength-1;
	stringbuffer << NodeP(this);
	*(Thread::This()->stringptr)='\0';
	return new String(textbuf);
}

void Pair::print(FILEP strm, int &width, int depth, int noBrackets, int noSpacers) 
{
	ThreadP th=Thread::This();
	if (circcounter()==th->circcounter)
	{	::print(strm, width, "...");
		return;
	}
	NodeP arg=0;
	bool was_list;
	PairP ndlist=this;

	int len=count(), wid=0;
	if (width >= 2*len-10)
		wid=width/len;

	if (noBrackets <= 0)
		::print(strm, width, '[');
	while (ndlist) 
	{	if (!(ndlist->is.list || ndlist->is.line)) 
			break;
		int w=wid;
		arg=ndlist->first();
		if (checkThrowing()) break;

		if (ndlist->circcounter()==th->circcounter)
		{	::print(strm, width, "...");
			break;
		}else
			ndlist->setcirccounter(th->circcounter);
			
		switch (ndlist->type)
		{
#ifdef _DEBUG
		case TODO:
			{	EvalCommand evco=ToDoNodeP(ndlist)->toDo.mnemonic;
				if (evco > 0  &&  evco <= end)
					::print(strm, w, "%t", Evaluator::commandName[evco]);
				else ::print(strm, w, _("unknown EvalCommand"));
			}
			break;
#endif
		case NTFREE: ::print(strm, w, _("NTFREE")); break;
#ifndef _DEBUG_LINES
		case LINE:
		case TREE:
#endif
		case PAIR:	if (arg && arg->is.list)
						{	if (noSpacers <= 0)
							{	th->indent++;
								::print(strm, w, '\t');	
							}
							if (arg)
								arg->print(strm, w, depth-1, noBrackets-1, noSpacers-1);
							if (noSpacers <= 0)
							{	::print(strm, w, '\n');
								th->indent--;
								printIndents(strm, w);
							}
							was_list=true;
							break;
						}else if (arg)
							arg->print(strm, w, depth-1, noBrackets-1, noSpacers-1);
						else
						{	::print(strm, w, '[');
							::print(strm, w, ']');
						}
						was_list=false;
						break;

		case COLON:	::print(strm, w, ':');
						arg->print(strm, w, depth-1, noBrackets-1, noSpacers-1);
						was_list=false;
						break;
#ifdef _DEBUG_LINES
		case TREE:	::print(strm, w, '\n'); 
						::print(strm, w, 'T'); 
						{	LineP l=TreeP(ndlist)->tree();
							if (l)
							{	if (l->first())
									l->first()->print(
										strm, width, depth, noBrackets-1, noSpacers-1); 
								::print(strm, w, '|'); 
								if (l->tail())
									l->tail()->print(strm, width, depth, noBrackets-1, noSpacers-1); 
							}
						}
						::print(strm, w, 't');
		case RUNPARSED:
		case LINE: 	//::print(strm, w, LineP(ndlist)->filename()->ptr());
						//::print(strm, w, LineP(ndlist)->col);
						//::print(strm, w, ' ');	
						::print(strm, w, LineP(ndlist)->row);
						if (arg->islist())
						{	if (!arg)
							{	::print(strm, w, '[');
								::print(strm, w, ']');
							}else
							{	th->indent++;
								::print(strm, w, '\t');	
								arg->print(strm, w, depth, noBrackets-1, noSpacers-1);	
								::print(strm, w, '\n');
								th->indent--;
								printIndents(strm, w);
								was_list=true;
							}
						}
						else
						{	arg->print(strm, w, depth, noBrackets-1, noSpacers-1);
							was_list=false;
						}
						break;
#endif
#ifdef _DEBUG_FNS
		case TREE:	print(strm, w, '\n'); 
						print(strm, w, 'T'); 
						print(strm, w, TreeP(ndlist)->tree()); 

						print(strm, w, 't');
		case RUNPARSED:
		case LINE: 	//print(strm, w, LineP(ndlist)->filename);
						if (LineP(ndlist)->filename->type==STRING)
							print(strm, w, LineP(ndlist)->filename);
						else
							print(strm, w, "BOGUS!");
						if (arg->islist())
						{	th->indent++;
							print(strm, w, '\t');	
							print(strm, arg, depth, width);	
							print(strm, w, '\n');
							th->indent--;
							printIndents(strm, w);
							was_list=true;
						}
						else
						{	print(strm, arg, w, depth);	
							was_list=false;
						}
						break;
#endif
		default: 
			if (arg)
				arg->print(strm, w, depth-1, noBrackets-1, noSpacers-1);
			else
			{	::print(strm, w, '[');
				::print(strm, w, ']');
			}
			was_list=false;
		}
		next(ndlist);
		width-=wid-w;
		if (ndlist) 
		{	if (!was_list) 
				::print(strm, width, ' ');
			if (width < 5) 
			{	::print(strm, width, "...");
				break;
			}
		}
	}
	if (noBrackets <= 0)
		::print(strm, width, ']');
	th->setcirccounter(th->circcounter+1);
}

void Pair::printBin(FILEP strm) 
{
	ThreadP th=Thread::This();
	int width=Int::max;
	if (circcounter()==th->circcounter)
	{	::print(strm, width, "...");
		return;
	}
	NodeP arg=0;
	PairP ndlist=this;
	while (ndlist) 
	{	if (!ndlist->is.list) return;

		if (ndlist->circcounter()==th->circcounter)
			break;
		else
			ndlist->setcirccounter(th->circcounter);
	
		arg=ndlist->first();
		if (checkThrowing()) break;

		switch (ndlist->type)
		{
#ifdef _DEBUG
		case TODO:
			{	EvalCommand evco=ToDoNodeP(ndlist)->toDo.mnemonic;
				if (evco > 0  &&  evco <= end)

					::print(strm, width, "%t", Evaluator::commandName[evco]);
				else ::print(strm, width, _("unknown EvalCommand"));
			}
			break;
#endif
		case NTFREE: ::print(strm, width, _("NTFREE")); break;
		case PAIR:	if (arg && arg->islist())
						{	arg->printBin(strm);	
							break;
						}
						break;
#ifdef _DEBUG_LINES
		case TREE:
		case RUNPARSED:
		case LINE: 	::print(strm, width, LineP(ndlist)->col);
						::print(strm, width, ' ');	
						::print(strm, width, LineP(ndlist)->row);
						arg->printBin(strm);
						break;
#endif
#ifdef _DEBUG_FNS
		case TREE:
		case RUNPARSED:
		case LINE: 	if (LineP(ndlist)->filename->type==STRING)
							print(strm, width, LineP(ndlist)->filename);
						else
							print(strm, width, "BOGUS!");
						printBin(strm, width, arg);
						break;
#endif
		default: 
			arg->printBin(strm);
		}
		next(ndlist);
	}
	th->setcirccounter(th->circcounter+1);
}

NodeP Pair::contentsTree(	wxArrayString &namearr, 
									wxArrayString &valarr, 
									wxArrayPtrVoid &objarr, 
									ObjectType want, 
									ObjectType dont,
									ObjectType must, 
									int &count, int level)
{
	objarr[count]=this;
	if (!expanded())
	{	StringP str=string();
		if (str  &&  str->is.string)
		{	valarr[count]=str->noFormat()->ptr();
			incContentsArrays(namearr, valarr, objarr, count);
		}
		return this;
	}
	ThreadP th=Thread::This();
	if (circcounter()==th->circcounter)
	{	valarr[count]="...";
		return this;
	}

	PairP list=this;
	NodeP contentsList=0;
	int i=1;
	while (list) 
	{	if (list->circcounter()==th->circcounter)
		{	valarr[count]="...";
			break;
		}else
			list->setcirccounter(th->circcounter);

		NodeP nd=list->first();
		if (nd)
		{	int lev=level;
			if (nd->type==OBJECT)
			{	nd=ObjectP(nd)->name();
				lev--;
			}else if (nd->type==LOGOOBJECT)
			{	nd=LogoObjectP(nd)->name();
				lev--;
			}else
				lev++;
			namearr[count]=wxString(' ',level-1);
			if (nd && nd->expandable())
				if (nd->expanded())
					namearr[count]+='-';
				else
					namearr[count]+='+';
			namearr[count] << i;
			objarr[count]=nd;
			if (nd->expanded())
			{	if (nd->type==LOGOOBJECT)
				{	valarr[count]=LogoObjectP(nd)->name()->ptr();
					incContentsArrays(namearr, valarr, objarr, count);
				}else
				{	valarr[count]=nd->_typeof()->ptr();
					incContentsArrays(namearr, valarr, objarr, count);
				}
			}
			contentsList=nd->contentsTree(
				namearr, valarr, objarr, want, dont, must, count, lev);
		}else
		{	valarr[count]="[]";
			incContentsArrays(namearr, valarr, objarr, count);
		}
		i++;
		next(list);
		if (checkThrowing()) break;
	}
	th->setcirccounter(th->circcounter+1);
	return this;
}

void Pair::setExpanded(bool state) 
{
	PairP l=this;
//	while (l)
	{	bit.table_expand=state;
//		next(l);
	}
}

NodeP Pair::compare(NodeP nd)
{
	ThreadP th=Thread::This();
	if (circcounter()==th->circcounter)
		return 0;
	if (nd && nd->isnolist())
		return Unbound;
	PairP l=this, b=PairP(nd);
	while (l && b)
	{	if (l->circcounter()==th->circcounter)
		{	if (l->circcounter()==b->circcounter())
				return 0;
			else
				return _One;
		}else if (b->circcounter()==th->circcounter)
			return _Minus_One;
		else
			l->setcirccounter(th->circcounter);
		if (!l->first())
		{	if (b->first())
			{	th->setcirccounter(th->circcounter+1);
				return _Minus_One;
			}
		}else
		{	NodeP c=l->first()->compare(b->first());
			if (c!=0)
			{	th->setcirccounter(th->circcounter+1);
				return c;
			}
		}
		next(l);
		next(b);
	}
	th->setcirccounter(th->circcounter+1);
	if (l)
		return _One;
	if (b)
		return _Minus_One;

	return 0;
}

int Pair::count()
{
	ThreadP th=Thread::This();
	if (this && circcounter()==th->circcounter)
		return 1;
	int c=0;
	for (PairP nd=this;  nd;  next(nd))
	{	if (nd->circcounter()==th->circcounter)
			break;
		else
			nd->setcirccounter(th->circcounter);
		c++;
//			if (checkThrowing()) break;
	}
	th->setcirccounter(th->circcounter+1);
	return c;
}

int Pair::_sizeof()
{
	int size=0;
	ThreadP th=Thread::This();
	if (circcounter()==th->circcounter)
		return size;
	for (PairP li=this;  li;  next(li))
	{	if (li->circcounter()==th->circcounter)
			break;
		else
			li->setcirccounter(th->circcounter);
		if (li->first())
			size+=li->first()->_sizeof();
//		if (checkThrowing()) break;
	}
	th->setcirccounter(th->circcounter+1);
	return size;
}

bool Pair::equalP(NodeP b)
{	if (b->isnolist() && (b && !b->is.line)) 
		return false;

	PairP alist=PairP(this), blist=PairP(b);
	ThreadP th=Thread::This();
	if (circcounter()==th->circcounter)
		return circcounter()==b->circcounter();

	while (alist && blist) 
	{	if (alist->circcounter()==th->circcounter)
			break;
		else
			alist->setcirccounter(th->circcounter);
		if (blist->circcounter()==th->circcounter)
			break;
		else
			blist->setcirccounter(th->circcounter);
		if (alist->first())
		{	if (! alist->first()->equalP(blist->first()))
			{	th->setcirccounter(th->circcounter+1);
				return false;
			}
		}
		else if (blist->first())
		{	th->setcirccounter(th->circcounter+1);
			return false;
		}
		next(alist);
		next(blist);
//		if (checkThrowing()) break;
	}
	th->setcirccounter(th->circcounter+1);
	return !alist && !blist;
}

NodeP Pair::deepCopy()	// TODO: should not be recursive any more!!!
{	if (!this) 
		return 0;
	NodeP f=0, t=0;
	if (first())
		f=first()->deepCopy();
	if (tail())
		t=tail()->deepCopy();
	return new Pair(f, t);
}

NodeP Pair::deepCopyLine()	// TODO: should not be recursive any more!!!
{	if (!this) 
		return 0;
	NodeP f=0, t=0;
	if (first())
		f=first()->deepCopyLine();
	if (tail())
		t=tail()->deepCopyLine();
	LineP l=new Line(f, t, LINE);
	return l;
}

NodeP Pair::first_() 
{	return first();
}

NodeP Pair::butFirst() 
{	return tail();
}

NodeP Pair::firsts()
{
	ThreadP th=Thread::This();
	if (circcounter()==th->circcounter)
		return 0;
	PairP tnode=0, val=0, li=this;
	if (li->first())
		tnode=val= new Pair(li->first()->first_(), 0);
	else
		tnode=val= new Pair(0, 0);
	if throwing return Unbound;

	for (li=li->tail();  li;  next(li)) 
	{
		if (li->circcounter()==th->circcounter)
			break;
		else
			li->setcirccounter(th->circcounter);

		if (li->first())
			tnode->settail( new Pair(li->first()->first_(), 0) );
		else
			tnode->settail( new Pair(0, 0) );
		if throwing return Unbound;
		next(tnode);
	}
	th->setcirccounter(th->circcounter+1);
	return val;
}

NodeP Pair::butFirsts()
{
	ThreadP th=Thread::This();
	if (circcounter()==th->circcounter)
		return this;
	PairP tnode=0, val=0, li=this;
	NodeP nd=li->first_()->a_bfable(1);
	if throwing return Unbound;
	tnode=val = new Pair(nd->butFirst(), 0);
	if throwing return Unbound;

	for (li=li->tail();  li;  next(li)) 
	{	if (li->circcounter()==th->circcounter)
			break;
		else
			li->setcirccounter(th->circcounter);
		NodeP nd=li->first_()->a_bfable(1);
		if throwing return Unbound;
		tnode->settail( new Pair(nd->butFirst(), 0) );
		if throwing return Unbound;
		next(tnode);
	}
	th->setcirccounter(th->circcounter+1);
	return val;
}

NodeP Pair::last()
{	PairP list=this;
	ThreadP th=Thread::This();
	if (circcounter()==th->circcounter)
		return list;
	while (list->tail()) 
	{	if (list->circcounter()==th->circcounter)
			break;
		else
			list->setcirccounter(th->circcounter);
		next(list);
//		if (checkThrowing()) break;
	}
	th->setcirccounter(th->circcounter+1);
	return list->first();
}

NodeP Pair::butLast()
{	PairP list=this, result=0, tnode=0, lastnode=0;
	ThreadP th=Thread::This();
	if (circcounter()==th->circcounter)
		return this;

	while (list->tail()) 
	{	if (list->circcounter()==th->circcounter)
			break;
		else
			list->setcirccounter(th->circcounter);
		tnode = new Pair(list->first(), 0);
		if (!result) 
		{	result=tnode;
			lastnode=tnode;
		}else 
		{	lastnode->settail( tnode );
			lastnode=tnode;
		}
		next(list);
//		if (checkThrowing()) break;
	}
	th->setcirccounter(th->circcounter+1);
	return result;
}

NodeP Pair::fPut(NodeP nd)
{	return new Pair(nd, this);
}

NodeP Pair::lPut(NodeP nd)
{	PairP lst=this, val=0, lastnode=0, tnode=0;
	ThreadP th=Thread::This();
	if (circcounter()==th->circcounter)
		return lst;
	while (lst) 
	{	if (lst->circcounter()==th->circcounter)
			break;
		else
			lst->setcirccounter(th->circcounter);
		tnode = new Pair(lst->first(), 0);
		if (!val) 
			val=tnode;
		else 
			lastnode->settail( tnode );
		lastnode=tnode;
		next(lst);
//		if (checkThrowing()) break;
	}
	th->setcirccounter(th->circcounter+1);
	if (!val)
		return new Pair(nd, 0);
	else
	{	lastnode->settail( new Pair(nd, 0) );
		return val;
	}
}

NodeP Pair::item(int i)
{	ThreadP th=Thread::This();
	if (i >= 0) 
	{	if (circcounter()==th->circcounter)
			return 0;
		PairP list = this;
		while (list && i--) 
		{	if (list->circcounter()==th->circcounter)
				break;
			else
				list->setcirccounter(th->circcounter);
			next(list);
		}
		th->setcirccounter(th->circcounter+1);
		if (list) return list->first();
	}
	error(BAD_DATA, new Int(i)); return Unbound;
}

NodeP Pair::item(NodeP index, NodeP result)
{	ThreadP th=Thread::This();
	if (index->islist())
	{	if (result && result->islist())		 
		{	PairP i=PairP(index), r=PairP(result);		  
			while (i && r)										   
			{	NodeP ret=item(i->first(), r->first());    
				if (!throwing) r->setfirst( ret );		    
				next(i);											      
				next(r);											       
			}														        
			if (!i && !r && !throwing) return result;	         
		}
		else
		{	PairP lst=PairP(index), result=0, lastnode=0, tnode=0;
			if (lst->circcounter()==th->circcounter)
				return 0;
			while (lst) 
			{	if (lst->circcounter()==th->circcounter)
					break;
				else
					lst->setcirccounter(th->circcounter);
				NodeP fst=lst->first();
				if (!fst)
					tnode=new Pair(0,0);
				else
					tnode = new Pair(item(fst, 0), 0);
				if (!result) 
					result=tnode;
				else 
					lastnode->settail( tnode );
				lastnode=tnode;
				next(lst);
				if throwing return Unbound;
			}
			th->setcirccounter(th->circcounter+1);
			return result;
		}
	}
//	ITEM_if_index_islist
	else if (index->type==INT_)
		return item(IntP(index)->int_-1);
	else if (index->is.string)
		return item(StringP(index)->number(), 0);
	error(BAD_DATA, index); return Unbound;
}

NodeP Pair::mdItem(NodeP index)
{
	ThreadP th=Thread::This();
	NodeP obj=this;
	if (index->islist())
	{	PairP indexlist=PairP(index);
		while (indexlist)
		{	if (indexlist->circcounter()==th->circcounter)
				break;
			else
				indexlist->setcirccounter(th->circcounter);
			NodeP i=indexlist->first();
			if (!i)
			{	error(BAD_DATA, index); 
				return Unbound;
			}
			if (!obj)
			{	error(BAD_DATA, this);
				return Unbound;
			}
			obj=obj->item(i, 0);
			next(indexlist);
		}
		th->setcirccounter(th->circcounter+1);
		return obj;
	}
	error(BAD_DATA, this);
	return Unbound;
}

NodeP Pair::setitem(NodeP index, NodeP newitem, bool safe)
{	ThreadP th=Thread::This();
	int i=index->a_int(1);
	if throwing return Unbound;
	if (safe) 
	{	if (circular(newitem) && !throwing) 
			error(BAD_DATA, newitem, 3);
	}
	if (!throwing) 
	{	if ((i <= 0) && !throwing) 
			error(BAD_DATA, index);

		if (!throwing) 
		{	PairP a=this;
			while (--i && a)
			{	if (a->circcounter()==th->circcounter)
					break;
				else
					a->setcirccounter(th->circcounter);
				next(a);
			}
			if (a) a->setfirst( newitem );
			else error(BAD_DATA, index);
		}
	}
	th->setcirccounter(th->circcounter+1);
	return Unbound;
}

NodeP Pair::memberP(NodeP subobj, bool notp, bool substr)
{
	if (substr) return _False;
	ThreadP th=Thread::This();
	PairP list=this;

	if (!subobj)
	{	while (list && !throwing)
		{	if (list->circcounter()==th->circcounter)
				break;
			else
				list->setcirccounter(th->circcounter);
			if (!list->first())
			{	th->setcirccounter(th->circcounter+1);
				return notp ?   list  :  NodeP(_True); 
			}
//			if (checkThrowing()) break;
			next(list);
		}
	}else
	{	while (list && !throwing) 
		{	if (list->circcounter()==th->circcounter)
				break;
			else
				list->setcirccounter(th->circcounter);
		
			if (subobj->equalP(list->first()))
			{	th->setcirccounter(th->circcounter+1);
				return notp ?   list  :  NodeP(_True);
			}
//			if (checkThrowing()) break;
			next(list);
		}
	}
	th->setcirccounter(th->circcounter+1);
	return notp ?   NodeP(0)  :  _False;
}

void Pair::removeitem(NodeP index)
{	ThreadP th=Thread::This();
	int i=index->a_int(1);
	if throwing return;
	
	if (i<=0) 
		error(BAD_DATA, index);
	if throwing return;

	if (i==1)
	{	if (tail())
		{	setfirst( tail()->first() );
			settail( tail()->tail() );
		}else
		{	setfirst( 0 );
			settail( 0 );
		}
		return;
	}
	PairP a=this, last=this;
	while (--i && a)
	{	if (a->circcounter()==th->circcounter)
			break;
		else
			a->setcirccounter(th->circcounter);
		last=a;
		next(a);
	}
	th->setcirccounter(th->circcounter+1);
	if (a)
		last->settail( a->tail() );
	else 
		error(BAD_DATA, index);
}

NodeP Pair::reverse()
{
	ThreadP th=Thread::This();
	PairP result=0, ins=new Pair(),
		list=this;

	while (list)
	{	if (list->circcounter()==th->circcounter)
			break;
		else
			list->setcirccounter(th->circcounter);
		ins->setfirst(list->first());
		result=ins;
		ins=new Pair(0, ins);
		if throwing return Unbound;
		next(list);
	}
	th->setcirccounter(th->circcounter+1);
	return result;
}

NodeP Pair::remove(NodeP thing)
{
	ThreadP th=Thread::This();
	PairP list=this, result=0, tnode=0;
	while (list)
	{	if (list->circcounter()==th->circcounter)
			break;
		else
			list->setcirccounter(th->circcounter);
		NodeP i=list->first();
		if ((!thing && i) || (thing && !i) || (i && !i->equal(thing)))
		{	if (!tnode)
			{	result=new Pair();
				tnode=result;
			}else
			{	tnode->settail(new Pair());
				next(tnode);
			}
			tnode->setfirst(i);
			if throwing return Unbound;
		}
		next(list);
	}
	th->setcirccounter(th->circcounter+1);
	return result;
}

NodeP Pair::destructiveRemove(NodeP thing)
{
	ThreadP th=Thread::This();
	PairP list=this, last=0, result=0;
	while (list)
	{//	while (list && (!list->first() || list->first()==thing))
		if (list->circcounter()==th->circcounter)
			break;
		else
			list->setcirccounter(th->circcounter);
		if (list->first() && list->first()->equal(thing))
		{	if (last)
				last->settail(list->tail());
			else
				result=list->tail();
			next(list);
		}else
		{	if (!result)
				result=list;
			last=list;
			next(list);
		}
	}
	th->setcirccounter(th->circcounter+1);
	return result;
}

NodeP Pair::remdup()
{
	ThreadP th=Thread::This();
	int size=count();
	TableP table=new Table(size);
	if throwing return Unbound;
	PairP revlist=PairP(reverse()), list=revlist;
	while (list && !throwing)
	{	if (list->circcounter()==th->circcounter)
			break;
		else
			list->setcirccounter(th->circcounter);
		NodeP f=list->first();
		if (f)
		{	StringP s=f->string();
			if (th->caseIgnored)
				s=StringP(s->lower());
			if (!table->find(s)) 
				table->insert(s, THIS_FILE, __LINE__);
		}
		next(list);
	}
	th->setcirccounter(th->circcounter+1);
	PairP result=0;
	list=revlist;
	while (list && !throwing)
	{	if (list->circcounter()==th->circcounter)
			break;
		else
			list->setcirccounter(th->circcounter);
		NodeP f=list->first();
		if (f)
		{	StringP s=f->string();
			if (th->caseIgnored)
				s=StringP(s->lower());

			ObjectP obj=table->find(s);
			if (obj && obj->var()==Unbound) 
			{	obj->setvar(0);
				result=new Pair(f, result);
			}
		}
		next(list);
	}
	th->setcirccounter(th->circcounter+1);
	return result;
}

NodeP Pair::upper() 
{	ThreadP th=Thread::This();
	if (circcounter()==th->circcounter)
		return 0;
	PairP lst=this, result=0, lastnode=0, tnode=0;
	while (lst) 
	{	if (lst->circcounter()==th->circcounter)
			break;
		else
			lst->setcirccounter(th->circcounter);
		NodeP fst=lst->first();
		if (!fst)
			tnode=new Pair(0,0);
		else
			tnode = new Pair(fst->upper(), 0);
		if (!result) 
			result=tnode;
		else 
			lastnode->settail( tnode );
		lastnode=tnode;
		next(lst);
		if (checkThrowing()) break;
	}
	th->setcirccounter(th->circcounter+1);
	return result;
}

NodeP Pair::lower() 
{	ThreadP th=Thread::This();
	if (circcounter()==th->circcounter)
		return 0;
	PairP lst=this, result=0, lastnode=0, tnode=0;
	while (lst) 
	{	if (lst->circcounter()==th->circcounter)
			break;
		else
			lst->setcirccounter(th->circcounter);
		NodeP fst=lst->first();
		if (!fst)
			tnode=new Pair(0,0);
		else
			tnode = new Pair(fst->lower(), 0);
		if (!result) 
			result=tnode;
		else 
			lastnode->settail( tnode );
		lastnode=tnode;
		next(lst);
		if (checkThrowing()) break;
	}
	th->setcirccounter(th->circcounter+1);
	return result;
}

ArrayP Pair::array(int origin) 
{
	ThreadP th=Thread::This();
	if (circcounter()==th->circcounter)
		return 0;
	int len=count();
	PairP np;

	ArrayP arr = new Array(len, origin);
	if throwing return ArrayP(Unbound);
	NodePP d = arr->data();

	for (np=this;  np;  next(np))	// copy the pointers from the list to the new array
	{	if (np->circcounter()==th->circcounter)
			break;
		else
			np->setcirccounter(th->circcounter);
		*d = np->first();
		arr->check_oldyoung(*d++);	
	}
	th->setcirccounter(th->circcounter+1);
	return arr;
}

IntArrayP Pair::intarray(int origin) 
{
	ThreadP th=Thread::This();
	if (circcounter()==th->circcounter)
		return 0;
	int len=count();
	PairP np;

	IntArrayP intarray = new IntArray(len, origin);
	if throwing return IntArrayP(Unbound);
	intP d = intarray->data();

	for (np=this;  np;  next(np))	// copy the pointers from the list to the new array
	{	if (np->circcounter()==th->circcounter)
			break;
		else
			np->setcirccounter(th->circcounter);
		NodeP h=np->first();
		switch (type_of(np->first()))
		{	case INT_:	*d++ =             IntP(h)->int_;		break;
			case FLOAT_:*d++ = Int::clip(FloatP(h)->float_);	break;
			case NINT16: *d++ =           Int16P(h)->int_;		break;
			case NINT8:	*d++ =            Int8P(h)->int_;		break;
			case STRING:if (h->numberP())
								*d++ = Int::clip(h->getnumber());
							else
							{	error(BAD_DATA, this); return IntArrayP(Unbound);
							}	
							break;
			default:
				error(BAD_DATA, this);	return IntArrayP(Unbound);
		}
	}
	th->setcirccounter(th->circcounter+1);
	return intarray;
}

Int16ArrayP Pair::int16array(int origin) 
{
	ThreadP th=Thread::This();
	if (circcounter()==th->circcounter)
		return 0;
	int len=count();
	PairP np;

	Int16ArrayP int16array = new Int16Array(len, origin);
	if throwing return Int16ArrayP(Unbound);
	int16P d = int16array->data();

	for (np=this;  np;  next(np))	// copy the pointers from the list to the new array
	{	if (np->circcounter()==th->circcounter)
			break;
		else
			np->setcirccounter(th->circcounter);
		NodeP h=np->first();
		switch (type_of(h))
		{	case INT_:	*d++ = Int16::clip(  IntP(h)->int_);	break;
			case FLOAT_:*d++ = Int16::clip(FloatP(h)->float_);	break;
			case NINT16: *d++ =             Int16P(h)->int_;		break;
			case NINT8:	*d++ =              Int8P(h)->int_;		break;
			case STRING:if (h->numberP())
								*d++ = Int16::clip(h->getnumber());
							else
							{	error(BAD_DATA, this); return Int16ArrayP(Unbound);
							}	
							break;
			default:
				error(BAD_DATA, this);	return Int16ArrayP(Unbound);
		}
	}
	th->setcirccounter(th->circcounter+1);
	return int16array;
}

FloatArrayP Pair::floatarray(int origin) 
{
	ThreadP th=Thread::This();
	if (circcounter()==th->circcounter)
		return 0;
	int len=count();
	PairP np;

	FloatArrayP floatarray = new FloatArray(len, origin);
	if (!floatarray)
		return FloatArrayP(Unbound);
	doubleP d = floatarray->data();

	for (np=this;  np;  next(np))	// copy the pointers from the list to the new array
	{	if (np->circcounter()==th->circcounter)
			break;
		else
			np->setcirccounter(th->circcounter);
		NodeP h=np->first();
		switch (type_of(np->first()))
		{	case INT_:	*d++ =   IntP(h)->int_;		break;
			case FLOAT_:*d++ = FloatP(h)->float_;	break;
			case NINT16: *d++ = Int16P(h)->int_;		break;
			case NINT8:	*d++ =  Int8P(h)->int_;		break;
			case STRING:if (h->numberP())
								*d++ = h->getnumber();
							else
							{	error(BAD_DATA, this); return FloatArrayP(Unbound);
							}	
							break;
			default:
				error(BAD_DATA, this);	return FloatArrayP(Unbound);
		}
	}
	th->setcirccounter(th->circcounter+1);
	return floatarray;
}

TableP Pair::table() 
{
	ThreadP th=Thread::This();
	if (circcounter()==th->circcounter)
		return 0;
	int len=count();
	PairP np;
	if (len & 1)
	{	error(BAD_DATA, this); return TableP(Unbound);
	}
	TableP table = new Table(len);
	if throwing return TableP(Unbound);

	for (np=this;  np;  next(np))	// copy the pointers from the list to the new array
	{	if (np->circcounter()==th->circcounter)
			break;
		else
			np->setcirccounter(th->circcounter);
		StringP f=np->first()->string();
//		f=String::make(f->ptr(), 0, f->length(), 
//			STRING, String::copy_decode); 
		f=String::make(f->ptr(), 0, f->length(), 
			STRING, String::copy); 
		if throwing return TableP(Unbound);
		ObjectP obj=table->find(f);
		if (!obj)
			obj=table->insert(f, THIS_FILE, __LINE__);
		next(np);
		obj->setvar(np->first());
	}
	th->setcirccounter(th->circcounter+1);
	return table;
}

bool Pair::circular2() 
{
	ThreadP th=Thread::This();
	PairP list = this;

	while (list) 
	{	if (list->circcounter()==th->circcounter)
		{	th->setcirccounter(th->circcounter+1);
			return true;
		}else
			list->setcirccounter(th->circcounter);
		if (list->first() && list->first()->circular2()) 
			return true;
		if throwing return false;

		next(list);
	}
	th->setcirccounter(th->circcounter+1);
	return false;
}

int Pair::depth()
{
	PairP l=this;
	int d=0;
	while (l && l->first() && l->first()->is.list)
	{	d++;
		l=l->first();
	}
	return d;
}

PairP Pair::append(NodeP tailnode)	// nondestructive append (slow!)
{
	if (!this) return PairP(tailnode);
//	return new Line
//		(	first(), 
//			tail()->append(tailnode)
//		);
	ThreadP th=Thread::This();
	if (circcounter()==th->circcounter)
		return 0;
	PairP lst=this, val=0, lastnode=0, tnode=0;
	while (lst) 
	{	if (lst->circcounter()==th->circcounter)
			break;
		else
			lst->setcirccounter(th->circcounter);
//wxASSERT(!(th->row==11 && lst->first() && lst->first()->is.line && LineP(lst->first())->row==17));
		if (lst->is.line)
		{	LineP l=LineP(lst);
			th->col=l->col;
			th->tcol=l->tcol;
			th->row=l->row;
			th->setfilename(l->filename());
		}
		tnode = new Line(lst->first(), 0);
		if (!val) 
			val=tnode;
		else 
			lastnode->settail(tnode);
		lastnode=tnode;
		next(lst);
		if (checkThrowing()) break;
	}
	lastnode->settail(tailnode);
	th->setcirccounter(th->circcounter+1);
	return val;
}

PairP Pair::reverse_destruct()	// reverse a list destructively 
{
	ThreadP th=Thread::This();
	if (this && circcounter()==th->circcounter)
		return 0;
	PairP list=this, ret=0, temp;
	while (list)
	{	if (list->circcounter()==th->circcounter)
			break;
		else
			list->setcirccounter(th->circcounter);
		temp=list;
		next(list);
		temp->settail( ret );
		ret=temp;
	}
	th->setcirccounter(th->circcounter+1);
	return ret;
}

PairP Pair::sentence(NodeP nd)
{
	ThreadP th=Thread::This();
	if (this && circcounter()==th->circcounter)
		return this;
	PairP val=0, tnode=0, lastnode=0;
	NodeP thing=this;

	if (thing->islist()) 
	{	for (PairP lst=PairP(thing);  lst && !throwing;  next(lst))
		{
			if (lst->circcounter()==th->circcounter)
				break;
			else
				lst->setcirccounter(th->circcounter);
			tnode = new Pair(lst->first(), 0);
			if (!val) 
				val=tnode;
			else 
				lastnode->settail( tnode );
			lastnode=tnode;
		}
	}else 
	{	tnode=new Pair(thing, 0);
		if (!val) 
			val=tnode;
		else 
			lastnode->settail( tnode );
		lastnode=tnode;
	}
	thing=nd;
	if (thing->islist()) 
	{	for (PairP lst=PairP(thing);  lst && !throwing;  next(lst))
		{
			if (lst->circcounter()==th->circcounter)
				break;
			else
				lst->setcirccounter(th->circcounter);
			tnode = new Pair(lst->first(), 0);
			if (!val) 
				val=tnode;
			else 
				lastnode->settail( tnode );
			lastnode=tnode;
		}
	}else 
	{	tnode=new Pair(thing, 0);
		if (!val) 
			val=tnode;
		else 
			lastnode->settail( tnode );
		lastnode=tnode;
	}
	th->setcirccounter(th->circcounter+1);
	return val;
}

PairP Pair::merge(PairP b) 
{
	ThreadP th=Thread::This();
//	if (this && circcounter()==th->circcounter)
//		return this;
	if (!this) return b;
	if (!b) return this;

	PairP ret=0, tnode=0, a=this;

	if (!a->first()) 
	{	error(BAD_DATA, this); return PairP(Unbound);
	}
	if (a->first()->compare(b->first()) < 0) 
	{	ret=a;	tnode=a;	next(a);
	}else 
	{	ret=b;	tnode=b;	next(b);
	}
	while (a  &&  b)
	{
//		if (a->circcounter()==th->circcounter)
//			break;
//		else
//			a->setcirccounter(th->circcounter);
//		if (b->circcounter()==th->circcounter)
//			break;
//		else
//			b->setcirccounter(th->circcounter);
		if (!a->first()) 
		{	error(BAD_DATA, this); return PairP(Unbound);
		}
		if (a->first()->compare(b->first()) < 0) 
		{	tnode->settail(a);	next(a);
		}else 
		{	tnode->settail(b);	next(b);
		}
		next(tnode);
	}
	if (a)
		tnode->settail(a);
	else
		tnode->settail(b);

//	th->setcirccounter(th->circcounter+1);
	return ret;
}

void Pair::mergePairs() 
{
	ThreadP th=Thread::This();
	if (this && circcounter()==th->circcounter)
		return;
	PairP nd=this;
	while (nd)
	{	if (nd->circcounter()==th->circcounter)
			break;
		else
			nd->setcirccounter(th->circcounter);
		if (!nd->tail()) break;
		nd->setfirst( nd->first()->merge(nd->second()) );
		nd->settail( nd->tail()->tail() );
		next(nd);
	}
	th->setcirccounter(th->circcounter+1);
}

void Pair::toListList() 
{
	ThreadP th=Thread::This();
	if (this && circcounter()==th->circcounter)
		return;
	PairP nd=this;
	while (nd && !throwing) 
	{	if (nd->circcounter()==th->circcounter)
			break;
		else
			nd->setcirccounter(th->circcounter);
		nd->setfirst( new Pair(nd->first(), 0) );
		next(nd);
	}
	th->setcirccounter(th->circcounter+1);
}

PairP Pair::mergeSort()
{
	ThreadP th=Thread::This();
	if (this && circcounter()==th->circcounter)
		return this;
	if (!this) return 0;
	if (!tail()) return this;
	toListList();
	while (tail())
		mergePairs();
	th->setcirccounter(th->circcounter+1);
	return first();
}

void Pair::mergeSortInPlace(int halflength)
{
	if (!this) return;
	if (!tail()) return;
	if (!halflength)
	{	int c=count();
		halflength=(c+1)>>1;
	}
	if (halflength==0)
		;
	else
	{	PairP lst=this;
		for (int i=halflength-1; i > 0; i--)
			next(lst);
		PairP lst2=lst->tail();
		if (halflength>1)
			mergeSortInPlace((halflength+1)>>1);
		lst2->mergeSortInPlace((halflength+1)>>1);
		lst=this;
		PairP ret=this;
		int i=(halflength<<1);
		while (lst && lst2 && i>0)
		{	if (!lst->first() || lst->first()->compare(lst2->first()) < 0)
			{	NodeP nd=lst->first();
				lst->setfirst(lst2->first());
				lst2->setfirst(nd);
				next(lst);
			}else
			{	NodeP nd=lst->first();
				lst->setfirst(lst2->first());
				lst2->setfirst(nd);
				next(lst2);
			}
			i--;
			next(ret);
		}
/*		if (lst) 
		{	ret->setfirst(lst->first());
			next(ret);
		}
		if (lst2) 
			ret->setfirst(lst2->first());
*/
	}
}

#pragma optimize("",off)
NodeP Pair::combSort()
{
	ArrayP a=0;
	a=array();
	if throwing return Unbound;
	a->combSortInPlace();
	return a->list();
}
#pragma optimize("",on)

PairP Pair::one_list() 
{
	if (islist())
		return this;
	else
		return new Pair(this, 0);
}

void Pair::three_lists(PairP &proclist, PairP &varlist, PairP &plistlist) 
{
	if (this)
		if (!is.list)
			proclist = one_list();
		else if (first()->isnolist())
			proclist = this;
		else
		{	proclist = first();
			if (tail()) 
			{	varlist = second()->one_list();
				if (tail()->tail()) 
				{	plistlist = third()->one_list();
					if (tail()->tail()->tail()) 
						error(BAD_DATA_UNREC, this);
				}
			}
		}

	if ( proclist->isnolist()
	||   varlist  ->isnolist()
	||   plistlist->isnolist() )
	{	error(BAD_DATA_UNREC, this);
		plistlist = varlist = proclist = NIL;
	}
}

bool Pair::all_lists()
{
	if (!this) 
		return true;

	if (first()->isnolist()) 
		return false;

	return tail()->all_lists();
}

void Pair::setflag(ObjectType flag)
{
	ThreadP th=Thread::This();
	if (this && circcounter()==th->circcounter)
		return;
	PairP list=this;
	while (list && !throwing) 
	{	if (list->circcounter()==th->circcounter)
			break;
		else
			list->setcirccounter(th->circcounter);
		if (list->first()->is.aggregate) 
		{	error(BAD_DATA_UNREC, list->first());
			break;
		}
		ObjectP obj=list->first()->intern();
		if (!th->varStack->setflag(obj, flag))
			obj->setflag(flag);
		next(list);
		if (checkThrowing()) break;
	}
	th->setcirccounter(th->circcounter+1);
}

void Pair::clearflag(ObjectType flag)
{
	ThreadP th=Thread::This();
	if (this && circcounter()==th->circcounter)
		return;
	PairP list=this;
	while (list && !throwing) 
	{	if (list->circcounter()==th->circcounter)
			break;
		else
			list->setcirccounter(th->circcounter);
		if (list->first()->is.aggregate) 
		{	error(BAD_DATA_UNREC, list->first());
			break;
		}
		ObjectP obj=list->first()->intern();
		if (!th->varStack->clearflag(obj, flag))
			obj->clearflag(flag);
		next(list);
		if (checkThrowing()) break;
	}
	th->setcirccounter(th->circcounter+1);
}

NodeP Pair::bury(ObjectType flag) 
{
	PairP proclist=0, varlist=0, plistlist=0;
	three_lists(proclist, varlist, plistlist);

	proclist->setflag(ObjectType(flag & PROCS));
	varlist->setflag(ObjectType(flag & VALS));
	plistlist->setflag(ObjectType(flag & TABLES));
	return Unbound;
}

NodeP Pair::unBury(ObjectType flag) 
{
	PairP proclist=0, varlist=0, plistlist=0;
	three_lists(proclist, varlist, plistlist);

	proclist->clearflag(ObjectType(flag & PROCS));
	varlist->clearflag(ObjectType(flag & VALS));
	plistlist->clearflag(ObjectType(flag & TABLES));
	return Unbound;
}

double Pair::_min(double d)
{	ThreadP th=Thread::This();
	if (this && circcounter()==th->circcounter)
		return 0;
	PairP list=this;
	int i=1;
	while (list)
	{	if (list->circcounter()==th->circcounter)
			break;
		else
			list->setcirccounter(th->circcounter);
		double dnew = list->first()->_min(d);
		if (dnew!=d)
		{	d=dnew;
			th->minimumPosition=i;
		}
		i++;
		next(list);
	}
	th->setcirccounter(th->circcounter+1);
	return d;
}

double Pair::_max(double d)
{	ThreadP th=Thread::This();
	if (this && circcounter()==th->circcounter)
		return 0;
	PairP list=this;
	int i=1;
	while (list)
	{	if (list->circcounter()==th->circcounter)
			break;
		else
			list->setcirccounter(th->circcounter);
		double dnew = list->first()->_max(d);
		if (dnew!=d)
		{	d=dnew;
			th->maximumPosition=i;
		}
		i++;
		next(list);
	}
	th->setcirccounter(th->circcounter+1);
	return d;
}

NodeP Pair::Norm()
{	ThreadP th=Thread::This();
	if (this && circcounter()==th->circcounter)
		return 0;
	double d=0;
	PairP lst=this, result=0, lastnode=0, tnode=0;
	if (first() && first()->is.aggregate)
	{	while (lst) 
		{	if (lst->circcounter()==th->circcounter)
				break;
			else
				lst->setcirccounter(th->circcounter);
			NodeP fst=lst->first();
			if (fst)
				tnode = new Pair(fst->Norm(), 0);
			else
				tnode=new Pair(0,0);
			if (result) 
				lastnode->settail( tnode );
			else 
				result=tnode;
			lastnode=tnode;
			next(lst);
			if (checkThrowing()) break;
		}
		th->setcirccounter(th->circcounter+1);
		return result;
	}else
	{	while (lst)
		{	if (lst->circcounter()==th->circcounter)
				break;
			else
				lst->setcirccounter(th->circcounter);
			double h = lst->first()->Norm()->getnumber();
			if (throwing) 
				return Unbound;
			d+= h*h;
			next(lst);
		}
		th->setcirccounter(th->circcounter+1);
		return new Float(::sqrt(d));
	}
}

NodeP Pair::maxNorm()
{	ThreadP th=Thread::This();
	if (this && circcounter()==th->circcounter)
		return 0;
	double d=0;
	PairP lst=this, result=0, lastnode=0, tnode=0;
	if (first() && first()->is.aggregate)
	{	while (lst) 
		{	if (lst->circcounter()==th->circcounter)
				break;
			else
				lst->setcirccounter(th->circcounter);
			NodeP fst=lst->first();
			if (fst)
				tnode = new Pair(fst->maxNorm(), 0);
			else
				tnode=new Pair(0,0);
			if (result) 
				lastnode->settail( tnode );
			else 
				result=tnode;
			lastnode=tnode;
			next(lst);
			if (checkThrowing()) break;
		}
		th->setcirccounter(th->circcounter+1);
		return result;
	}else
	{	while (lst)
		{	if (lst->circcounter()==th->circcounter)
				break;
			else
				lst->setcirccounter(th->circcounter);
			double h = lst->first()->maxNorm()->getnumber();
			if (throwing) return Unbound;
			double ha=Float::abs(h);	
			if (ha > d) d = ha;
			next(lst);
		}
		th->setcirccounter(th->circcounter+1);
		return new Float(d);
	}
}

NodeP Pair::procType(int wanted) 
{
	NodeP cell,  arg = a_name(1);
	if throwing return Unbound;
	if ((cell = arg->intern()->proc_or_prim())==Unbound)
		return _False;
	
	if (wanted==2) 
		return boolnode( arg->intern()->bit.proc_macro );

	int isprim = cell->is.primitive;
	if (!throwing) 
		return boolnode(isprim==wanted);

	return Unbound;
}

void Pair::untreeify() 
{
	ThreadP th=Thread::This();
	if (this && circcounter()==th->circcounter)
		return;
	PairP l=this;
	while (l)
	{	if (l->circcounter()==th->circcounter)
			break;
		else
			l->setcirccounter(th->circcounter);
		if (l->first())
			l->first()->untreeify();
		next(l);
	}
	th->setcirccounter(th->circcounter+1);
}

void Pair::eval_driver()		// Evaluate a line of input. 
{
	Evaluator(PairP(this), __begin_line, Thread::This());
}

NodeP Pair::err_eval_driver()	  // Evaluate a sequence of expressions 
{								// until we get a value to return (Called from erract)
	Thread::This()->val_status = value_maybe_ok_in_macro; 
	return Evaluator(PairP(this), __begin_sequence, Thread::This()).val;
}

void Pair::runstartup() 
{
	ThreadP th=Thread::This();

	if (this &&  islist()) 
	{	th->val_status = no_value_allowed;
		eval_driver();
	}
	else if (this && type==OBJECT) 
	{	th->val_status = no_value_allowed;
		PairP inst=new Pair(ObjectP(this), 0);
		if throwing return;
		inst->eval_driver();
	}
}
