#ifndef Node_included
	#include "Node.h"
#endif

#ifndef Pair_included

enum ObjectType;

class Pair: public Node		// is a pair of Pointers to Pair.
{
	public:
		PairP _tail, _first;
		int _circcounter;
		union {ObjectType flag; ObjectBits bit; int tint;};

		static int maxStringLength;
		static const Pair aPair;
		operator_new;

		PairP tail()   {return _tail;}
		PairP first()  {return _first;}
		PairP second() {return tail()->first();}
		PairP third()  {return tail()->tail()->first();}
		PairP fourth() {return tail()->tail()->tail()->first();}
		PairP fifth()  {return tail()->tail()->tail()->tail()->first();}
		PairP sixth()  {return tail()->tail()->tail()->tail()->tail()->first();}
		int  circcounter() {return _circcounter;}

		void settail  (NodeP nd) { _tail = PairP(nd);  check_oldyoung(nd);}
		void setfirst (NodeP nd) {_first = PairP(nd);  check_oldyoung(nd);}

		void setsecond(NodeP nd) {tail()->setfirst(nd);}
		void setthird (NodeP nd) {tail()->tail()->setfirst(nd);}
		void setfourth(NodeP nd) {tail()->tail()->tail()->setfirst(nd);}
		void setfifth (NodeP nd) {tail()->tail()->tail()->tail()->setfirst(nd);}
		void setcirccounter(int ccnt) {_circcounter=ccnt;}

		Pair(): Node(PAIR), _tail(0), _first(0),
			_circcounter(0), flag(ObjectType(0))
		{}

		Pair(NodeP first_, NodeP tail_): 
			Node(PAIR), _circcounter(0), flag(ObjectType(0)) 
		{	setfirst(first_); settail(tail_);
		}

		Pair(NodeP first_, NodeP tail_, NodeType type_): 
			Node(type_), _circcounter(0), flag(ObjectType(0)) 
		{	setfirst(first_); settail(tail_);
		}

		Pair(charP str);

		void inc_gc() {fifo << first() << tail();}
		int youngs() {return gmark(first())+gmark(tail());}
		int youngsPtr(PtrToInt_ &ptrToInt) 
		{	return 
				gmarkPtr(first(), ptrToInt)
				+gmarkPtr(tail(), ptrToInt);
		}
		void check_oldyoungs() {check_oldyoung(first()); check_oldyoung(tail());}
		
		void setPtrs(IntToPtr_ &intToPtr);
		DataInputStream &read(DataInputStream &istr);
		wxDataOutputStream &write(wxDataOutputStream &ostr);

		NodeP copy(PtrToInt_ &ptrToInt);

		StringP string();
		void print(FILEP strm, int &width, int depth, int noBrackets=0, int noSpacers=0);
		void printBin(FILEP strm);
		NodeP contentsTree(	wxArrayString &namearr, 
									wxArrayString &valarr, 
									wxArrayPtrVoid &objarr, 
									ObjectType want, 
									ObjectType dont, 
									ObjectType must, 
									int &count, int level);
		bool expanded() {return bit.table_expand;}
		bool expandable() {return true;}
		void setExpanded(bool state);

		OPERATORS_DECL
		NodeP compare(NodeP nd);
		int count();
		int _sizeof();
		StringP _typeof();
		bool equalP(NodeP b);
		NodeP deepCopy();
		NodeP deepCopyLine();
		NodeP first_();
		NodeP butFirst();
		NodeP firsts();
		NodeP butFirsts();
		NodeP last();
		NodeP butLast();
		NodeP fPut(NodeP nd);
		NodeP lPut(NodeP nd);
		NodeP item(int index);
		NodeP item(NodeP index, NodeP result);
		NodeP mdItem(NodeP index);
		NodeP setitem(NodeP index, NodeP newitem, bool safe);
		NodeP memberP(NodeP subobj, bool notp=false, bool substr=false);
		void removeitem(NodeP index);
		NodeP reverse();
		NodeP remove(NodeP thing);
		NodeP destructiveRemove(NodeP thing);
		NodeP remdup();
		NodeP upper();
		NodeP lower();
		PairP list() {return this;}
		ArrayP array(int origin=1);
		IntArrayP intarray(int origin=1);
		Int16ArrayP int16array(int origin=1);
		FloatArrayP floatarray(int origin=1);
		TableP table();
		NodeP combSort();
		void untreeify();
		bool circular2();
		GRAPHIC_DECL

		int depth();
		PairP append(NodeP tailnode);	// nondestructive append (slow!)
		PairP reverse_destruct();	// reverse a list destructively 
		PairP sentence(NodeP nd);

		PairP merge(PairP b);
		void mergePairs();
		void toListList();
		PairP mergeSort();
		void mergeSortInPlace(int halflength=0);

		PairP one_list();
		void three_lists(PairP &proclist, PairP &varlist, PairP &plistlist);
		bool all_lists();		// check if all elements of the list are lists

		void   setflag(ObjectType flag);
		void clearflag(ObjectType flag);
		NodeP     bury(ObjectType flag);
		NodeP   unBury(ObjectType flag);

		double _min(double d);
		double _max(double d);
		NodeP Norm();
		NodeP maxNorm();

		NodeP open_file_helper(charP mode);

		LineP runparse(bool deep=false);
		void make_runparse(bool deep=false);
		void makeTree(bool deep=false); // Treeify a list of tokens (runparsed or not).
		void makeTreeFromBody(bool deep=false); // Treeify a body by appending the trees of the lines.

		NodeP to_helper(bool macro_flag);

		NodeP procType(int wanted);
		NodeP printOut(int just_titles);	// >0 for _printOutTitles, <0 for _edit

		void eval_driver();	// Evaluate a line of input. 
		NodeP err_eval_driver();	// Evaluate a sequence of expressions 	
									// until we get a value to return (Called from erract)
		void runstartup();

		PairP getProperty(StringP name, bool before);

		friend class GC_;
};

#define Pair_included
#endif
