#ifndef Node_included
	#include "Node.h"
#endif

#ifndef Primitive_included

struct PrimType
{	charP name;
	char min, std, max;
	Priority priority;
	FunctionP function;
};

class Primitive: public Node		// is a function having a Priority and argument numbers
{
	FunctionP _function;

	public:
		Priority _priority;
		char min, std, max;

		static const Primitive aPrimitive;
		static const char ok_if_no_arg;
		static PrimType primitives[];

		operator_new;
		Primitive(): _function(0), _priority(priority_STOP) {}
		Primitive(NodeType type): Node(type), _function(0), _priority(priority_STOP) {}
		Primitive(PrimType &prim);

		Priority priority() {return _priority;}
		void setpriority (Priority pri) {_priority=pri;}

		DataInputStream &read(DataInputStream &istr);
		wxDataOutputStream &write(wxDataOutputStream &ostr);

		NodeP copy(PtrToInt_ &ptrToInt);

		FunctionP function() {return _function;}

		void print(FILEP strm, int &width, int depth, int noBrackets=0, int noSpacers=0);
		void printBin(FILEP strm);

		StringP _typeof();
		LineP gather_args(LinePP args, bool inparen, 
			int oldPriority, ObjectPP ifnode);
		NodeP call(PairPP asp) {return (*_function)(asp);}

		static void init(PrimType primitives[], bool caseIgnored);
};

#define Primitive_included
#endif
