#ifndef Node_included
	#include "Node.h"
#endif

class Procedure: public Node
{
	PairP _formals, _bodylist, _bodywords;
	CompiledP _compiled;
	ObjectP _object;

	public:
		Priority _priority;
		char min, std, max;
		union {ObjectType flag; ObjectBits bit; int tint;};

		static const Procedure aProcedure;

		operator_new;
		Procedure() { }
		Procedure(PairP formals_, PairP bodylist_, PairP bodywords_, 
				ObjectP object_, 
				Priority priority_, char min_, char std_, char max_, NodeType type_);

		PairP formals()  {return _formals;}
		PairP bodylist() {return _bodylist;}
		PairP bodywords(){return _bodywords;}
		CompiledP compiled() {return _compiled;}
		ObjectP object() {return _object;}
		Priority priority() {return _priority;}

		void setformals  (PairP nd) { _formals =nd;  check_oldyoung(nd);}
		void setbodylist (PairP nd) {_bodylist =nd;  check_oldyoung(nd);}
		void setbodywords(PairP nd) {_bodywords=nd;  check_oldyoung(nd);}
		void setcompiled (CompiledP nd);
		void setpriority (Priority pri) {_priority=pri;}

		void inc_gc();
		int youngs();
		int youngsPtr(PtrToInt_ &ptrToInt);
		void check_oldyoungs();

		void setPtrs(IntToPtr_ &intToPtr);
		DataInputStream &read(DataInputStream &istr);
		wxDataOutputStream &write(wxDataOutputStream &ostr);

		NodeP copy(PtrToInt_ &ptrToInt);
		void print(FILEP strm, int &width, int depth, int noBrackets=0, int noSpacers=0);
		void printBin(FILEP strm);

		NodeP contentsTree(	wxArrayString &namearr, 
									wxArrayString &valarr, 
									wxArrayPtrVoid &objarr, 
									ObjectType want, 
									ObjectType dont, 
									ObjectType must, 
									int &count, int level);
		bool expanded() {return bit.table_expand;}
		bool expandable() {return true;}
		void setExpanded(bool state) {bit.table_expand=state;}

		NodeP compare(NodeP nd);
		int count();
		int _sizeof();
		StringP _typeof();
		bool equalP(NodeP b);
		NodeP first_();
		NodeP butFirst();
		NodeP last();
		NodeP butLast();
		PairP list();

//		void untreeify();
		PairP get_bodywords(NodeP name);

		LineP gather_args(LinePP args, bool inparen, 
			int oldPriority, ObjectPP ifnode);

		static LineP gather_some_args(
			int min, int max, LinePP args, bool inparen, 
			int oldPriority, ObjectPP ifnode);
};

#define Procedure_included
