#include "stdafx.h"
#include <malloc.h>

#ifdef WIN32
	#include <crtdbg.h>
#endif

#include <wx/datstrm.h>
#include <wx/thread.h>

#include "Main.h"
#include "File.h"
#include "PtrToInt_.h"
#include "IntToPtr_.h"
#include "String.h"
#include "Object.h"
#include "PtrTable.h"
#include "Init.h"
#include "Error.h"
#include "Thread.h"
#include "Security.h"

#ifdef _DEBUG
	#undef THIS_FILE
	static char THIS_FILE[]= __FILE__;
	#define new new(_NORMAL_BLOCK, THIS_FILE, __LINE__)
	#define  calloc(n, m)	 _calloc_dbg((n), (m),   _NORMAL_BLOCK, __FILE__, __LINE__)
#endif

PtrTable::PtrTable(int size_): 
	Table(size_)
{	type=PTRTABLE;
}

PtrTable::~PtrTable() 
{	free();
}

void PtrTable::free() 
{	Table::free();
}

int PtrTable::hash(NodeP nd)
{
	unsigned int index=(unsigned int)nd;
	index %= size;
	return index;
}

ObjectP PtrTable::find(NodeP nd) 
{
	ObjectP obj;
	for (obj=base[hash(nd)];  obj;  next(obj))
		if (nd==obj->name())
			break;

	return obj;
}

ObjectP PtrTable::insert(NodeP nd)
{
	ObjectPP obj=&base[hash(nd)];
	*obj = new Object(StringP(nd), *obj);
	check_oldyoung(*obj);
	return *obj;
}

NodeP PtrTable::item(NodeP index)
{	ObjectP obj=find(index);
	if (!obj)
		return 0;
	return obj->var();
}

NodeP PtrTable::setitem(NodeP index, NodeP newitem)
{	ObjectP obj=find(index);
	if (!obj)
		obj=insert(index);
	obj->setvar(newitem);
	return Unbound;
}

void PtrTable::removeitem(NodeP index)
{	int i=hash(index);
	ObjectP obj=base[i], last=0;
	while (obj)
	{	if (index==obj->name())
			break;
		last=obj;
		next(obj);
	}
	if (!obj)
	{	error(BAD_DATA, index);
		return;
	}
	if (!last)
	{	base[i]=obj->tail();
	}
	else
		last->settail(obj->tail());
}

