//___________________________________________________________________
//
//                         Class PtrToInt_
//
//                           Definitions
//___________________________________________________________________

#include "stdafx.h"
#ifdef WIN32
	#include <crtdbg.h>
#endif

#include <stdio.h>
#include <malloc.h>

#include <wx/datstrm.h>

#include "Main.h"
#include "Node.h"
#include "Error.h"
#include "PtrToInt_.h"

#ifdef _DEBUG
	#undef THIS_FILE
	static char THIS_FILE[]= __FILE__;
	#define new new(_NORMAL_BLOCK, THIS_FILE, __LINE__)

	#define  calloc(n, m)	 _calloc_dbg((n), (m),   _NORMAL_BLOCK, __FILE__, __LINE__)
#endif

PtrToInt_::PtrToInt_(int size_):
	size(0), nr(0), start(0), last(0)
{
	data = (PtrIntPairP*)(GC_::calloc(size_, sizeof(PtrIntPairP)));
	if (data)
		size=size_;
}

PtrToInt_::~PtrToInt_()
{
	for (int i=0; i < size; i++)
	{	if (data[i])
			delete data[i];
	}
	if (data)
	{	GC_::free(data); data=0;
	}
}

int PtrToInt_::hash(void *p)
{
	unsigned int index = (unsigned int)p;
	if (size)
		index %= size;
	else
		index=0;
	return index;
}

int PtrToInt_::find(void *p)
{
	PtrIntPairP obj;
	for (obj=data[hash(p)];  obj;  obj=obj->tail)
		if (obj->p==p)
			return obj->i;
	return 0;
}

void PtrToInt_::insert(void *p)
{
	nr++;
	PtrIntPairP &obj=data[hash(p)];
	obj = new PtrIntPair(p, nr, obj);
	if (!obj)
		error(OUT_OF_MEM);
}

void PtrToInt_::insertNode(NodeP p)
{
/*	switch (p->type)
	{
	case UNBOUND:
	case STRING:
	case BACKSLASHED:
	case VBAR_STRING:
	case INT_:
	case FLOAT_:
	case COMPLEX:
	case NDINT16:
	case NDINT8:
	case NDUINT8:
	case QUOTE:
	case COLON:
	case OBJECT:
	case PAIR:
	case LINE:
	case RUNPARSED:
	case TREE:
	case TODO:
	case FILE_:
	case PROC_:
	case COMPILED:
	case ARRAY:
	case BITMAP_:
	case TEXTURE:
	case TURTLE_:
	case TABLE:
	case STRUCT:
	case GRAPHIC:
	case DYNAMIC_LIB:
	case INTARRAY:
	case INT16ARRAY:
	case INT8ARRAY:
	case UINT8ARRAY:
	case FLOATARRAY:
	case COMPLEXARRAY:
	case PRIM:
	case MACRO:
	case TAILFORM:
	case INFIX:
	{
*/		nr++;
		PtrIntPairP &obj=data[hash(p)];
		obj = new PtrIntPair(p, nr, obj);
		if (!obj)
		{	error(OUT_OF_MEM); return;
		}
		if (!start)
			start=obj;
		else
			last->nxt=obj;
		last=obj;
/*		break;
	}
	default: 
		nr=nr;
	}
*/
}

wxDataOutputStream &PtrToInt_::writeNodes(wxDataOutputStream &ostr)
{
	PtrIntPairP obj=start;
	while (obj)
	{	((Node*)obj->p)->write(ostr);
		obj=obj->nxt;
	}
	return ostr;
}
