//___________________________________________________________________
//
//										Shadow.h
//___________________________________________________________________

// plane equation
struct sPlaneEq{
	double a, b, c, d;
};

// structure describing an object's face
struct sPlane{
	unsigned int p[3];
	Point normals[3];
	unsigned int neigh[3];
	sPlaneEq PlaneEq;
	bool visible;
};

class ShadowObject
{
public:
	int nPoints, nPlanes, ptsize, plsize, dptsize, dplsize;
	Point *points, *texs;
	Color *colors;
	sPlane *planes;

	ShadowObject();
	~ShadowObject();

	bool checkPoints(int i);
	bool checkPlanes(int i);
	void clear();

	int read(char *st);

	void setConnectivity();
	void calcPlane(sPlane *plane);
	void draw();

	void castShadows(Point lp, double ldir);
};
