//___________________________________________________________________
//
//                        Class Splitter
//
//                          Definitons
//___________________________________________________________________

#include "stdafx.h"
#ifdef WIN32
	#include <crtdbg.h>
#endif

#include <wx/splitter.h>

#include <math.h>

#include "Splitter.h"

#ifdef _DEBUG
	#undef THIS_FILE
	static char THIS_FILE[]= __FILE__;
	#define new new(_NORMAL_BLOCK, THIS_FILE, __LINE__)
#endif

BEGIN_EVENT_TABLE(Splitter, wxSplitterWindow)

	EVT_SIZE( Splitter::OnSize )
END_EVENT_TABLE()

bool Splitter::OnSashPositionChange(int newSashPosition)
{	
	if (inSetRatio)
		return false;
	if (!GetWindow1() || !GetWindow2()) 
		return false;
	wxSize r, r1, r2;
	r1=GetWindow1()->GetSize();
	r2=GetWindow2()->GetSize();
	r=r1+r2;
	if (GetSplitMode()==wxSPLIT_HORIZONTAL)
	{	if (r.GetHeight() != 0)
		{	ratio=double(newSashPosition //GetSashPosition()
							)/r.GetHeight();
			if (ratio > 1)
				ratio=1;
			if (ratio < 0)
				ratio=0;
		}else 
			ratio=0.5;
	}else
	{	if (r.GetWidth() != 0)
		{	ratio=double(newSashPosition //GetSashPosition()
							)/r.GetWidth();
			if (ratio > 1)
				ratio=1;
			if (ratio < 0)
				ratio=0;
		}else 
			ratio=0.5;
	}
	return true;
}

void Splitter::setRatio(double y)
{
	if (!GetWindow1() || !GetWindow2()) 
		return;
	if (y > 1)
		y=1;
	ratio=y;
	wxSize r, r1, r2;
	r1=GetWindow1()->GetSize();
	r2=GetWindow2()->GetSize();
	r=r1+r2;
	int h;
	if (GetSplitMode()==wxSPLIT_HORIZONTAL)
		h=r.GetHeight();
	else
		h=r.GetWidth();
	inSetRatio=true;
	if (int(h*ratio)==0)
		SetSashPosition(1);
	else
		SetSashPosition(int(h*ratio));
	inSetRatio=false;
}

void Splitter::OnSize(wxSizeEvent& event)
{
	int h;
	if (GetSplitMode()==wxSPLIT_HORIZONTAL)
		h=event.GetSize().GetHeight();
	else
		h=event.GetSize().GetWidth();
	inSetRatio=true;
	if (int(h*ratio)==0)
		SetSashPosition(1);
	else
		SetSashPosition(int(h*ratio));
	inSetRatio=false;
}
