//___________________________________________________________________
//
//                         StaticText Header
//___________________________________________________________________

#ifndef WINDOWNODE
	#include "Window.h"
#endif

extern Function 
	lStaticText, lStaticTextDestroy, 
	lStaticTextLabel, lStaticTextSetLabel,
	lStaticTextSetBackgroundColor, lStaticTextSetColor,
	lStaticTextSetFontSize, lStaticTextSetFontName,
	lStaticTextSetFontStyle, lStaticTextSetFontWeight;

class StaticText: public wxStaticText
{
	public:
		enum Data
		{	WINDOW_DATA,
			dataCount
		};
		NodeP data[dataCount];

		static int vmt;

		virtual NodePP d(int i) {return &data[i];}

		StaticText(wxWindow *parent);
		StaticText(StaticTextNodeP staticTextNode_);
		StaticText(StaticTextNodeP staticTextNode_,
			wxWindow* parent, wxWindowID id, 
			const wxString &label, 
			const wxPoint& pos = wxDefaultPosition, 
			const wxSize& size = wxDefaultSize, 
			long style = 0, 
			const wxString& name = _("StaticText"));
		~StaticText();

		void 
			OnClose(wxCloseEvent &event);

		wxString wxstring();
		DataInputStream &read(DataInputStream &istr);
		wxDataOutputStream &write(wxDataOutputStream &ostr);
};
typedef StaticText *StaticTextP;

class StaticTextNode: public WindowNode
{
	public:
		StaticTextP &staticText;

		static const StaticTextNode aStaticTextNode;

		operator_new;

		StaticTextNode();
		StaticTextNode(WindowNodeP parent_);

		void free();

		DataInputStream &read(DataInputStream &istr);
		wxDataOutputStream &write(wxDataOutputStream &ostr);
		void setPtrs(IntToPtr_ &intToPtr);
		void recreate();

		StringP string();
		wxString wxstring();
		void print(FILEP strm, int &width, int depth, int noBrackets=0, int noSpacers=0);
		StringP _typeof();
};
