#ifndef Node_included
	#include "Node.h"
#endif

#ifndef Table_included

class Table: public Node
{
	public:
		bool allocated;
		int size;
		ObjectP *base;
		union {ObjectType flag; ObjectBits bit; int tint;};

		static int maxStringLength;
		static const Table aTable;
		operator_new;

		Table(): Node(TABLE), allocated(false), size(0), base(0) {}
		Table(int size_);
		virtual ~Table();
		void free();

		void inc_gc();
		int youngs();
		int youngsPtr(PtrToInt_ &ptrToInt);
		void check_oldyoungs();

		void setPtrs(IntToPtr_ &intToPtr);
		DataInputStream &read(DataInputStream &istr);
		wxDataOutputStream &write(wxDataOutputStream &ostr);

		NodeP copy(PtrToInt_ &ptrToInt);

		StringP string();
		void print(FILEP strm, int &width, int depth, int noBrackets=0, int noSpacers=0);
		void printBin(FILEP strm);
		NodeP contentsTree(	wxArrayString &namearr, 
									wxArrayString &valarr, 
									wxArrayPtrVoid &objarr, 
									ObjectType want, 
									ObjectType dont,
									ObjectType must, 
									int &count, int level);
		bool expanded() {return bit.table_expand;}
		bool expandable() {return true;}
		void setExpanded(bool state) {bit.table_expand=state;}

		void mark();
		void mark_all_but_objects();
		void clean();

		int count();
		int _sizeof();
		StringP _typeof();
		NodeP item(NodeP index, NodeP result);
		NodeP setitem(NodeP index, NodeP newitem, bool safe);
		NodeP memberP(NodeP subobj, bool notp=false, bool substr=false);
		void removeitem(NodeP index);
		NodeP reverse();
		NodeP upper();
		NodeP lower();
		PairP list();

		int hash(StringP str);
		ObjectP operator[](StringP str);
		ObjectP find(StringP str);
		ProcedureP findProc(StringP filename, int linenr);
		ObjectP insert(StringP nd, charP file, int line);

		TableP merge(TableP b);
		PairP objectlist();
		void self_resize(int newsize);

		void setflag(ObjectType want, ObjectType flag);
		void clearflag(ObjectType want, ObjectType flag);

		PairP contents(ObjectType want, ObjectType dont);
		PairP contents(ObjectType obj_type);
		PairP contentsNameVar(ObjectType want);

		NodeP erase_all(bool procs, bool vals, bool plists);
		void makeTree(bool deep);
};
extern TableP root;

	#define Table_included
#endif
