
#include "stdafx.h"

#include <wx/wfstream.h>
#include <wx/txtstrm.h>

#include "Main.h"
#include "Color.h"
#include "TextInputStream.h"

TextInputStream::TextInputStream(wxFileInputStream &s):
wxTextInputStream(s)
{
}

TextInputStream::TextInputStream(wxFFileInputStream &s):
wxTextInputStream(s)
{
}

TextInputStream &TextInputStream::operator>>(wxString& word)
{
	word = ReadWord();
	return *this;
}

TextInputStream &TextInputStream::operator>>(bool &b)
{
    b = (Read8()!=0);
    return *this;
}

TextInputStream &TextInputStream::operator>>(char &c)
{
    c = m_input.GetC();
    if(m_input.LastRead() <= 0) c = 0;
    if (EatEOL(c))
        c = '\n';
    return *this;
}

TextInputStream &TextInputStream::operator>>(wxInt16& i)
{
	i = (wxInt16)Read16();
	return *this;
}

TextInputStream &TextInputStream::operator>>(wxInt32& i)
{
	i = (wxInt32)Read32();
	return *this;
}

TextInputStream &TextInputStream::operator>>(wxUint16& i)
{
	i = Read16();
	return *this;
}

TextInputStream &TextInputStream::operator>>(wxUint32& i)
{
	i = Read32();
	return *this;
}

TextInputStream &TextInputStream::operator>>(Color &c)
{
	int16 r,g,b,a; 
	*this >> r >> g >> b >> a; 
	c.r = r & 0xff;
	c.g = g & 0xff;
	c.b = b & 0xff;
	c.a = a & 0xff;
	return *this;
}

TextInputStream &TextInputStream::operator>>(double& i)
{
	i = ReadDouble();
	return *this;
}

TextInputStream &TextInputStream::operator>>(float& f)
{
	f = (float)ReadDouble();
	return *this;
}

bool TextInputStream::Eof()
{
	return m_input.Eof();
}