
#include "stdafx.h"

#include <wx/wfstream.h>
#include <wx/txtstrm.h>

#include "Main.h"
#include "Color.h"
#include "TextOutputStream.h"

TextOutputStream::TextOutputStream(wxFileOutputStream &fos):
wxTextOutputStream(fos)
{
	formati=wxT("%i");
	formatd=wxT("%g");
}

TextOutputStream::TextOutputStream(wxFFileOutputStream &fos):
wxTextOutputStream(fos)
{
	formati=wxT("%i");
	formatd=wxT("%g");
}

TextOutputStream &TextOutputStream::operator<<(bool b)
{
	Write8((unsigned char)(b));
	return *this;
}

TextOutputStream &TextOutputStream::operator<<(char c)
{
	PutChar(c);
	return *this;
}

TextOutputStream &TextOutputStream::operator<<(int i)
{
	wxString s;
	s.Printf(formati, i);
	WriteString(s);
	return *this;
}

TextOutputStream &TextOutputStream::operator<<(unsigned int u)
{
	wxString s;
	s.Printf(formati, u);
	WriteString(s);
	return *this;
}

TextOutputStream &TextOutputStream::operator<<(Color c)
{
	return *this
		<< int16(c.r) << ' ' 
		<< int16(c.g) << ' ' 
		<< int16(c.b) << ' ' 
		<< int16(c.a) << ' ';
}

TextOutputStream &TextOutputStream::operator<<(double d)
{
	wxString s;
	s.Printf(formatd, d);
	WriteString(s);
	return *this;
}

TextOutputStream &TextOutputStream::operator <<(float f)
{
	wxString s;
	s.Printf(formatd, f);
	WriteString(s);
	return *this;
}

TextOutputStream &TextOutputStream::operator <<(wxString s)
{
	WriteString(s);
	return *this;
}

void TextOutputStream::SetDoubleFormat(wxString format)
{
	formatd=format;
}

void TextOutputStream::SetIntFormat(wxString format)
{
	formati=format;
}
