//___________________________________________________________________
//
//                         ToggleButton Header
//___________________________________________________________________

#ifndef WINDOWNODE
	#include "Window.h"
#endif

extern Function 
	lToggleButton, lToggleButtonDestroy, lToggleButtonOnClick,
	lToggleButtonValue, lToggleButtonSetValue,
	lToggleButtonEnable;

#ifdef WIN32
class ToggleButton: public wxToggleButton
#else
class ToggleButton: public wxCheckBox
#endif
{
	public:
		enum Data
		{	WINDOW_DATA,
			onClick, uonClick, tonClick,
			dataCount
		};
		NodeP data[dataCount];

		static int vmt;

		virtual NodePP d(int i) {return &data[i];}

		ToggleButton(wxWindow *parent);
		ToggleButton(ToggleButtonNodeP buttonNode_);
		ToggleButton(ToggleButtonNodeP buttonNode_,
			wxWindow* parent, wxWindowID id, 
			const wxString &label,
			PairP onClick_=PairP(0),
			const wxPoint& pos = wxDefaultPosition, 
			const wxSize& size = wxDefaultSize, 
			long style = 0, 
			const wxValidator& validator = wxDefaultValidator, 
			const wxString& name = _("ToggleButton"));
		~ToggleButton();

		void 
			OnClose(wxCloseEvent &event),
			OnClick(wxCommandEvent &event);

		wxString wxstring();
		DataInputStream &read(DataInputStream &istr);
		wxDataOutputStream &write(wxDataOutputStream &ostr);

		DECLARE_EVENT_TABLE()
};
typedef ToggleButton *ToggleButtonP;

class ToggleButtonNode: public WindowNode
{
	public:
		ToggleButtonP &toggleButton;
		static const ToggleButtonNode aToggleButtonNode;

		operator_new;
		PairP onClick();
		void setonClick(NodeP function);

		ToggleButtonNode();
		ToggleButtonNode(WindowNodeP parent_);

		void free();

		void inc_gc();
		int youngs();
		int youngsPtr(PtrToInt_ &ptrToInt);
		void check_oldyoungs();
		
		DataInputStream &read(DataInputStream &istr);
		wxDataOutputStream &write(wxDataOutputStream &ostr);
		void setPtrs(IntToPtr_ &intToPtr);
		void recreate();

		StringP string();
		wxString wxstring();
		void print(FILEP strm, int &width, int depth, int noBrackets=0, int noSpacers=0);

		StringP _typeof();
};
