#ifndef Node_included
	#include "Node.h"
#endif

#ifndef UInt8_included

class UInt8: public Node
{
	public: 
		uint8 int_;
		static const uint8 digits;
		static const uint8 max, min;
		static const UInt8 aUInt8;

		operator_new;
		UInt8():       Node(NUINT8), int_(0) {}
		UInt8(unsigned char i): Node(NUINT8), int_(i) {}

		DataInputStream &read(DataInputStream &istr);
		wxDataOutputStream &write(wxDataOutputStream &ostr);

		NodeP copy(PtrToInt_ &ptrToInt);

		StringP string();
		void print(FILEP strm, int &width, int depth, int noBrackets=0, int noSpacers=0);
		void printBin(FILEP strm);

		int   numberP() {return 1;}
		double getnumber() {return int_;}
		 NodeP    number() {return this;}

		OPERATORS_DECL
		NodeP compare(NodeP nd);
		int _sizeof();
		StringP _typeof();
		double _min(double d);
		double _max(double d);
		NodeP Norm();
		NodeP maxNorm();
		NodeP item(NodeP index, NodeP result);
		NodeP bititem(NodeP index);
		NodeP setitem(NodeP index, NodeP newitem, bool safe);
		NodeP memberP(NodeP subobj, bool notp=false, bool substr=false);
		NodeP readbin(FileP file);
		PairP list();

		static unsigned char clip(double d);
		static unsigned char clip(int i);
};

	#define UInt8_included
#endif
