//___________________________________________________________________
//
//                         Window_ Header
//___________________________________________________________________

#ifndef WINDOWNODE

extern Function 
	lWindow, 
	lWindowCenter, 
	lWindowCenterOnParent, 
	lWindowCenterOnScreen, 
	lWindowClearBackground, 
	lWindowClientToScreen,
	lWindowClose,
	lWindowDestroy, 
	lWindowDestroyChildren, 
	lWindowDisable, 
	lWindowEnable, 
	lWindowFindFocus, 
	lWindowFindWindowById, 
	lWindowFindWindowByLabel, 
	lWindowFindWindowByName, 
	lWindowFit, 
	lWindowFitInside, 
	lWindowFreeze,
	lWindowGetBackgroundColor, 
	lWindowGetBackgroundStyle, 
	lWindowGetBestSize, 
	lWindowGetCapture,
	lWindowGetCaret,
	lWindowGetCursor,
	lWindowGetCharHeight,
	lWindowGetCharWidth,
	lWindowGetChildren, 
	lWindowGetClientSize, 
	lWindowGetExtraStyle, 
	lWindowGetFont,
	lWindowGetForegroundColor, 
	lWindowGetGrandParent, 
	lWindowGetHandle, 
	lWindowGetHelpText,
	lWindowGetId,
	lWindowGetLabel,
	lWindowGetMinSize,
	lWindowGetMaxSize,
	lWindowGetName,
	lWindowGetParent,
	lWindowGetPosition,
	lWindowGetRect,
	lWindowGetScreenPosition,
	lWindowGetScreenRect,
	lWindowGetScrollPos,
	lWindowGetScrollRange,
	lWindowGetScrollThumb,
	lWindowGetSize,
	lWindowGetSizer,
	lWindowGetTextExtent,
	lWindowGetToolTip,
	lWindowGetUpdateRegion,
	lWindowGetValidator,
	lWindowGetVirtualSize,
	lWindowGetWindowBorderSize,
	lWindowGetWindowStyle,
	lWindowGetWindowVariant,
	lWindowHasCapture,
	lWindowHasFlag,
	lWindowHasMultiplePages,
	lWindowHasScrollbar,
	lWindowHasTransparentBackground,
	lWindowHide,
	lWindowInheritAttributes,
	lWindowInitDialog,
	lWindowInvalidateBestSize,
	lWindowIsDoubleBuffered,
	lWindowIsEnabled,
	lWindowIsExposed,
	lWindowIsFrozen,
	lWindowIsRetained,
	lWindowIsShown,
	lWindowIsShownOnScreen,
	lWindowIsTopLevel,
	lWindowLayout,
	lWindowLineDown,
	lWindowLineUp,
	lWindowLower,
	lWindowMakeModal,
	lWindowMove,
	lWindowMoveAfterInTabOrder,
	lWindowMoveBeforeInTabOrder,
	lWindowNavigate,
	lWindowOnInternalIdle,
	lWindowPageDown,
	lWindowPageUp,
	lWindowPopEventHandler,
	lWindowPopupMenu,
	lWindowPushEventHandler,
	lWindowRaise,
	lWindowRefresh,
	lWindowRefreshRect,
	lWindowRegisterHotKey,
	lWindowReleaseMouse,
	lWindowRemoveChild,
	lWindowRemoveEventHandler,
	lWindowReparent,
	lWindowScreenToClient,
	lWindowScrollLines,
	lWindowScrollPages,
	lWindowScrollWindow,
	lWindowSetAcceleratorTable,
	lWindowSetAccessible,
	lWindowSetAutoLayout,
	lWindowSetBackgroundColor,
	lWindowSetBackgroundStyle,
	lWindowSetInitialSize,
	lWindowSetCaret,
	lWindowSetClientSize,
	lWindowSetConstraints,
	lWindowSetContainingSizer,
	lWindowSetCursor,
	lWindowSetDropTarget,
	lWindowSetInitialBestSize,
	lWindowSetEventHandler,
	lWindowSetExtraStyle,
	lWindowSetFocus,
	lWindowSetFocusFromKbd,
	lWindowSetFont,
	lWindowSetFontName,
	lWindowSetFontSize, 
	lWindowSetFontStyle, 
	lWindowSetFontWeight,
	lWindowSetForegroundColor,
	lWindowSetHelpText,
	lWindowSetId,
	lWindowSetLabel,
	lWindowSetMaxSize,
	lWindowSetMinSize,
	lWindowSetName,
	lWindowSetOwnBackgroundColor,
	lWindowSetOwnFontName,
	lWindowSetOwnFontSize,
	lWindowSetOwnFontStyle,
	lWindowSetOwnFontWeight,
	lWindowSetOwnForegroundColor,
	lWindowSetPalette,
	lWindowSetScrollbar,
	lWindowSetScrollPos,
	lWindowSetSize,
	lWindowSetSizeHints,
	lWindowSetSizer,
	lWindowSetSizerAndFit,
	lWindowSetThemeEnabled,
	lWindowSetToolTip,
	lWindowSetValidator,
	lWindowSetVirtualSize,
	lWindowSetVirtualSizeHints,
	lWindowSetWindowStyle,
	lWindowSetWindowStyleFlag,
	lWindowSetWindowVariant,
	lWindowShouldInheritColours,
	lWindowShow,
	lWindowThaw,
	lWindowToggleWindowStyle,
	lWindowTransferDataFromWindow,
	lWindowTransferDataToWindow,
	lWindowUnregisterHotKey,
	lWindowUpdate,
	lWindowUpdateWindowUI,
	lWindowValidate,
	lWindowWarpPointer;

#define WINDOW_EVENTS(x)											\
	x(Close) x(Paint) x(Erase) x(SetFocus) x(KillFocus)	\
	x(Move) x(Size)													\
	x(Char) x(KeyDown) x(KeyUp)									\
	x(LeftDown) x(RightDown) x(MiddleDown)						\
	x(LeftUp) x(RightUp) x(MiddleUp)								\
	x(LeftDClick) x(RightDClick) x(MiddleDClick)				\
	x(Motion) x(MouseWheel) x(EnterWindow) x(LeaveWindow)	\
	x(Mouse)

#define WINDOW_list_lFunction(x)	lWindowOn##x, 

extern Function WINDOW_EVENTS(WINDOW_list_lFunction) lbye;

#define WINDOW_MAKE_DATA_ON(x)	on##x, uon##x, ton##x,

#define WINDOW_MAKE_NODE_ON(x)				\
	virtual PairP on##x();						\
	virtual ObjectP uon##x();					\
	virtual LogoObjectP ton##x();				\
	virtual void seton##x(NodeP function);

#define WINDOW_MAKE_inc_gc(x)		<< on##x() << uon##x() << ton##x() 

#define WINDOW_MAKE_youngs(x)		+gmark(on##x())+gmark(uon##x())+gmark(ton##x())

#define WINDOW_MAKE_youngsPtr(x)	\
	+gmarkPtr(on##x(), ptrToInt)	\
	+gmarkPtr(uon##x(), ptrToInt)	\
	+gmarkPtr(ton##x(), ptrToInt)

#define WINDOW_MAKE_check_oldyoung(x)	\
	check_oldyoung(on##x());				\
	check_oldyoung(uon##x());				\
	check_oldyoung(ton##x());

#define WINDOW_DATA								\
	WINDOW_EVENTS(WINDOW_MAKE_DATA_ON)		\
	boxSizer, windowNode

class Window_: public wxWindow
{
	public:
		ThreadP thread;

		enum Data
		{	WINDOW_DATA,
			dataCount
		};
		NodeP data[dataCount];

		static int vmt;

		virtual NodePP d(int i) {return &data[i];}

		Window_(wxWindow *parent);
		Window_(WindowNodeP windowNode_);
		Window_(WindowNodeP windowNode_,
			wxWindow* parent, wxWindowID id, 
			const wxPoint& pos = wxDefaultPosition, 
			const wxSize& size = wxDefaultSize, 
			long style = wxDEFAULT_FRAME_STYLE, 
			const wxString& name = _("Window_"));
		~Window_();

		virtual void 
			OnPaint			(wxPaintEvent &event),
			OnErase			(wxEraseEvent &event),
			OnSize			(wxSizeEvent &event),
			OnClose			(wxCloseEvent &event),
			OnSetFocus		(wxFocusEvent &event),
			OnKillFocus		(wxFocusEvent &event),
			OnChar			(wxKeyEvent &event),
			OnKeyDown		(wxKeyEvent &event),
			OnKeyUp			(wxKeyEvent &event),
			OnMove			(wxMoveEvent  &event),
			OnLeftDown		(wxMouseEvent &event),
			OnRightDown		(wxMouseEvent &event),
			OnMiddleDown	(wxMouseEvent &event),
			OnLeftUp  		(wxMouseEvent &event),
			OnRightUp  		(wxMouseEvent &event),
			OnMiddleUp  	(wxMouseEvent &event),
			OnLeftDClick	(wxMouseEvent &event),
			OnRightDClick	(wxMouseEvent &event),
			OnMiddleDClick	(wxMouseEvent &event),
			OnMotion			(wxMouseEvent &event),
			OnEnterWindow	(wxMouseEvent &event),
			OnLeaveWindow	(wxMouseEvent &event),
			OnMouseWheel	(wxMouseEvent &event),
			OnMouse			(wxMouseEvent& event);

		virtual wxString wxstring();
		virtual DataInputStream &read(DataInputStream &istr);
		virtual wxDataOutputStream &write(wxDataOutputStream &ostr);

		DECLARE_EVENT_TABLE()
};
typedef Window_ *WindowP;

class WindowNode: public Node
{
	public:
		WindowP window;
		WindowNodeP parent;
		WindowPairP children;
		int style;

		static const WindowNode aWindowNode;

		operator_new;
		WINDOW_EVENTS(WINDOW_MAKE_NODE_ON)

		virtual BoxSizerNodeP boxSizer();
		virtual void setSizer(BoxSizerNodeP boxSizer_);
		virtual void setSizerAndFit(BoxSizerNodeP boxSizer_);

		WindowNode();
		WindowNode(NodeType type_);
		WindowNode(NodeType type_, WindowNodeP parent_);

		virtual void free();

		virtual void inc_gc();
		virtual int youngs();
		virtual int youngsPtr(PtrToInt_ &ptrToInt);
		virtual void check_oldyoungs();
		
		virtual DataInputStream &read(DataInputStream &istr);
		virtual wxDataOutputStream &write(wxDataOutputStream &ostr);
		virtual void setPtrs(IntToPtr_ &intToPtr);
		virtual void aftersetPtrs();
		virtual void recreate();
		virtual void aftersetPtrs3();

		virtual StringP string();
		virtual wxString wxstring();
		virtual void print(FILEP strm, int &width, int depth, int noBrackets=0, int noSpacers=0);
		virtual StringP _typeof();

		virtual void setParent(WindowNodeP Window_);
};

#define WINDOWNODE
#endif
